% -----rbMIT Software Copyright MIT 2006-07-----
% -------------DBP Huynh, NC Nguyen, AT Patera, G Rozza ----------
% The user agrees to rbMIT  MIT usage, distribution, and citation terms and
% conditions described in the License at http://augustine.mit.edu/rbMIT_SystemLicense.htm.
%  rbMIT Software Part II and IV

% Script *PROBNAME_Step2_1_coer_compliant.m: Copyright MIT 2006-07.
% Enter control parameters for the calculation of alpha_LB(mubar).
% First address generation of the sample $\Xi_{train}^\alpha$.
clear pr_PROBDEF pr_OFFLINE pr_ONLINE
load(strcat(probname,'_','pr_OFFLINE'));
assignin('base','pr_OFFLINE',eval(strcat(probname,'_','pr_OFFLINE')));
pr_OFFLINE.coerlb.sample.newflg = 1; % 1 $\Rightarrow$ create new sample $\Xi_{train}^\alpha$; 0 $\Rightarrow$ use existing sample (previously created) $Xi_{train}^\alpha$
pr_OFFLINE.coerlb.sample.densityflg = 0; % 0 $\Rightarrow$ random with uniform density in $\bfmu$; 1 $\Rightarrow$ random with uniform density in $\ln(\bfmu)$ (requires $\mu_{\min} >0$)
pr_OFFLINE.coerlb.sample.size = 3000; % positive integer $n_{train} --- size of $\Xi_{train}^{\alpha}$
% Next provide tolerances.
pr_OFFLINE.coerlb.alpha_tol = 0.850; % positive real tolerance for the stopping criterium (UB-UL)/UB.
pr_OFFLINE.coerlb.Kbarmax = 200; % maximum number of sample points used as constraints
pr_OFFLINE.coerlb.Kloc = 16; % maximum number of sample points used as mu_near constraints (if set to zero Kloc is set with the rule 2^P, P=No. of parameters)
pr_OFFLINE.coerlb.Jloc = 0; % maximum number of positive constraints

pr_OFFLINE.coerlb.restartflg=0;  % =1 for a re-start of greedy SCM, =0 for normal running;
% beyond this line no more user input requested
if (pr_OFFLINE.coerlb.restartflg==0)
    if exist(strcat(probname,'_','pr_ONLINE.mat'))==2
        load(strcat(probname,'_','pr_ONLINE'));
        assignin('base','pr_ONLINE',eval(strcat(probname,'_','pr_ONLINE')));
    else
        pr_ONLINE.coerlb.failedpoints=[];
    end
    pr_OFFLINE.coerlb.failedpoints=[pr_OFFLINE.coerlb.failedpoints; pr_ONLINE.coerlb.failedpoints];
    pr_ONLINE.coerlb = [];
    pr_ONLINE.coerlb.failedpoints=[];
else
    load(strcat(probname,'_','pr_ONLINE'));
    assignin('base','pr_ONLINE',eval(strcat(probname,'_','pr_ONLINE')));
    pr_OFFLINE.coerlb.failedpoints=[pr_OFFLINE.coerlb.failedpoints; pr_ONLINE.coerlb.failedpoints];
    pr_ONLINE.coerlb.failedpoints=[ ];
end
assignin('base',strcat(probname,'_','pr_OFFLINE'),pr_OFFLINE);
save(strcat(probname,'_','pr_OFFLINE'),strcat(probname,'_','pr_OFFLINE')) % save final *PROBNAME_pr_OFFLINE structure inputs to file *PROBNAME_pr_OFFLINE.mat
assignin('base',strcat(probname,'_','pr_ONLINE'),pr_ONLINE);
save(strcat(probname,'_','pr_ONLINE'),strcat(probname,'_','pr_ONLINE')) % save (empty) *PROBNAME_pr_ONLINE structure to file *PROBNAME_pr_ONLINE.mat

%
% Load the problem data required by the Greedy algorithm.
load(strcat(probname,'_','pr_PROBDEF'));
assignin('base','pr_PROBDEF',eval(strcat(probname,'_','pr_PROBDEF')));
load(strcat(probname,'_','pr_ONLINE'));
assignin('base','pr_ONLINE',eval(strcat(probname,'_','pr_ONLINE')));
load(strcat(probname,'_','pr_OFFLINE'));
assignin('base','pr_OFFLINE',eval(strcat(probname,'_','pr_OFFLINE')));
% Call the Greedy SCM routine (which resides in \rbMIT_System\rbMIT_Library).

% addpath('../rbMIT_Library')

[pr_PROBDEF, pr_OFFLINE, pr_ONLINE]=SCM_coer(pr_PROBDEF, pr_OFFLINE, pr_ONLINE, str2func(strcat(probname, '_' , 'InsideOutsideD')), str2func(strcat(probname, '_' , 'Get_Theta_q')));%@Get_Theta_q);


% Display the ``user--readable" outputs of the Greedy SCM algorithm. (Note the Greedy SCMcode produces many ``non--user--readable" OUTs (saved to the pr_OFFLINE and pr_ONLINE structures and
% corresponding .mat files) that are needed for (i) ``Inherited" problem
% creation (see Section 5.4.2), and of course (ii) the Online RB output and
% error bound evaluation s--- Step3 below.
assignin('base',strcat(probname,'_','pr_PROBDEF'),pr_PROBDEF);
save(strcat(probname,'_','pr_PROBDEF'),strcat(probname,'_','pr_PROBDEF')) % save final *PROBNAME_pr_PROBDEF structure inputs to file *PROBNAME_pr_PROBDEF.mat
assignin('base',strcat(probname,'_','pr_OFFLINE'),pr_OFFLINE);
save(strcat(probname,'_','pr_OFFLINE'),strcat(probname,'_','pr_OFFLINE')) % save final *PROBNAME_pr_OFFLINE structure inputs to file *PROBNAME_pr_OFFLINE.mat
assignin('base',strcat(probname,'_','pr_ONLINE'),pr_ONLINE);
save(strcat(probname,'_','pr_ONLINE'),strcat(probname,'_','pr_ONLINE')) % save final *PROBNAME_pr_ONLINE structure inputs to file *PROBNAME_pr_ONLINE.mat
%

