% -----rbMIT Software Copyright MIT 2006-07-----
% -------------DBP Huynh, NC Nguyen, AT Patera, G Rozza ----------
% The user agrees to rbMIT  MIT usage, distribution, and citation terms and
% conditions described in the License at http://augustine.mit.edu/rbMIT_SystemLicense.htm.
%  rbMIT Software Part II and IV coercive problems, non-compliant outputs
% Script *PROBNAME_Step2_2_coer_noncompliant.m: Copyright MIT 2006-07.
%
% Enter control parameters for Greedy^{out,*} generation of primal RB space.
% First address generation of the sample $\Xi_{train}$.
clear pr_PROBDEF pr_OFFLINE pr_ONLINE
load(strcat(probname,'_','pr_OFFLINE'));
assignin('base','pr_OFFLINE',eval(strcat(probname,'_','pr_OFFLINE')));
load(strcat(probname,'_','pr_ONLINE'));
assignin('base','pr_ONLINE',eval(strcat(probname,'_','pr_ONLINE')));
pr_OFFLINE.space.sample.newflg = 1; % 1 $\Rightarrow$ create new sample $\Xi_{train}$; 0 $\Rightarrow$ use existing sample (previously created) $Xi_{train}$
pr_OFFLINE.space.sample.densityflg = 0; % 0 $\Rightarrow$ random with uniform density in $\bfmu$; 1 $\Rightarrow$ random with uniform density in $\ln(\bfmu)$ (requires $\mu_{\min} >0$)
pr_OFFLINE.space.sample.size = 1000; % positive integer $n_{train} --- size of $\Xi_{train}$
% Next provide tolerances.
pr_OFFLINE.space.absrelflg = 1; % 0 $\Rightarrow \omega_N = 1$ (absolute error on greedy); 1 $\Rightarrow \omega_N=u_N (relative error in energy norm for greedy)
pr_OFFLINE.space.tol = 1e-2; % positive real $\varepsilon_{tol,\min}$ --- anticipated smallest desired (absolute or relative) output error
pr_OFFLINE.space.Nbarmax = 120; % positive integer $\overline{N}_{\max}$ --- upper limit on dimension of (largest) RB space


pr_OFFLINE.space.restartflg=0;  % =1 for a re-start of greedy, =0 for normal running;
% beyond this line no more user input requested

if (pr_OFFLINE.space.restartflg==0)
    pr_ONLINE.space = [ ]; % no problem-specific (user) inputs required
else
    load(strcat(probname,'_','pr_ONLINE'));
    assignin('base','pr_ONLINE',eval(strcat(probname,'_','pr_ONLINE')));
end

assignin('base',strcat(probname,'_','pr_OFFLINE'),pr_OFFLINE);
save(strcat(probname,'_','pr_OFFLINE'),strcat(probname,'_','pr_OFFLINE')) % save final *PROBNAME_pr_OFFLINE structure inputs to file *PROBNAME_pr_OFFLINE.mat
assignin('base',strcat(probname,'_','pr_ONLINE'),pr_ONLINE);
save(strcat(probname,'_','pr_ONLINE'),strcat(probname,'_','pr_ONLINE')) % save (empty) *PROBNAME_pr_ONLINE structure to file *PROBNAME_pr_ONLINE.mat

%
% Load the problem data required by the Greedy algorithm.
load(strcat(probname,'_','pr_PROBDEF'));
assignin('base','pr_PROBDEF',eval(strcat(probname,'_','pr_PROBDEF')));
load(strcat(probname,'_','pr_ONLINE'));
assignin('base','pr_ONLINE',eval(strcat(probname,'_','pr_ONLINE')));
load(strcat(probname,'_','pr_OFFLINE'));
assignin('base','pr_OFFLINE',eval(strcat(probname,'_','pr_OFFLINE')));
% Call the Greedy routine (which resides in \rbMIT_System\rbMIT_Library).

% addpath('../rbMIT_Library')
% addpath('../rbMIT_Library/parabolic')

[pr_PROBDEF, pr_OFFLINE, pr_ONLINE] = Greedy_primal_coer_noncompliant(pr_PROBDEF, pr_OFFLINE, pr_ONLINE, str2func(strcat(probname, '_' , 'InsideOutsideD')), str2func(strcat(probname, '_' , 'Get_Theta_q')));


% Display the ``user--readable" outputs of the Greedy algorithm. (Note the Greedy code produces many ``non--user--readable" OUTs (saved to the OFFLINE and ONLINE structures and
% corresponding .mat files) that are needed for (i) ``Inherited" problem
% creation (see Section 5.4.2), and of course (ii) the Online RB output and
% error bound evaluation s--- Step3 below.
% Note if the Greedy algorithm terminates ``normally" then either *PROBNAME_pr_ONLINE.space.Nmax = Nbarmax or *PROBNAME_pr_ONLINE.space.eps_out_star(Nmax) $\le \varepsilon_{tol,\min}$.
% (We consider non-normal termination and associated error messages and remedies in Sections 5.4.2 and 5.5.)
assignin('base',strcat(probname,'_','pr_PROBDEF'),pr_PROBDEF);
save(strcat(probname,'_','pr_PROBDEF'),strcat(probname,'_','pr_PROBDEF')) % save final *PROBNAME_pr_PROBDEF structure inputs to file *PROBNAME_pr_PROBDEF.mat
assignin('base',strcat(probname,'_','pr_OFFLINE'),pr_OFFLINE);
save(strcat(probname,'_','pr_OFFLINE'),strcat(probname,'_','pr_OFFLINE')) % save final *PROBNAME_pr_OFFLINE structure inputs to file *PROBNAME_pr_OFFLINE.mat
assignin('base',strcat(probname,'_','pr_ONLINE'),pr_ONLINE);
save(strcat(probname,'_','pr_ONLINE'),strcat(probname,'_','pr_ONLINE')) % save final *PROBNAME_pr_ONLINE structure inputs to file *PROBNAME_pr_ONLINE.mat
%
pr_ONLINE.space.Nmax  % scalar --- the value of $N_{\max}$
pr_ONLINE.space.eps_out_star %  $1 \times N_{\max}$ vector --- $\varepsilon^{out,\ast}(N), 1 \le N \le N_{\max}$
%
% beyond this point the script checks and compute "mixed" primal-dual terms
% if a dual space is already available and primal has been enriched/changed
% by a restart.
if pr_OFFLINE.space.restartflg==1
    if exist('outputname')==1
        addpath(outputname)
    end
    if exist(strcat(probname,'_',outputname,'_','du_ONLINE.mat'))==2
        if size(pr_ONLINE.RB.matrix.LN{1},1)< pr_ONLINE.space.Nmax

            load(strcat(probname,'_',outputname,'_','du_PROBDEF'));
            assignin('base','du_PROBDEF',eval(strcat(probname,'_',outputname,'_','du_PROBDEF')));
            load(strcat(probname,'_',outputname,'_','du_OFFLINE'));
            assignin('base','du_OFFLINE',eval(strcat(probname,'_',outputname,'_','du_OFFLINE')));
            load(strcat(probname,'_',outputname,'_','du_ONLINE'));
            assignin('base','du_ONLINE',eval(strcat(probname,'_',outputname,'_','du_ONLINE')));

            m=pr_OFFLINE.FEM.matrix.m;
            for q=1:pr_PROBDEF.Q_affine.a
                Aq{q} = pr_OFFLINE.FEM.matrix.Aq{q}(m,m);
            end
            for q=1:du_PROBDEF.Q_affine.l
                Lq{q}=-full(du_OFFLINE.FEM.matrix.Lq{q}(m)); %FEM.matrix.L{q}
            end
            for q=1:pr_PROBDEF.Q_affine.f
                Fq{q}=full(pr_OFFLINE.FEM.matrix.Fq{q}(m)); %FEM.matrix.F{q}
            end

            for q=1:du_PROBDEF.Q_affine.l
                pr_ONLINE.RB.matrix.LN{q} = pr_OFFLINE.space.Z'*Lq{q};
            end

            for q=1:pr_PROBDEF.Q_affine.f
                du_ONLINE.RB.matrix.FN{q} = du_OFFLINE.space.Z'*Fq{q};
            end

            for q=1:pr_PROBDEF.Q_affine.a
                du_ONLINE.RB.matrix.Aqns{q} =  pr_OFFLINE.space.Z'*(Aq{q}*du_OFFLINE.space.Z);
            end
            cd (outputname)
            assignin('base',strcat(probname,'_',outputname,'_','du_PROBDEF'),du_PROBDEF);
            save(strcat(probname,'_',outputname,'_','du_PROBDEF'),strcat(probname,'_',outputname,'_','du_PROBDEF')) % save final *PROBNAME_du_PROBDEF structure inputs to file *PROBNAME_du_PROBDEF.mat
            assignin('base',strcat(probname,'_',outputname,'_','OFFLINE'),du_OFFLINE);
            save(strcat(probname,'_',outputname,'_','du_OFFLINE'),strcat(probname,'_',outputname,'_','du_OFFLINE')) % save final *PROBNAME_du_OFFLINE structure inputs to file *PROBNAME_du_OFFLINE.mat
            assignin('base',strcat(probname,'_',outputname,'_','du_ONLINE'),du_ONLINE);
            save(strcat(probname,'_',outputname,'_','du_ONLINE'),strcat(probname,'_',outputname,'_','du_ONLINE')) % save final *PROBNAME_du_ONLINE structure inputs to file *PROBNAME_du_ONLINE.mat
            %
            cd ..
            assignin('base',strcat(probname,'_','pr_ONLINE'),pr_ONLINE);
            save(strcat(probname,'_','pr_ONLINE'),strcat(probname,'_','pr_ONLINE')) % save final *PROBNAME_pr_ONLINE structure inputs to file *PROBNAME_pr_ONLINE.mat
        end
    end
end

if (pr_PROBDEF.plotdemo==1)
    close all
    figure()
    semilogy(1:size(pr_ONLINE.space.eps_out_star,2), pr_ONLINE.space.eps_out_star, 'o')
    title('Offline Adaptive Sampling')
    xlabel('N')
    ylabel('\epsilon^{*}')
    % %

    disp(['plotted max error bounds at different iterations of primal greedy'])
    disp(['Press any key']);

    pause;
    close all
end