% -----rbMIT Software Copyright MIT 2006-07-----
% -------------DBP Huynh, NC Nguyen, AT Patera, G Rozza ----------
% The user agrees to rbMIT  MIT usage, distribution, and citation terms and
% conditions described in the License at http://augustine.mit.edu/rbMIT_SystemLicense.htm.

% Part II and IV coercive problems, non-compliant outputs

% Script *PROBNAME_OUTPUTNAME_Step2_2_coer_noncompliant.m: Copyright MIT 2006-07.
% Enter control parameters for Greedy^{out,*} generation of dual RB space.
% First address generation of the sample $\Xi_{train}$.
clear pr_PROBDEF pr_OFFLINE pr_ONLINE

load(strcat(probname,'_',outputname,'_','du_OFFLINE'));
assignin('base','du_OFFLINE',eval(strcat(probname,'_',outputname,'_','du_OFFLINE')));

du_OFFLINE.space.sample.newflg = 1; % 1 $\Rightarrow$ create new sample $\Xi_{train}$; 0 $\Rightarrow$ use existing sample (previously created) $Xi_{train}$
du_OFFLINE.space.sample.densityflg = 0; % 0 $\Rightarrow$ random with uniform density in $\bfmu$; 1 $\Rightarrow$ random with uniform density in $\ln(\bfmu)$ (requires $\mu_{\min} >0$)
du_OFFLINE.space.sample.size = 1000; % positive integer $n_{train} --- size of $\Xi_{train}$
% Next provide tolerances.
du_OFFLINE.space.absrelflg = 1; % 0 $\Rightarrow \omega_N = 1$ (absolute error); 1 $\Rightarrow \omega_N=u_N (relative error in energy norm for greedy)
du_OFFLINE.space.tol = 5e-3; % positive real $\varepsilon_{tol,\min}$ --- anticipated smallest desired (absolute or relative) output error
du_OFFLINE.space.Nbarmax = 120; % positive integer $\overline{N}_{\max}$ --- upper limit on dimension of (largest) RB space


du_OFFLINE.space.restartflg=0;  % =1 for a re-start of greedy, =0 for normal running;
% beyond this line no more user input requested

if (du_OFFLINE.space.restartflg==0)
    du_ONLINE.space = [ ]; % no problem-specific (user) inputs required
else
    load(strcat(probname,'_',outputname,'_','du_ONLINE'));
    assignin('base','du_ONLINE',eval(strcat(probname,'_',outputname,'_','du_ONLINE')));
end

assignin('base',strcat(probname,'_',outputname,'_','du_OFFLINE'),du_OFFLINE);
save(strcat(probname,'_',outputname,'_','du_OFFLINE'),strcat(probname,'_',outputname,'_','du_OFFLINE')) % save final *PROBNAME_du_OFFLINE structure inputs to file *PROBNAME_du_OFFLINE.mat
assignin('base',strcat(probname,'_',outputname,'_','du_ONLINE'),du_ONLINE);
save(strcat(probname,'_',outputname,'_','du_ONLINE'),strcat(probname,'_',outputname,'_','du_ONLINE')) % save (empty) *PROBNAME_du_ONLINE structure to file *PROBNAME_du_ONLINE.mat

%
% Load the problem data required by the Greedy algorithm.
load(strcat(probname,'_',outputname,'_','du_PROBDEF'));
assignin('base','du_PROBDEF',eval(strcat(probname,'_',outputname,'_','du_PROBDEF')));
load(strcat(probname,'_',outputname,'_','du_ONLINE'));
assignin('base','du_ONLINE',eval(strcat(probname,'_',outputname,'_','du_ONLINE')));
load(strcat(probname,'_',outputname,'_','du_OFFLINE'));
assignin('base','du_OFFLINE',eval(strcat(probname,'_',outputname,'_','du_OFFLINE')));
%
load(strcat('../',probname,'_','pr_PROBDEF'));
assignin('base','pr_PROBDEF',eval(strcat(probname,'_','pr_PROBDEF')));
load(strcat('../',probname,'_','pr_ONLINE'));
assignin('base','pr_ONLINE',eval(strcat(probname,'_','pr_ONLINE')));
load(strcat('../',probname,'_','pr_OFFLINE'));
assignin('base','pr_OFFLINE',eval(strcat(probname,'_','pr_OFFLINE')));
% Call the Greedy routine (which resides in \rbMIT_System\rbMIT_Library).

% addpath('../../rbMIT_Library')
% addpath('../../rbMIT_Library/parabolic')
[du_PROBDEF, du_OFFLINE, du_ONLINE, pr_ONLINE] = Greedy_dual_coer_noncompliant(du_PROBDEF, pr_PROBDEF, du_OFFLINE, pr_OFFLINE, du_ONLINE, pr_ONLINE, str2func(strcat(probname, '_' , 'InsideOutsideD')), str2func(strcat(probname, '_' , 'Get_Theta_q')), str2func(strcat(probname, '_' , outputname, '_','Get_Theta_q')));

% Second dual problem for dLIFT
% cuong 8/16
if strcmp(pr_PROBDEF.type,'parabolic') & (du_PROBDEF.dirfluxflag == 1)
    load(strcat(probname,'_',outputname,'_','du2_OFFLINE'));
    assignin('base','du2_OFFLINE',eval(strcat(probname,'_',outputname,'_','du2_OFFLINE')));
    du2_OFFLINE.space.sample.newflg = 1; % 1 $\Rightarrow$ create new sample $\Xi_{train}$; 0 $\Rightarrow$ use existing sample (previously created) $Xi_{train}$
    du2_OFFLINE.space.sample.densityflg = 0; % 0 $\Rightarrow$ random with uniform density in $\bfmu$; 1 $\Rightarrow$ random with uniform density in $\ln(\bfmu)$ (requires $\mu_{\min} >0$)
    du2_OFFLINE.space.sample.size = 1000; % positive integer $n_{train} --- size of $\Xi_{train}$
    % Next provide tolerances.
    du2_OFFLINE.space.absrelflg = 1; % 0 $\Rightarrow \omega_N = 1$ (absolute error); 1 $\Rightarrow \omega_N=u_N (relative error in energy norm for greedy)
    du2_OFFLINE.space.tol = 5e-3; % positive real $\varepsilon_{tol,\min}$ --- anticipated smallest desired (absolute or relative) output error
    du2_OFFLINE.space.Nbarmax = 120; % positive integer $\overline{N}_{\max}$ --- upper limit on dimension of (largest) RB space
    if (du_OFFLINE.space.restartflg==0)
        du2_OFFLINE.space.restartflg=0;
        du2_ONLINE.space = [ ]; % no problem-specific (user) inputs required
    else
        load(strcat(probname,'_',outputname,'_','du2_ONLINE'));
        assignin('base','du2_ONLINE',eval(strcat(probname,'_',outputname,'_','du2_ONLINE')));
    end
    assignin('base',strcat(probname,'_',outputname,'_','du2_OFFLINE'),du2_OFFLINE);
    save(strcat(probname,'_',outputname,'_','du2_OFFLINE'),strcat(probname,'_',outputname,'_','du2_OFFLINE')) % save final *PROBNAME_du_OFFLINE structure inputs to file *PROBNAME_du_OFFLINE.mat
    assignin('base',strcat(probname,'_',outputname,'_','du2_ONLINE'),du2_ONLINE);
    save(strcat(probname,'_',outputname,'_','du2_ONLINE'),strcat(probname,'_',outputname,'_','du2_ONLINE')) % save (empty) *PROBNAME_du_ONLINE structure to file *PROBNAME_du_ONLINE.mat

    % Load the problem data required by the Greedy algorithm.
    load(strcat(probname,'_',outputname,'_','du2_PROBDEF'));
    assignin('base','du2_PROBDEF',eval(strcat(probname,'_',outputname,'_','du2_PROBDEF')));
    load(strcat(probname,'_',outputname,'_','du2_ONLINE'));
    assignin('base','du2_ONLINE',eval(strcat(probname,'_',outputname,'_','du2_ONLINE')));
    load(strcat(probname,'_',outputname,'_','du2_OFFLINE'));
    assignin('base','du2_OFFLINE',eval(strcat(probname,'_',outputname,'_','du2_OFFLINE')));

    [du2_PROBDEF, du2_OFFLINE, du2_ONLINE] = Greedy_dual_coer_noncompliant(du2_PROBDEF, pr_PROBDEF, du2_OFFLINE, pr_OFFLINE, du2_ONLINE, pr_ONLINE, str2func(strcat(probname, '_' , 'InsideOutsideD')), str2func(strcat(probname, '_' , 'Get_Theta_q')), str2func(strcat(probname, '_' , outputname, '_','Get_Theta_LM_q')));
    du_PROBDEF.du2_PROBDEF=du2_PROBDEF;
    du_OFFLINE.du2_OFFLINE=du2_OFFLINE;
    du_ONLINE.du2_ONLINE=du2_ONLINE;
    du2_ONLINE.space.Nmax  % scalar --- the value of $N_{\max}$
    du2_ONLINE.space.eps_out_star %  $1 \times N_{\max}$ vector --- $\varepsilon^{out,\ast}(N), 1 \le N \le N_{\max}$
end
% cuong 8/16

% Display the ``user--readable" outputs of the Greedy algorithm. (Note the Greedy code produces many ``non--user--readable" OUTs (saved to the OFFLINE and ONLINE structures and
% corresponding .mat files) that are needed for (i) ``Inherited" problem
% creation (see Section 5.4.2), and of course (ii) the Online RB output and
% error bound evaluation s--- Step3 below.
% Note if the Greedy algorithm terminates ``normally" then either *PROBNAME_du_ONLINE.space.Nmax = Nbarmax or *PROBNAME_du_ONLINE.space.eps_out_star(Nmax) $\le \varepsilon_{tol,\min}$.
% (We consider non-normal termination and associated error messages and remedies in Sections 5.4.2 and 5.5.)

assignin('base',strcat(probname,'_',outputname,'_','du_PROBDEF'),du_PROBDEF);
save(strcat(probname,'_',outputname,'_','du_PROBDEF'),strcat(probname,'_',outputname,'_','du_PROBDEF')) % save final *PROBNAME_du_PROBDEF structure inputs to file *PROBNAME_du_PROBDEF.mat
assignin('base',strcat(probname,'_',outputname,'_','du_OFFLINE'),du_OFFLINE);
save(strcat(probname,'_',outputname,'_','du_OFFLINE'),strcat(probname,'_',outputname,'_','du_OFFLINE')) % save final *PROBNAME_du_OFFLINE structure inputs to file *PROBNAME_du_OFFLINE.mat
assignin('base',strcat(probname,'_',outputname,'_','du_ONLINE'),du_ONLINE);
save(strcat(probname,'_',outputname,'_','du_ONLINE'),strcat(probname,'_',outputname,'_','du_ONLINE')) % save final *PROBNAME_du_ONLINE structure inputs to file *PROBNAME_du_ONLINE.mat
%


assignin('base',strcat(probname,'_','pr_ONLINE'),pr_ONLINE);
save(strcat('../',probname,'_','pr_ONLINE'),strcat(probname,'_','pr_ONLINE')) % save final *PROBNAME_pr_ONLINE structure inputs to file *PROBNAME_pr_ONLINE.mat

du_ONLINE.space.Nmax  % scalar --- the value of $N_{\max}$
du_ONLINE.space.eps_out_star %  $1 \times N_{\max}$ vector --- $\varepsilon^{out,\ast}(N), 1 \le N \le N_{\max}$
%
if (pr_PROBDEF.plotdemo==1)
    close
    figure()
    semilogy(1:size(du_ONLINE.space.eps_out_star,2), du_ONLINE.space.eps_out_star, 'o')
    title('Offline Adaptive Sampling')
    xlabel('N')
    ylabel('\epsilon^{*}')
    disp(['plotted max error bounds at different iterations of dual greedy'])
    disp(['Press any key']);

    pause;
    close all
    % %
    %size(du_OFFLINE.space.Z)
end
