function [OFFLINE,ONLINE] = Greedy_sampling_procedure(OFFLINE, ONLINE)
% TODO: generalize to multiple outputs 
% -----rbMIT Software Copyright MIT 2006-07----
% DBP Huynh, NC Nguyen, AT Patera, G Rozza
% Henceforth, Software shall refer to the rbMIT_System software package: 
% the contents of the rbMIT_Library and rbMIT_Aux folders.
% 
% This License governs use of all accompanying Software, and your download and/or use of the Software constitutes acceptance 
% of this License.
% 
% You may use this Software for any non-commercial purpose, subject to the restrictions in this license. 
% Some purposes which can be non-commercial are teaching and academic research.
% 
% You may not use or distribute this Software or any derivative works in any form for commercial purposes. 
% Examples of commercial purposes would be licensing, leasing, or selling the Software, or distributing the 
% Software for use with commercial products.
% 
% You may modify this Software and distribute the modified Software for non-commercial purposes,
%  however, you may not grant rights to the Software or derivative works that are broader than those 
% provided by this License. For example, you may not distribute modifications of the Software under terms 
% that would permit commercial use.
% 
% In return, we require that you agree:
% 
% not to remove any copyright or other notices from the Software;
% 
% that if you distribute the Software in source or object form, you will include a verbatim copy of this license;
% 
% that if you distribute derivative works of the Software in source code form you do so only under a license
% that includes all of the provisions of this License, and if you distribute derivative works of the Software solely 
% in object form you do so only under a license that complies with this License;
% 
% that if you have modified the Software or created derivative works, and distribute such modifications or derivative
% works, you will cause the modified files to carry prominent notices so that recipients know that they are not receiving the original Software;
% 
% THAT THE SOFTWARE COMES "AS IS", WITH NO WARRANTIES: THIS MEANS NO EXPRESS, IMPLIED OR STATUTORY WARRANTY, 
% INCLUDING WITHOUT LIMITATION WARRANTIES OF MERCHANTABILITY OR FITNESS FOR A PARTICULAR PURPOSE OR ANY WARRANTY 
% OF TITLE OR NON-INFRINGEMENT; YOU MUST PASS THIS DISCLAIMER ON WHENEVER YOU DISTRIBUTE THE SOFTWARE OR DERIVATIVE WORKS;
% 
% THAT NEITHER MIT NOR THE AUTHORS WILL BE LIABLE FOR ANY DAMAGES RELATED TO THE SOFTWARE OR THIS LICENSE, 
% INCLUDING DIRECT, INDIRECT, SPECIAL, CONSEQUENTIAL OR INCIDENTAL DAMAGES; YOU MUST PASS THIS LIMITATION OF LIABILITY 
% ON WHENEVER YOU DISTRIBUTE THE SOFTWARE OR DERIVATIVE WORKS;
% 
% that your rights under the License end automatically if you breach the License in any way;
% 
% that MIT reserves all rights not expressly granted to you in this License.
% 
% (Note: The wording of this license agreement is derived from a Microsoft Shared Source license agreement.)
% 
% ---------- 
% Get function handles
InsideOutsideD=str2func(strcat(OFFLINE.PROBDEF.name, '_' , 'InsideOutsideD'));
Get_Theta_q=str2func(strcat(OFFLINE.PROBDEF.name, '_' , 'Get_Theta_q'));
output_Get_Theta_q=str2func(strcat(OFFLINE.PROBDEF.name, '_', OFFLINE.PROBDEF.output, '_' , 'Get_Theta_q'));
RB_Offline=str2func(OFFLINE.PROBDEF.RB_Offline);
RB_Online=str2func(OFFLINE.PROBDEF.RB_Online);

if (OFFLINE.space.restartflg~=1) 
    OFFLINE.space.N=0;     
    ONLINE.space.Nmax=0;    
end
  
ONLINE.space.absrelflg = OFFLINE.space.absrelflg;

if OFFLINE.space.sample.newflg==1.0
    OFFLINE.space.sample.mu_samples=Samples_generation(OFFLINE.space.sample.size, InsideOutsideD, ONLINE.PROBDEF, OFFLINE.space.sample.densityflg, OFFLINE.space.sample.newflg); %possible generalization with log sample
    [alphaLB, alphaUB, rat, ONLINE]=alphaLB_coer(OFFLINE.space.sample.mu_samples, ONLINE.PROBDEF, ONLINE, Get_Theta_q);
    ONLINE.coerlb.alphaLB=alphaLB;
end
  
OFFLINE.space.startPoint=1;
OFFLINE.space.endPoint=OFFLINE.space.sample.size;     
OFFLINE.space.sampleSetNo=1;
tol=OFFLINE.space.tol;
mu_samples=OFFLINE.space.sample.mu_samples;
endPoint=OFFLINE.space.endPoint;
startPoint=OFFLINE.space.startPoint;
sampleSetNo=OFFLINE.space.sampleSetNo;
OFFLINE.space.sample_in_basis = zeros(1,endPoint); 
%generating coefficient of linear and bilinear form
samples=feval(Get_Theta_q,ONLINE.PROBDEF, mu_samples);
    
cur_tol = 2*tol;

if OFFLINE.space.N == 0
    %fist sample selection
    first_index =round(startPoint + rand*(endPoint-startPoint));
    if first_index < startPoint | first_index > endPoint
      first_index = ceil(0.5*(startPoint+endPoint));
    end
    mu_samples(first_index,:)=[];
    ONLINE.coerlb.alphaLB(first_index)=[];
        
    % storing first sample as first basis function
    ONLINE.space.Mus = mu_samples(first_index,1:end);
    ONLINE.space.theta_a=samples(first_index,1:ONLINE.PROBDEF.Q_affine.a);
    ONLINE.space.theta_f=samples(first_index,ONLINE.PROBDEF.Q_affine.a+1:end);
    
    % Initial online data
    [OFFLINE,ONLINE]=feval(RB_Offline, OFFLINE, ONLINE);
    OFFLINE.space.N=1;    
    ONLINE.space.eps_out_star=[];
end

tol

% iterative algorithm for basis assembling
disp(['Greedy algorithm']); 
while (cur_tol > tol)
   ONLINE.space.Nmax=OFFLINE.space.N;
   if (ONLINE.space.Nmax >= OFFLINE.space.Nbarmax)
       ONLINE.space.Nmax=OFFLINE.space.N;

   disp(['WARNING : increase Nbar (max) or reduce the tolerance']);

   return;
       break;
   end
   
    all_err_bounds=[];
    for i_s = 1:size(mu_samples,1)
        mu=mu_samples(i_s,:);
        N=OFFLINE.space.N;
        Ndu=OFFLINE.space.N;
        ONLINE.coerlb.alpha_LB=ONLINE.coerlb.alphaLB(i_s);
        [s,aN,DelN_s]=feval(RB_Online, mu, N, Ndu, ONLINE);
        all_err_bounds(i_s)=max(DelN_s);
    end

    [max_err_bound,max_err_bound_index] =  max(all_err_bounds);
    cur_tol = max_err_bound;
    ONLINE.space.eps_out_star = [cur_tol]; 

    disp(' ');
    disp([' N = ',num2str(OFFLINE.space.N),...
          ' Max err bound = ',num2str(max_err_bound),...
          ' Next mu = ',num2str(mu_samples(max_err_bound_index,:))]);
    disp(' ');

    % now look for the next basis function    
    ONLINE.space.Mus(end+1,:) = mu_samples(max_err_bound_index,1:end);  
    ONLINE.space.theta_a(end+1,:) = samples(max_err_bound_index,1:ONLINE.PROBDEF.Q_affine.a);
    ONLINE.space.theta_f(end+1,:) = samples(max_err_bound_index,ONLINE.PROBDEF.Q_affine.a+1:end);
    mu_samples(max_err_bound_index,:)=[];
    ONLINE.coerlb.alphaLB(max_err_bound_index)=[];
    
    % Updated online data
    [OFFLINE,ONLINE]=feval(RB_Offline, OFFLINE, ONLINE);
    OFFLINE.space.N=OFFLINE.space.N+1;    
end
ONLINE.coerlb=rmfield(ONLINE.coerlb, 'alpha_LB');
