% -----rbMIT Software Copyright MIT 2006-07----
% DBP Huynh, NC Nguyen, AT Patera, G Rozza
% Henceforth, Software shall refer to the rbMIT software package: 
% the contents of the rbMIT_Library and rbMIT_Aux folders.
% 
% This License governs use of all accompanying Software, and your download and/or use of the Software constitutes acceptance 
% of this License.
% 
% You may use this Software for any non-commercial purpose, subject to the restrictions in this license. 
% Some purposes which can be non-commercial are teaching and academic research.
% 
% You may not use or distribute this Software or any derivative works in any form for commercial purposes. 
% Examples of commercial purposes would be licensing, leasing, or selling the Software, or distributing the 
% Software for use with commercial products.
% 
% You may modify this Software and distribute the modified Software for non-commercial purposes,
%  however, you may not grant rights to the Software or derivative works that are broader than those 
% provided by this License. For example, you may not distribute modifications of the Software under terms 
% that would permit commercial use.
% 
% In return, we require that you agree:
% 
% not to remove any copyright or other notices from the Software;
% 
% that if you distribute the Software in source or object form, you will include a verbatim copy of this license;
% 
% that if you distribute derivative works of the Software in source code form you do so only under a license
% that includes all of the provisions of this License, and if you distribute derivative works of the Software solely 
% in object form you do so only under a license that complies with this License;
% 
% that if you have modified the Software or created derivative works, and distribute such modifications or derivative
% works, you will cause the modified files to carry prominent notices so that recipients know that they are not receiving the original Software;
% 
% THAT THE SOFTWARE COMES "AS IS", WITH NO WARRANTIES: THIS MEANS NO EXPRESS, IMPLIED OR STATUTORY WARRANTY, 
% INCLUDING WITHOUT LIMITATION WARRANTIES OF MERCHANTABILITY OR FITNESS FOR A PARTICULAR PURPOSE OR ANY WARRANTY 
% OF TITLE OR NON-INFRINGEMENT; YOU MUST PASS THIS DISCLAIMER ON WHENEVER YOU DISTRIBUTE THE SOFTWARE OR DERIVATIVE WORKS;
% 
% THAT NEITHER MIT NOR THE AUTHORS WILL BE LIABLE FOR ANY DAMAGES RELATED TO THE SOFTWARE OR THIS LICENSE, 
% INCLUDING DIRECT, INDIRECT, SPECIAL, CONSEQUENTIAL OR INCIDENTAL DAMAGES; YOU MUST PASS THIS LIMITATION OF LIABILITY 
% ON WHENEVER YOU DISTRIBUTE THE SOFTWARE OR DERIVATIVE WORKS;
% 
% that your rights under the License end automatically if you breach the License in any way;
% 
% that MIT reserves all rights not expressly granted to you in this License.
% 
% (Note: The wording of this license agreement is derived from a Microsoft Shared Source license agreement.)
% 
% ---------- 
% Also used for the book:
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%% REDUCED BASIS APPROXIMATION AND A POSTERIORI ERROR ESTIMATION %%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%% FOR PARAMETRIZED PARTIAL DIFFERENTIAL EQUATIONS %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%% Anthony T. PATERA - Gianluigi ROZZA %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%% (C) M.I.T. Massachusetts Institute of Technology 2006-07 %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%
% rbMIT Software PartII_IV

function [sN, DeltaN]=Online_RB(probname, mu, outputname, varargin)
%global pr_ONLINE pr_DEF du_ONLINE du_DEF cr_probname;
%%%cuong
s1=strcat(probname,'_','pr_PROBDEF');
load(s1); 
eval(['pr_DEFtdep=' s1 ';']);
if strcmp(pr_DEFtdep.type,'parabolic')==1
    [sN,DeltaN]=RB_parabolic(probname, outputname, mu, varargin{:});
    return;
end
%%%cuong

global pr_ONLINE pr_DEF du_ONLINE du_DEF cr_probname;
if strcmp(cr_probname,probname)~=1
    clear global pr_ONLINE pr_DEF du_ONLINE du_DEF cr_probname;
    global pr_ONLINE pr_DEF du_ONLINE du_DEF cr_probname;
end

% Online Evaluator
if isempty(varargin)==0
N_pr=varargin{1};
N_du=varargin{2}; %or N_du or epsdes (for now)
epsdes=varargin{2};
else
    epsdes=1000;
end
if strcmp(outputname,'')==1
DEF = evalin('base',strcat(probname,'_','PROBDEF'));
ONLINE = evalin('base',strcat(probname,'_','ONLINE'));
if epsdes==1000
    N_pr=ONLINE.space.Nmax;
    epsdes=0;
end
if strcmp(DEF.type,'parcoer_compliant')==1
[sN, DeltaN]=Online_RB_parcoer_compliant(mu, N_pr, epsdes, DEF, ONLINE, str2func(strcat(probname,'_','InsideOutsideD')), str2func(strcat(probname,'_','Get_Theta_q')));    
end
if strcmp(DEF.type,'coer_compliant')==1
[sN, DeltaN]=Online_RB_coer_compliant(mu, N_pr, epsdes, DEF, ONLINE, str2func(strcat(probname,'_','InsideOutsideD')), str2func(strcat(probname,'_','Get_Theta_q')));
end
else
% pr_DEF = evalin('base',strcat(probname,'_','pr_PROBDEF'));
% pr_ONLINE = evalin('base',strcat(probname,'_','pr_ONLINE'));
% du_DEF = evalin('base',strcat(probname,'_',outputname,'_','du_PROBDEF'));
% du_ONLINE = evalin('base',strcat(probname,'_',outputname,'_','du_ONLINE'));
if isempty(pr_ONLINE) | isempty(pr_DEF)
    s1=strcat(probname,'_','pr_ONLINE');
    s2=strcat(probname,'_','pr_PROBDEF');
    load(s1); load(s2);
    eval(['pr_ONLINE=' s1 ';']);
    eval(['pr_DEF=' s2 ';']);
    clear(s1); clear(s2); 
end
if isempty(du_ONLINE) | isempty(du_DEF)
    d0=fileparts([pwd,filesep]);  
    addpath([d0,strcat('/',outputname)]);
    s1=strcat(probname,'_',outputname,'_','du_ONLINE');
    s2=strcat(probname,'_',outputname,'_','du_PROBDEF');
    load(s1); load(s2); 
    eval(['du_ONLINE=' s1 ';']);
    eval(['du_DEF=' s2 ';']);
    clear(s1); clear(s2); 
end
if epsdes==1000
    N_pr=pr_ONLINE.space.Nmax;
    N_du=du_ONLINE.space.Nmax;
end
if strcmp(pr_DEF.type,'coer_noncompliant')==1
 cd (outputname)
%  addpath ../../rbMIT_Library
 tc=cputime;
 [sN, DeltaN]=Online_RB_coer_noncompliant(mu, N_pr, N_du, pr_DEF, du_DEF, pr_ONLINE, du_ONLINE, str2func(strcat(probname,'_','InsideOutsideD')), str2func(strcat(probname,'_','Get_Theta_q')), str2func(strcat(probname,'_',outputname,'_','Get_Theta_q')));      
 tf=cputime-tc;
%  if pr_ONLINE.space.absrelflg==1
%  DeltaN=DeltaN*sN;
%  end
 sN = sN + feval(strcat(probname,'_',outputname,'_','addout'),mu);
% if pr_ONLINE.space.absrelflg==1
%  DeltaN=DeltaN/sN;
% end
% for i = 1:size(mu,1)
%     [tmp1,tmp2]=Online_RB_coer_noncompliant(mu(i,:), N_pr, N_du, pr_DEF, du_DEF, pr_ONLINE, du_ONLINE, str2func(strcat(probname,'_','InsideOutsideD')), str2func(strcat(probname,'_','Get_Theta_q')), str2func(strcat(probname,'_',outputname,'_','Get_Theta_q')));
%     sN(i) = tmp1;
%     DeltaN(i) = tmp2;
%     tf=cputime-tc;
%     sN(i) = sN(i) + feval(strcat(probname,'_',outputname,'_','addout'),mu);
% end
cd ..
end
% assignin('base',strcat(probname,'_','pr_ONLINE'),pr_ONLINE);
% save(strcat(probname,'_','pr_ONLINE'),strcat(probname,'_','pr_ONLINE'));
end



