% -----rbMIT_System Software Copyright MIT 2006-07----
%
% Henceforth, Software shall refer to the rbMIT_System software package:
% the contents of the rbMIT_Library and rbMIT_Aux folders.
%
% This License governs use of all accompanying Software, and your download and/or use of the Software constitutes acceptance
% of this License.
%
% You may use this Software for any non-commercial purpose, subject to the restrictions in this license.
% Some purposes which can be non-commercial are teaching and academic research.
%
% You may not use or distribute this Software or any derivative works in any form for commercial purposes.
% Examples of commercial purposes would be licensing, leasing, or selling the Software, or distributing the
% Software for use with commercial products.
%
% You may modify this Software and distribute the modified Software for non-commercial purposes,
%  however, you may not grant rights to the Software or derivative works that are broader than those
% provided by this License. For example, you may not distribute modifications of the Software under terms
% that would permit commercial use.
%
% In return, we require that you agree:
%
% not to remove any copyright or other notices from the Software;
%
% that if you distribute the Software in source or object form, you will include a verbatim copy of this license;
%
% that if you distribute derivative works of the Software in source code form you do so only under a license
% that includes all of the provisions of this License, and if you distribute derivative works of the Software solely
% in object form you do so only under a license that complies with this License;
%
% that if you have modified the Software or created derivative works, and distribute such modifications or derivative
% works, you will cause the modified files to carry prominent notices so that recipients know that they are not receiving the original Software;
%
% THAT THE SOFTWARE COMES "AS IS", WITH NO WARRANTIES: THIS MEANS NO EXPRESS, IMPLIED OR STATUTORY WARRANTY,
% INCLUDING WITHOUT LIMITATION WARRANTIES OF MERCHANTABILITY OR FITNESS FOR A PARTICULAR PURPOSE OR ANY WARRANTY
% OF TITLE OR NON-INFRINGEMENT; YOU MUST PASS THIS DISCLAIMER ON WHENEVER YOU DISTRIBUTE THE SOFTWARE OR DERIVATIVE WORKS;
%
% THAT NEITHER MIT NOR THE AUTHORS WILL BE LIABLE FOR ANY DAMAGES RELATED TO THE SOFTWARE OR THIS LICENSE,
% INCLUDING DIRECT, INDIRECT, SPECIAL, CONSEQUENTIAL OR INCIDENTAL DAMAGES; YOU MUST PASS THIS LIMITATION OF LIABILITY
% ON WHENEVER YOU DISTRIBUTE THE SOFTWARE OR DERIVATIVE WORKS;
%
% that your rights under the License end automatically if you breach the License in any way;
%
% that MIT reserves all rights not expressly granted to you in this License.
%
% (Note: The wording of this license agreement is derived from a Microsoft Shared Source license agreement.)
%
% ----------
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%% REDUCED BASIS APPROXIMATION AND A POSTERIORI ERROR ESTIMATION %%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%% FOR PARAMETRIZED PARTIAL DIFFERENTIAL EQUATIONS %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%% Anthony T. PATERA - Gianluigi ROZZA %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%% (C) M.I.T. Massachusetts Institute of Technology 2006-07 %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%

function [res_dual_norm,alpha]=Online_RB_Bernoulli(probname,mu,varargin)
%global VIS pr_OFFLINE pr_ONLINE pr_DEF cr_probname VIS;

%%%cuong
s1=strcat(probname,'_','pr_PROBDEF');
load(s1);
eval(['pr_DEFtdep=' s1 ';']);
if strcmp(pr_DEFtdep.type,'parabolic')==1
    RB_parabolic_vis(probname,mu,varargin{:});
    return;
end
%%%cuong
global VIS pr_OFFLINE pr_ONLINE pr_DEF cr_probname VIS;
%%Gianluigi
if strcmp(cr_probname,probname)~=1
    clear global pr_ONLINE pr_DEF VIS cr_probname;
    global pr_ONLINE pr_DEF VIS cr_probname;
end

%%%Gianluigi

if isempty(varargin)==0
    pin=varargin{1};
    gravity=varargin{2};
    %epsdes=varargin{3};
    %N=varargin{4};
else
    pin=1;
    gravity=0;
end
    N=0;
    epsdes=0.01;
    ONLINE.space.absrelflg=1;



%
% if exist('outputname')==0
% DEF = evalin('base',strcat(probname,'_','PROBDEF'));
% ONLINE = evalin('base',strcat(probname,'_','ONLINE'));
% OFFLINE = evalin('base',strcat(probname,'_','OFFLINE'));
% end

% if  exist(strcat(probname,'_','pr_ONLINE.mat'))==2
% DEF = evalin('base',strcat(probname,'_','pr_PROBDEF'));
% ONLINE = evalin('base',strcat(probname,'_','pr_ONLINE'));
% OFFLINE = evalin('base',strcat(probname,'_','pr_OFFLINE'));
% else
% if exist(strcat(probname,'_','ONLINE.mat'))==2
%  DEF = evalin('base',strcat(probname,'_','PROBDEF'));
%  ONLINE = evalin('base',strcat(probname,'_','ONLINE'));
%  OFFLINE = evalin('base',strcat(probname,'_','OFFLINE'));
% end
% end

%VIS = evalin('base',strcat(probname,'_','VIS'));


if isempty(pr_ONLINE) | isempty(pr_DEF)
    s1=strcat(probname,'_','pr_ONLINE');
    s2=strcat(probname,'_','pr_PROBDEF');
    s3=strcat(probname,'_','pr_OFFLINE');
    s4=strcat(probname,'_','VIS');
    load(s1); load(s2);load (s3); load (s4)
    eval(['ONLINE=' s1 ';']);
    eval(['DEF=' s2 ';']);
    eval(['OFFLINE=' s3 ';']);
    eval(['VIS=' s4 ';']);
    clear(s1); clear(s2); clear(s3); clear(s4)
    ONLINE.space.absrelflg = 0;
end


%Geometry

if exist(strcat(probname,'_','SYMB.mat'))==2
    figure()
    pmu=geoplot(probname,mu);
    geoplot(probname,mu)
    %   figure(20)
    %   pdemesh(pmu,VIS.e,VIS.t)
else
    pmu=VIS.p;
    figure()
    pdegplot(VIS.g)
    %    figure(20)
    %    pdemesh(pmu,VIS.e,VIS.t)
end

%pdegplot(strcat(probname,'_','pdedom'));

%  parameter range check
if (min(mu) < DEF.mu_min)
    error(['WARNING : all parameters have to be >= ', num2str(DEF.mu_min)]);
end
%
% %
if (max(mu) > DEF.mu_max)
    error(['WARNING : all parameters have to be <= ', num2str(DEF.mu_max)]);
end
%

[InsideBoolean] = feval(strcat(probname,'_','InsideOutsideD'), DEF, mu);

if InsideBoolean==0
    error(['WARNING : parameter value is out of range']);
end
if (N > ONLINE.space.Nmax)
    error(['Size of reduced basis space should be smaller than Nmax']);
end

sample=feval(strcat(probname,'_','Get_Theta_q'), DEF, mu);
theta_a = sample(1:DEF.Q_affine.a);
theta_f = sample(1+DEF.Q_affine.a: DEF.Q_affine.f+DEF.Q_affine.a);

if  (N==0)
    N=ONLINE.space.Nmax;
    %%%%  solve RB system %%%%%%%%%
    AN = theta_a(1)*ONLINE.RB.matrix.Aqn{1}(1:N,1:N);
    for q=2:DEF.Q_affine.a
        AN = AN + theta_a(q)*ONLINE.RB.matrix.Aqn{q}(1:N,1:N);
    end

    FN = ONLINE.RB.matrix.FN{1}(1:N)*theta_f(1);
    for q=2:DEF.Q_affine.f
        FN = FN + ONLINE.RB.matrix.FN{q}(1:N)*theta_f(q);
    end

    uN = AN\FN;

    sN = uN' * FN;

    %%%%%%  end solve RB system %%%%%%%%%


    if exist(strcat(probname,'_','ONLINE.mat'))==2
        % alpha lower bound
        alpha= alphaLB_parcoer(theta_a,DEF.aux.thetamubar(1:DEF.Q_affine.a));
    end
    if exist(strcat(probname,'_','pr_ONLINE.mat'))==2
        [alpha, alphaUB, rat, ONLINE]=alphaLB_coer(mu, DEF, ONLINE, str2func(strcat(probname,'_','Get_Theta_q')));
    end

    %% error estimation %%%


    %res_ff = RB_pr.res_ff;

    res_ff = 0;
    for q=1:DEF.Q_affine.f
        for qprime=1:DEF.Q_affine.f
            res_ff = res_ff + theta_f(q)*theta_f(qprime)*ONLINE.RB.matrix.Zqfprime_Fq{q,qprime};
        end
    end

    res_af = 0;
    for q=1:DEF.Q_affine.a
        for qprime=1:DEF.Q_affine.f
            res_af = res_af + theta_a(q)*theta_f(qprime)*...
                ONLINE.RB.matrix.Zqfprime_Aq_Z{q,qprime}(1,1:N)*uN;
        end
    end

    res_aa = 0;
    for q = 1:DEF.Q_affine.a
        for qprime = 1:DEF.Q_affine.a
            res_aa = res_aa + theta_a(q)*theta_a(qprime)*...
                (uN'*ONLINE.RB.matrix.Zqaprime_Aq_Z{q,qprime}(1:N,1:N)*uN);
        end
    end

    res_dual_norm = real(res_ff -2*res_af + res_aa);

    delta_s = res_dual_norm/alpha;




    %u_RB = OFFLINE.space.Z(:,1:N)*uN;

    rb_norm_Nmax = (uN'*ONLINE.RB.matrix.X_norm_rb(1:N,1:N)*uN);
    Delta_u = real(sqrt(res_dual_norm)/alpha);
    uNmax=uN;
    if ONLINE.space.absrelflg==0
        sol_bound = Delta_u;
    else
        sol_bound = Delta_u/sqrt(rb_norm_Nmax);
    end

    epsdes=epsdes-sol_bound ; %sharp tolerance

    if epsdes<0
        N=ONLINE.space.Nmax ;
        disp(['epsdes is too small for given approximation']);
        disp(['the plot is given for Nmax!!!']);
    else
        if (min(ONLINE.space.eps_out_star(1:end-1))<epsdes)
            N=min(find(ONLINE.space.eps_out_star<epsdes));
        else
            disp(['epsdes is too small for given approximation']);
            disp(['the plot is given for Nmax!!!']);
            N=ONLINE.space.Nmax;
        end
    end
end


sol_bound=101.0;


if epsdes==0.0
    epsdes=100.0;
end
iter=1.0;
while (sol_bound>epsdes)
    if iter>1
        N=N+3;
        if N>ONLINE.space.Nmax
            disp(['Reduce the accuracy or enrich the basis, epsdes is too small and Nmax not enough']);
            disp(['the plot is given for Nmax!!!']);
            N=ONLINE.space.Nmax;
        end
    end
    %%%%  solve RB system %%%%%%%%%
    AN = theta_a(1)*ONLINE.RB.matrix.Aqn{1}(1:N,1:N);
    for q=2:DEF.Q_affine.a
        AN = AN + theta_a(q)*ONLINE.RB.matrix.Aqn{q}(1:N,1:N);
    end

    FN = ONLINE.RB.matrix.FN{1}(1:N)*theta_f(1);
    for q=2:DEF.Q_affine.f
        FN = FN + ONLINE.RB.matrix.FN{q}(1:N)*theta_f(q);
    end

    uN = AN\FN;

    sN = uN' * FN;

    %%%%%%  end solve RB system %%%%%%%%%
    if N>0

        if exist(strcat(probname,'_','ONLINE.mat'))==2
            % alpha lower bound
            alpha= alphaLB_parcoer(theta_a,DEF.aux.thetamubar(1:DEF.Q_affine.a));
        end
        if exist(strcat(probname,'_','pr_ONLINE.mat'))==2
            [alpha, alphaUB, rat, ONLINE]=alphaLB_coer(mu, DEF, ONLINE, str2func(strcat(probname,'_','Get_Theta_q')));
        end

        %% error estimation %%%


        %res_ff = RB_pr.res_ff;

        res_ff = 0;
        for q=1:DEF.Q_affine.f
            for qprime=1:DEF.Q_affine.f
                res_ff = res_ff + theta_f(q)*theta_f(qprime)*ONLINE.RB.matrix.Zqfprime_Fq{q,qprime};
            end
        end

        res_af = 0;
        for q=1:DEF.Q_affine.a
            for qprime=1:DEF.Q_affine.f
                res_af = res_af + theta_a(q)*theta_f(qprime)*...
                    ONLINE.RB.matrix.Zqfprime_Aq_Z{q,qprime}(1,1:N)*uN;
            end
        end

        res_aa = 0;
        for q = 1:DEF.Q_affine.a
            for qprime = 1:DEF.Q_affine.a
                res_aa = res_aa + theta_a(q)*theta_a(qprime)*...
                    (uN'*ONLINE.RB.matrix.Zqaprime_Aq_Z{q,qprime}(1:N,1:N)*uN);
            end
        end

        res_dual_norm = real(res_ff -2*res_af + res_aa);

        delta_u = res_dual_norm/alpha;
        
        if ONLINE.space.absrelflg==0
            sol_bound = delta_u;
            disp(['error in X norm is ', num2str(sol_bound)]);
        else
            rb_norm= (uN'*ONLINE.RB.matrix.X_norm_rb(1:N,1:N)*uN);
            sol_bound = delta_u/sqrt(rb_norm);
            disp(['error in X norm is ', num2str(sol_bound)]);
        end

    else

        %u_RB = OFFLINE.space.Z(:,1:N)*uN;
        uNc=[uN;zeros(size(uNmax,1)-size(uN,1),1)];
        rb_norm_err = ((uNc-uNmax)'*ONLINE.RB.matrix.X_norm_rb(1:ONLINE.space.Nmax,1:ONLINE.space.Nmax)*(uNc-uNmax));

        %Delta_u = real(sqrt(res_dual_norm)/alpha);

        if ONLINE.space.absrelflg==0
            sol_bound = sqrt(abs(rb_norm_err));
            disp(['error in X norm is ', num2str(sol_bound)]);
        else
            rb_norm= (uN'*ONLINE.RB.matrix.X_norm_rb(1:N,1:N)*uN);
            sol_bound =sqrt(rb_norm_err)/sqrt(rb_norm);
            disp(['error in X norm is ', num2str(sol_bound)]);
        end
    end
    iter=iter+1;
    if (N==ONLINE.space.Nmax)
        break;
    end
end

%Visualization
%importing structure
B=VIS.B;
uRB=OFFLINE.space.Z(:,1:N)*uN;

m=OFFLINE.FEM.matrix.m;
P=sparse(size(m,2),size(m,2));
for i=1: size(m,2)
    P(i,m(i))=1;
end
uRBr=inv(P)*uRB;
%p=VIS.p;
t=VIS.t;
UD=VIS.UD;
e=VIS.e;
uT=B*uRBr+UD;
num_dim=size(uT,1)/size(pmu,2);
if strcmp(DEF.probtype,'LE5') % recover u1
    uT(1:size(pmu,2)) = uT(1:size(pmu,2)).*pmu(1,:)';
end
startp=1;
endp=size(pmu,2);
for k=1:num_dim

    figure(k+1)
    pdesurf(pmu,t,uT(startp:endp))
    title('Potential Function')
    colormap(jet)
    axis equal;
    colorbar('vert')
    lighting('phong')
    startp=startp+size(pmu,2);
    endp=endp+size(pmu,2);
end


if num_dim == 1
    for k=1:size(t,2)
    cg(1,k)=(pmu(1,t(1,k))+pmu(1,t(2,k))+pmu(1,t(3,k)))/3;
    cg(2,k)=(pmu(2,t(1,k))+pmu(2,t(2,k))+pmu(2,t(3,k)))/3;
    end
    Delta_u = real(sqrt(res_dual_norm/alpha));
    rb_norm= (uN'*ONLINE.RB.matrix.X_norm_rb(1:N,1:N)*uN);
    Delta_ur=Delta_u/rb_norm;
    I_N = sqrt(sN); % this is uN'*AN*uN, Gianluigi pls check
    %I_N = sqrt(uN'*AN*uN) checked it is OK
    DeltaV = Delta_ur^2+2*I_N*Delta_ur;
    DeltaP = 0.5*DeltaV;
    
    % velocity
    [ux,uy] = pdegrad(pmu,t,uT);
    Udata = -[ux;uy];
    
%     figure(11);
%     hold on;
%     pdeplot(pmu,[],t,'xydata',uT,'colormap','cool','flowdata',Udata,'flowstyle','arrow','title',['Velocity error = ',num2str(DeltaV)]);
%     colormap(jet)
%     colorbar('vert')
%     lighting('phong')
%     axis equal;
%     hold off;

    figure(11);
    pdeplot(pmu,[],t,'xydata',uT,'colormap','jet','flowdata',Udata,'flowstyle','arrow','title',['Velocity error = ',num2str(DeltaV)]);
    hold on;
    
    flowdata=pdeprtni(pmu,t,Udata);
    xmin=min(pmu(1,t)); xmax=max(pmu(1,t));
    ymin=min(pmu(2,t)); ymax=max(pmu(2,t));
    na=21;
    xtmp=linspace(xmin,xmax,na);
    ytmp=linspace(ymin,ymax,na);
    utmp=tri2grid(pmu,t,flowdata(:,1),xtmp,ytmp);
    vtmp=tri2grid(pmu,t,flowdata(:,2),xtmp,ytmp);
    [msg,xtmp,ytmp]=xyzchk(xtmp,ytmp,utmp,vtmp);
    oks=find(~isnan(utmp));
    quiver(xtmp(oks),ytmp(oks),utmp(oks),vtmp(oks),'k-');
    colorbar('vert')
    lighting('phong')
    axis equal;
    hold off;    
    
    % pressure
    %pin = pressure; % some random inlet pressure (at the top) %we can introduce this as parameter
    rhogy=1*gravity*1;% gravity effect (potential) %we can introduce this as parameter
    Pdata = rhogy+pin+0.5-0.5*(Udata(1,:).^2+Udata(2,:).^2)-gravity*cg(2,:);
    figure(12);
    hold on;
    pdeplot(pmu,[],t,'xydata',Pdata,'colormap','jet','contour','on','levels',21,'title',['Pressure error = ',num2str(DeltaP)]);
    colorbar('vert')
    lighting('phong')
    axis equal;    
    hold off;
end

% disp(['Press any key'])
% pause

% close all
return