% -----rbMIT Software Copyright MIT 2006-07----
%  DBP  Huynh,NC Nguyen, AT Patera, G Rozza
% Henceforth, Software shall refer to the rbMIT_System software package: 
% the contents of the rbMIT_Library and rbMIT_Aux folders.
% 
% This License governs use of all accompanying Software, and your download and/or use of the Software constitutes acceptance 
% of this License.
% 
% You may use this Software for any non-commercial purpose, subject to the restrictions in this license. 
% Some purposes which can be non-commercial are teaching and academic research.
% 
% You may not use or distribute this Software or any derivative works in any form for commercial purposes. 
% Examples of commercial purposes would be licensing, leasing, or selling the Software, or distributing the 
% Software for use with commercial products.
% 
% You may modify this Software and distribute the modified Software for non-commercial purposes,
%  however, you may not grant rights to the Software or derivative works that are broader than those 
% provided by this License. For example, you may not distribute modifications of the Software under terms 
% that would permit commercial use.
% 
% In return, we require that you agree:
% 
% not to remove any copyright or other notices from the Software;
% 
% that if you distribute the Software in source or object form, you will include a verbatim copy of this license;
% 
% that if you distribute derivative works of the Software in source code form you do so only under a license
% that includes all of the provisions of this License, and if you distribute derivative works of the Software solely 
% in object form you do so only under a license that complies with this License;
% 
% that if you have modified the Software or created derivative works, and distribute such modifications or derivative
% works, you will cause the modified files to carry prominent notices so that recipients know that they are not receiving the original Software;
% 
% THAT THE SOFTWARE COMES "AS IS", WITH NO WARRANTIES: THIS MEANS NO EXPRESS, IMPLIED OR STATUTORY WARRANTY, 
% INCLUDING WITHOUT LIMITATION WARRANTIES OF MERCHANTABILITY OR FITNESS FOR A PARTICULAR PURPOSE OR ANY WARRANTY 
% OF TITLE OR NON-INFRINGEMENT; YOU MUST PASS THIS DISCLAIMER ON WHENEVER YOU DISTRIBUTE THE SOFTWARE OR DERIVATIVE WORKS;
% 
% THAT NEITHER MIT NOR THE AUTHORS WILL BE LIABLE FOR ANY DAMAGES RELATED TO THE SOFTWARE OR THIS LICENSE, 
% INCLUDING DIRECT, INDIRECT, SPECIAL, CONSEQUENTIAL OR INCIDENTAL DAMAGES; YOU MUST PASS THIS LIMITATION OF LIABILITY 
% ON WHENEVER YOU DISTRIBUTE THE SOFTWARE OR DERIVATIVE WORKS;
% 
% that your rights under the License end automatically if you breach the License in any way;
% 
% that MIT reserves all rights not expressly granted to you in this License.
% 
% (Note: The wording of this license agreement is derived from a Microsoft Shared Source license agreement.)
% 
% License at http://augustine.mit.edu/rbMIT_SystemLicense.htm.
%
% rbMIT Software Part_II_and_IV
%
% ---------- 

n=201;
p=((0:n-1)/(n-1))';
p=xmax*p;
t=([1:n-1; 2:n])';

gx=[-0.8611363116 -0.3399810435 0.3399810435 0.8611363116];
gw=[0.3478548451 0.6521451548 0.6521451548 0.3478548451];

Me=[1/3 1/6; 1/6 1/3];
Ae=[1 -1;-1  1];
A=sparse(n,n); 
M=sparse(n,n); 
F=zeros(n,1);
Fna=F;
Aq{1}=A;
Aq{2}=A;
fe=zeros(2,1);Ae1=zeros(2,2);Ae2=Ae1;
for k=t'    
    h=p(k(2))-p(k(1));
    A(k,k)=A(k,k)+Ae/h; 
    M(k,k)=M(k,k)+h*Me; 
    F(k)=F(k)+h*[0.5; 0.5]; 
    
    x1=p(k(1)); 
    x2=p(k(2)); 
    detJ=(x2-x1)/2;
    Ce=inv([1 x1; 1 x2]);
    a=(x1+x2)/2; 
    b=(x2-x1)/2; 
    xp=a+b*gx;
    
    for i=1:2
        phival=Ce(1,i)+Ce(2,i)*xp; 
        fxg=(xp+2*xp.^2).*phival;
        fe(i)=detJ*gw*fxg';
    end    
    Fna(k)=Fna(k)+fe;

    for i = 1:2        
        for j = 1:2
            phival = Ce(1,i) + Ce(2,i)*xp;
            dphival = Ce(2,i)*ones(1,4);
            phjval = Ce(1,j) + Ce(2,j)*xp;            
            dphjval = Ce(2,j)*ones(1,4);
            fxy1=(xp.^2).*dphival.*dphjval;            
            Ae1(i,j)=detJ*gw*fxy1';
            fxy2=xp.*dphival.*phjval;            
            Ae2(i,j)=detJ*gw*fxy2';
        end
    end
    Aq{1}(k,k) = Aq{1}(k,k) + Ae1;
    Aq{2}(k,k) = Aq{2}(k,k) + Ae2;
end
AAq=Aq;MM=M;
UD=max(1-p,0);
Ftmp{1}=Aq{1}*UD;
Ftmp{2}=Aq{2}*UD;
Ftmp{3}=M*UD;
Lout=zeros(size(p));
in1=find(p==oareadload(1));
in2=find(p==oareadload(2));
Lout(in1:in2)=h;
Lout(in1)=0.5*h;
Lout(in2)=0.5*h;
Lout=Lout/(oareadload(2)-oareadload(1));
sNadd=Lout'*UD;
P=length(muref);
Qa=2;Qm=1;Qf=3;Qu=1;Ql=1;

bnodes=[1 n];
AAq{1}(bnodes,:)=[];AAq{1}(:,bnodes)=[];
AAq{2}(bnodes,:)=[];AAq{2}(:,bnodes)=[];
MM(bnodes,:)=[];MM(:,bnodes)=[];
UD(bnodes)=[];
Ftmp{1}(bnodes)=[];
Ftmp{2}(bnodes)=[];
Ftmp{3}(bnodes)=[];
Lout(bnodes)=[];

addpath('../rbMIT_Aux')
copyfile('../rbMIT_Aux/InsideOutsideD.m',strcat(probname,'_','InsideOutsideD.m'))
copyfile('../rbMIT_Aux/Get_Theta_q.m',strcat(probname,'_','Get_Theta_q.m'))
copyfile('../rbMIT_Aux/Step2_1_coer_noncompliant.m',strcat(probname,'_','Step2_1_coer_noncompliant.m'))
copyfile('../rbMIT_Aux/Step2_2_coer_noncompliant.m',strcat(probname,'_','Step2_2_coer_noncompliant.m'))

VIS.p=p;
VIS.t=t;
VIS.UD=max(1-p,0);
assignin('base',strcat(probname,'_','VIS'),VIS);
save(strcat(probname,'_','VIS'),strcat(probname,'_','VIS'));

PROBDEF.type ='parabolic';
PROBDEF.P = P; 
PROBDEF.probtype = 'HT';
PROBDEF.mu_min = mu_min;
PROBDEF.mu_max = mu_max;
PROBDEF.mu_bar = mu_bar;
PROBDEF.mu_ref = muref;
PROBDEF.Q_affine.a = Qa ; 
PROBDEF.Q_affine.m = Qm ; 
PROBDEF.Q_affine.f = Qf ; 
PROBDEF.Q_affine.u = Qu ;

PROBDEF.Laffsunipos{1}='0.5*mu1^2';
PROBDEF.Laffsunipos{2}='mu2-mu1^2-mu3';
PROBDEF.Raffsunipos{1}='-0.5*mu1^2';
PROBDEF.Raffsunipos{2}='-mu2+mu1^2+mu3';
PROBDEF.Raffsunipos{3}='-mu2+mu1^2+mu3';
PROBDEF.Maffsunipos{1}='1';
PROBDEF.Uaffsunipos{1}='1';
PROBDEF.plotdemo=0;
eval([strcat(probname,'_','pr_PROBDEF') '=PROBDEF;']);
save(strcat(probname,'_','pr_PROBDEF'),strcat(probname,'_','pr_PROBDEF')); 

OFFLINE.FEM.matrix.UD=UD;
OFFLINE.FEM.matrix.Aq{1}=AAq{1};
OFFLINE.FEM.matrix.Aq{2}=AAq{2};
OFFLINE.FEM.matrix.Mq{1}=MM;
OFFLINE.FEM.matrix.Fq{1}=Ftmp{1};
OFFLINE.FEM.matrix.Fq{2}=Ftmp{2};
OFFLINE.FEM.matrix.Fq{3}=Ftmp{3};
OFFLINE.FEM.matrix.Uq{1}=zeros(size(UD));
OFFLINE.FEM.matrix.M_ref = MM; 
OFFLINE.coerlb.failedpoints=[];
if exist('primaltol');
    OFFLINE.space.tol=primaltol;
end
OFFLINE.GREEDY.Offline='offline_parabolic_primal';
OFFLINE.GREEDY.Online='online_parabolic_primal';
OFFLINE.FEM.timestep.dt=dt;
OFFLINE.FEM.timestep.nt=nt;
eval([strcat(probname,'_','pr_OFFLINE') '=OFFLINE;']);
save(strcat(probname,'_','pr_OFFLINE'),strcat(probname,'_','pr_OFFLINE'));

fid = fopen(strcat(probname,'_','Get_Theta_q.m'),'wt');
fprintf(fid,'%% -----rbMIT_System Software Copyright MIT 2006-07-----\n');
fprintf(fid,'%%\n'); 
fprintf(fid,'%%\n');
fprintf(fid,'%% The user agrees to rbMIT_System MIT usage, distribution, and citation terms and conditions \n');
fprintf(fid,'%% described in the License at http://augustine.mit.edu/rbMIT_SystemLicense.htm.\n');
fprintf(fid,'%% rbMIT_System Software PartI_V2\n');
fprintf(fid,'%%\n');
fprintf(fid,'\n');
fprintf(fid,'function [Thetavectorvalue] = Get_Theta_q(DEF, muvectorvalue);\n');
fprintf(fid,'P = %d ; %% $P$, the number of parameters\n',PROBDEF.P);
fprintf(fid,'Qa = %d;\n',PROBDEF.Q_affine.a);
fprintf(fid,'Qf = %d;\n',PROBDEF.Q_affine.f);
fprintf(fid,'nummupts=size(muvectorvalue,1); %% nummupts=M\n');
fprintf(fid,'for m=1:nummupts\n');
for pp=1:PROBDEF.P
fprintf(fid,'    %s = muvectorvalue(m,%d);\n',strcat('mu',num2str(pp)),pp);
end
fprintf(fid,'    %% First compute the Theta_a^q, 1 \\le q \\le Q_a.\n');
for q=1:PROBDEF.Q_affine.a
fprintf(fid,'    Theta_a(1,%d) = %s;\n',q,PROBDEF.Laffsunipos{q});
end
fprintf(fid,'    %% Now compute the Theta_f^q, 1 \\le q \\le Q_f.\n');
for q=1:PROBDEF.Q_affine.f
fprintf(fid,'    Theta_f(1,%d) = %s;\n',q,PROBDEF.Raffsunipos{q});
end
if strcmp(PROBDEF.type,'parabolic')
    fprintf(fid,'    %% Compute the Theta_m^q, 1 \\le q \\le Q_m.\n');
    for q=1:PROBDEF.Q_affine.m
    fprintf(fid,'    Theta_m(1,%d) = %s;\n',q,PROBDEF.Maffsunipos{q});
    end
    for q=1:PROBDEF.Q_affine.u
    fprintf(fid,'    Theta_u(1,%d) = %s;\n',q,PROBDEF.Uaffsunipos{q});
    end
    fprintf(fid,'    Thetavectorvalue(m,:) = [Theta_a, Theta_f, Theta_m, Theta_u];\n');
else
    fprintf(fid,'    Thetavectorvalue(m,:) = [Theta_a, Theta_f];\n');
end
fprintf(fid,'end\n');
fclose(fid);

fid = fopen('addout.m','wt');
fprintf(fid,'%% -----rbMIT_System Software Copyright MIT 2006-07-----\n');
fprintf(fid,'%%\n');
fprintf(fid,'%%\n');
fprintf(fid,'%% The user agrees to rbMIT_System MIT usage, distribution, and citation terms and conditions \n');
fprintf(fid,'%% described in the License at http://augustine.mit.edu/rbMIT_SystemLicense.htm.\n');
fprintf(fid,'%% rbMIT_System Software PartI_SV1\n');
fprintf(fid,'%%\n');
fprintf(fid,'\n');
fprintf(fid,'function [sNadd] = addout(mu);\n');
fprintf(fid,'sNadd = %d;\n',sNadd); 
fclose(fid);


mkdir(outputname)
cd(outputname);
addpath('../../rbMIT_Aux')
addpath('../../rbMIT_Library')
addpath('../../rbMIT_Library/symbolic')
addpath('../../rbMIT_Library/parabolic')
copyfile('../../rbMIT_Aux/Get_Theta_q.m',strcat(probname,'_',outputname,'_','Get_Theta_q.m'))
copyfile('../../rbMIT_Aux/addout.m',strcat(probname,'_',outputname,'_','addout.m'))
copyfile(strcat('../',probname,'_','InsideOutsideD.m'),strcat(probname,'_','InsideOutsideD.m'))
copyfile(strcat('../',probname,'_','Get_Theta_q.m'),strcat(probname,'_','Get_Theta_q.m'))
copyfile('../../rbMIT_Aux/output_Step2_2_coer_noncompliant.m',strcat(probname,'_',outputname,'_','Step2_2_coer_noncompliant.m'))
 
du_PROBDEF.Q_affine.l = Ql;
du_PROBDEF.Oaffsunipos{1}='1';
du_PROBDEF.dirfluxflag = 0;
du_PROBDEF.outcoeffs = 0; 
eval([strcat(probname,'_',outputname,'_','du_PROBDEF') '=du_PROBDEF;']);
save(strcat(probname,'_',outputname,'_','du_PROBDEF'),strcat(probname,'_',outputname,'_','du_PROBDEF')); % save *PROBNAME_du_PROBDEF structure to file *PROBNAME_du_PROBDEF.mat

du_OFFLINE.FEM.matrix.Lq{1}=Lout;
du_OFFLINE.FEM.timestep.dt=dt;
du_OFFLINE.FEM.timestep.nt=nt;
du_OFFLINE.GREEDY.Offline='offline_parabolic_dual';
du_OFFLINE.GREEDY.Online='online_parabolic_dual';
if exist('dualtol');
   du_OFFLINE.space.tol=dualtol;
end
eval([strcat(probname,'_',outputname,'_','du_OFFLINE') '=du_OFFLINE;']);
du_ONLINE.space = [ ];
eval([strcat(probname,'_',outputname,'_','du_ONLINE') '=du_ONLINE;']);
save(strcat(probname,'_',outputname,'_','du_OFFLINE'),strcat(probname,'_',outputname,'_','du_OFFLINE'),strcat(probname,'_',outputname,'_','du_ONLINE')) % save *PROBNAME_du_OFFLINE structure (so far) to file *PROBNAME_du_OFFLINE.mat

fid = fopen(strcat(probname,'_',outputname,'_','Get_Theta_q.m'),'wt');
fprintf(fid,'%% -----rbMIT_System Software Copyright MIT 2006-07-----\n');
fprintf(fid,'%%\n'); 
fprintf(fid,'%%\n');
fprintf(fid,'%% The user agrees to rbMIT_System MIT usage, distribution, and citation terms and conditions \n');
fprintf(fid,'%% described in the License at http://augustine.mit.edu/rbMIT_SystemLicense.htm.\n');
fprintf(fid,'%% rbMIT_System Software PartI_SV1\n');
fprintf(fid,'%%\n');
fprintf(fid,'\n');
fprintf(fid,'function [Thetavectorvalue] = Get_Theta_q(DEF, muvectorvalue);\n');
fprintf(fid,'P = %d ; %% $P$, the number of parameters\n',PROBDEF.P);
fprintf(fid,'Qa = %d;\n',PROBDEF.Q_affine.a);
fprintf(fid,'Qf = %d;\n',PROBDEF.Q_affine.f);
fprintf(fid,'nummupts=size(muvectorvalue,1); %% nummupts=M\n');
fprintf(fid,'for m=1:nummupts\n');
for pp=1:PROBDEF.P
fprintf(fid,'    %s = muvectorvalue(m,%d);\n',strcat('mu',num2str(pp)),pp);
end
fprintf(fid,'    %% Compute the Theta_l^q, 1 \\le q \\le Q_l.\n');
for q=1:du_PROBDEF.Q_affine.l
fprintf(fid,'    Theta_l(1,%d) = %s;\n',q,du_PROBDEF.Oaffsunipos{q});
end
fprintf(fid,'    Thetavectorvalue(m,:) = [Theta_l];\n');
fprintf(fid,'end\n');
fclose(fid);

fid = fopen(strcat(probname,'_',outputname,'_','addout.m'),'wt');
fprintf(fid,'%% -----rbMIT_System Software Copyright MIT 2006-07-----\n');
fprintf(fid,'%%\n');
fprintf(fid,'%%\n');
fprintf(fid,'%% The user agrees to rbMIT_System MIT usage, distribution, and citation terms and conditions \n');
fprintf(fid,'%% described in the License at http://augustine.mit.edu/rbMIT_SystemLicense.htm.\n');
fprintf(fid,'%% rbMIT_System Software PartI_SV1\n');
fprintf(fid,'%%\n');
fprintf(fid,'\n');
fprintf(fid,'function [sNadd] = addout(mu);\n');
fprintf(fid,'P = %d ; %% $P$, the number of parameters\n',PROBDEF.P);
fprintf(fid,'Ql = %d;\n',du_PROBDEF.Q_affine.l);
for pp=1:PROBDEF.P
    fprintf(fid,'    %s = mu(%d);\n',strcat('mu',num2str(pp)),pp);
end
fprintf(fid,' sNadd = 0;\n');
for q=1:du_PROBDEF.Q_affine.l
    fprintf(fid,'    sNadd = sNadd + (%s )* %d;\n',du_PROBDEF.Oaffsunipos{q},du_PROBDEF.outcoeffs(q)); % atp-4/23 without parentheses evaluated to wrong quantity!
end
fclose(fid);

cd('..');
