function s_out = FEeval(probname,outputname,mu,plotflag)
% -----rbMIT Software Copyright MIT 2006-07----
%  DBP  Huynh,NC Nguyen, AT Patera, G Rozza
% Henceforth, Software shall refer to the rbMIT_System software package: 
% the contents of the rbMIT_Library and rbMIT_Aux folders.
% 
% This License governs use of all accompanying Software, and your download and/or use of the Software constitutes acceptance 
% of this License.
% 
% You may use this Software for any non-commercial purpose, subject to the restrictions in this license. 
% Some purposes which can be non-commercial are teaching and academic research.
% 
% You may not use or distribute this Software or any derivative works in any form for commercial purposes. 
% Examples of commercial purposes would be licensing, leasing, or selling the Software, or distributing the 
% Software for use with commercial products.
% 
% You may modify this Software and distribute the modified Software for non-commercial purposes,
%  however, you may not grant rights to the Software or derivative works that are broader than those 
% provided by this License. For example, you may not distribute modifications of the Software under terms 
% that would permit commercial use.
% 
% In return, we require that you agree:
% 
% not to remove any copyright or other notices from the Software;
% 
% that if you distribute the Software in source or object form, you will include a verbatim copy of this license;
% 
% that if you distribute derivative works of the Software in source code form you do so only under a license
% that includes all of the provisions of this License, and if you distribute derivative works of the Software solely 
% in object form you do so only under a license that complies with this License;
% 
% that if you have modified the Software or created derivative works, and distribute such modifications or derivative
% works, you will cause the modified files to carry prominent notices so that recipients know that they are not receiving the original Software;
% 
% THAT THE SOFTWARE COMES "AS IS", WITH NO WARRANTIES: THIS MEANS NO EXPRESS, IMPLIED OR STATUTORY WARRANTY, 
% INCLUDING WITHOUT LIMITATION WARRANTIES OF MERCHANTABILITY OR FITNESS FOR A PARTICULAR PURPOSE OR ANY WARRANTY 
% OF TITLE OR NON-INFRINGEMENT; YOU MUST PASS THIS DISCLAIMER ON WHENEVER YOU DISTRIBUTE THE SOFTWARE OR DERIVATIVE WORKS;
% 
% THAT NEITHER MIT NOR THE AUTHORS WILL BE LIABLE FOR ANY DAMAGES RELATED TO THE SOFTWARE OR THIS LICENSE, 
% INCLUDING DIRECT, INDIRECT, SPECIAL, CONSEQUENTIAL OR INCIDENTAL DAMAGES; YOU MUST PASS THIS LIMITATION OF LIABILITY 
% ON WHENEVER YOU DISTRIBUTE THE SOFTWARE OR DERIVATIVE WORKS;
% 
% that your rights under the License end automatically if you breach the License in any way;
% 
% that MIT reserves all rights not expressly granted to you in this License.
% 
% (Note: The wording of this license agreement is derived from a Microsoft Shared Source license agreement.)
% 
% License at http://augustine.mit.edu/rbMIT_SystemLicense.htm.
%
% rbMIT Software Part_II_and_IV
%
% ---------- 
currentCD = cd;
rootCD = which('symbolicprimal'); rootCD = rootCD(1:end-39); % chop out the 'rbMIT_Library\symbolic\symbolicprimal.m' part
cd(strcat(rootCD,probname));

if not(exist('plotflag'))
    plotflag = 0;
end

load(strcat(probname,'_','pr_PROBDEF'));
load(strcat(probname,'_','pr_OFFLINE'));
munum = size(mu,1);
eval(strcat('pr_PROBDEF = ',strcat(probname,'_','pr_PROBDEF'),';') );
eval(strcat('pr_OFFLINE = ',strcat(probname,'_','pr_OFFLINE'),';') );
if (plotflag) && (munum == 1) 
    load(strcat(probname,'_','SYMB'));
end
P = pr_PROBDEF.P;
Qa = pr_PROBDEF.Q_affine.a;
Qf = pr_PROBDEF.Q_affine.f;
eval( strcat('Thetavectorvalue =',probname,'_Get_Theta_q(pr_PROBDEF,mu);') );
Thetaq(:,1:Qa) = Thetavectorvalue(:,1:Qa);
Thetaf(:,1:Qf) = Thetavectorvalue(:,Qa+1:Qa+Qf);
if strcmp(pr_PROBDEF.type,'parabolic')==1
    dt=pr_OFFLINE.FEM.timestep.dt;
    nt=pr_OFFLINE.FEM.timestep.nt;
    Qm=pr_PROBDEF.Q_affine.m;
    Qu=pr_PROBDEF.Q_affine.u;
    ct=ones(1,nt); % unity constant control
    theta_m(:,1:Qm) = Thetavectorvalue(:,Qa+Qf+1:(Qa+Qf+Qm));
    theta_u(:,1:Qu) = Thetavectorvalue(:,(1+Qa+Qf+Qm):(Qa+Qf+Qm+Qu));
end

cd(outputname);
load(strcat(probname,'_',outputname,'_','du_PROBDEF'));
load(strcat(probname,'_',outputname,'_','du_OFFLINE'));
eval(strcat('du_PROBDEF = ',strcat(probname,'_',outputname,'_','du_PROBDEF;')));
eval(strcat('du_OFFLINE = ',strcat(probname,'_',outputname,'_','du_OFFLINE;')));
Ql = du_PROBDEF.Q_affine.l;
eval( strcat('Thetavectorvalue =',probname,'_',outputname,'_','Get_Theta_q(du_PROBDEF,mu);') );
Thetal(:,1:Ql) = Thetavectorvalue(:,1:Ql);


for imu = 1:munum
 
    K = 0*pr_OFFLINE.FEM.matrix.Aq{1};
    for q = 1:Qa
        K = K + Thetaq(imu,q)*pr_OFFLINE.FEM.matrix.Aq{q};
    end;
    F = 0*pr_OFFLINE.FEM.matrix.Fq{1};
    for q = 1:Qf
        F = F + Thetaf(imu,q)*pr_OFFLINE.FEM.matrix.Fq{q};
    end;
    
    clear u;
    if strcmp(pr_PROBDEF.type,'parabolic')==1
        M = 0*pr_OFFLINE.FEM.matrix.Mq{1};
        for q=1:Qm
            M = M + theta_m(imu,q)*pr_OFFLINE.FEM.matrix.Mq{q};
        end
        u0 = 0*pr_OFFLINE.FEM.matrix.Uq{1};
        for q=1:Qu
            u0 = u0 + theta_u(imu,q)*pr_OFFLINE.FEM.matrix.Uq{q};
        end        
        A=M+(dt)*K;
        for i=1:nt    
            if i==1
                u(:,i)=A\(M*u0+(ct(i)*dt)*F);
            else
                u(:,i)=A\(M*u(:,i-1)+(ct(i)*dt)*F); 
            end    
        end        
    else
        u = K\F;
    end
    
    if (plotflag) && (munum == 1)
        if strcmp(pr_PROBDEF.type,'parabolic')==1
            uu = Btmp*u(:,end) + uDIR;
        else
            uu = Btmp*u + uDIR;
        end
        % calculate new nodes locations and plot
        for i = 1:numdoms
            temp = Gaffs(i,:);
            for j = 1:P
                temp = subs(temp,strcat('mu',num2str(j)),mu(j));
            end
            Gaffsreal(i,:) = temp;
            temp = Caffs(i,:);
            for j = 1:P
                temp = subs(temp,strcat('mu',num2str(j)),mu(j));
            end
            Caffsreal(i,:) = temp;
        end
        ps = zeros(size(p,2),1);
        for i = 1:size(t,2)
            ps(t([1,2,3],i)) = t(4,i)*ones(3,1);
        end
        for i = 1:size(p,2)
            pmu(:,i) = [Gaffsreal(ps(i),1),Gaffsreal(ps(i),2);Gaffsreal(ps(i),3),Gaffsreal(ps(i),4)]*p(:,i)+[Caffsreal(ps(i),1);Caffsreal(ps(i),2)];
        end
        
        if strcmp(pr_PROBDEF.probtype(1:2),'LE')
            urs = reshape(uu,length(uu)/2,2);
            ud = pmu + urs'/max(abs(uu))/3;
        else
            ud = pmu;
        end
        num_dim=size(uu,1)/size(pmu,2);
        figure(1);
        pdemesh(ud,e,t);
        axis tight; axis equal;
        for k=1:num_dim
            figure(2+k);
            pdesurf(ud,t,uu((k-1)*size(pmu,2)+1:k*size(pmu,2)));
            axis tight;
            axis equal;
        end
    end
    
    eval(strcat('s_add =',probname,'_',outputname,'_','addout(mu(imu,:));'));

    L = 0*du_OFFLINE.FEM.matrix.Lq{1};
    for q = 1:Ql
        L = L + Thetal(imu,q)*du_OFFLINE.FEM.matrix.Lq{q};
    end;
    
    s(imu,:) = L'*u;
    s_out(imu,:) = s(imu,:) + s_add;
end

cd(currentCD);



% function s_out = FEeval(probname,outputname,mu,plotflag)
% 
% currentCD = cd;
% rootCD = which('symbolicprimal'); rootCD = rootCD(1:end-39); % chop out the 'rbMIT_Library\symbolic\symbolicprimal.m' part
% cd(strcat(rootCD,probname));
% 
% if not(exist('plotflag'))
%     plotflag = 0;
% end
% 
% load(strcat(probname,'_','pr_PROBDEF'));
% load(strcat(probname,'_','pr_OFFLINE'));
% munum = size(mu,1);
% eval(strcat('pr_PROBDEF = ',strcat(probname,'_','pr_PROBDEF'),';') );
% eval(strcat('pr_OFFLINE = ',strcat(probname,'_','pr_OFFLINE'),';') );
% if (plotflag) && (munum == 1) 
%     load(strcat(probname,'_','SYMB'));
% end
% P = pr_PROBDEF.P;
% Qa = pr_PROBDEF.Q_affine.a;
% Qf = pr_PROBDEF.Q_affine.f;
% eval( strcat('Thetavectorvalue =',probname,'_Get_Theta_q(pr_PROBDEF,mu);') );
% Thetaq(:,1:Qa) = Thetavectorvalue(:,1:Qa);
% Thetaf(:,1:Qf) = Thetavectorvalue(:,Qa+1:Qa+Qf);
% if strcmp(pr_PROBDEF.type,'parabolic')==1
%     dt=pr_OFFLINE.FEM.timestep.dt;
%     nt=pr_OFFLINE.FEM.timestep.nt;
%     Qm=pr_PROBDEF.Q_affine.m;
%     Qu=pr_PROBDEF.Q_affine.u;
%     ct=ones(1,nt); % unity constant control
%     theta_m(:,1:Qm) = Thetavectorvalue(:,Qa+Qf+1:(Qa+Qf+Qm));
%     theta_u(:,1:Qu) = Thetavectorvalue(:,(1+Qa+Qf+Qm):(Qa+Qf+Qm+Qu));
% end
% 
% cd(outputname);
% load(strcat(probname,'_',outputname,'_','du_PROBDEF'));
% load(strcat(probname,'_',outputname,'_','du_OFFLINE'));
% eval(strcat('du_PROBDEF = ',strcat(probname,'_',outputname,'_','du_PROBDEF;')));
% eval(strcat('du_OFFLINE = ',strcat(probname,'_',outputname,'_','du_OFFLINE;')));
% Ql = du_PROBDEF.Q_affine.l;
% eval( strcat('Thetavectorvalue =',probname,'_',outputname,'_','Get_Theta_q(du_PROBDEF,mu);') );
% Thetal(:,1:Ql) = Thetavectorvalue(:,1:Ql);
% 
% for imu = 1:munum
%  
%     K = 0*pr_OFFLINE.FEM.matrix.Aq{1};
%     for q = 1:Qa
%         K = K + Thetaq(imu,q)*pr_OFFLINE.FEM.matrix.Aq{q};
%     end;
%     F = 0*pr_OFFLINE.FEM.matrix.Fq{1};
%     for q = 1:Qf
%         F = F + Thetaf(imu,q)*pr_OFFLINE.FEM.matrix.Fq{q};
%     end
%     if strcmp(pr_PROBDEF.type,'parabolic')==1
%         M = theta_m(imu,1)*pr_OFFLINE.FEM.matrix.Mq{1};
%         for q=2:Qm
%             M = M + theta_m(imu,q)*pr_OFFLINE.FEM.matrix.Mq{q};
%         end
%         u0 = theta_u(imu,1)*pr_OFFLINE.FEM.matrix.Uq{1};
%         for q=2:Qu
%             u0 = u0 + theta_u(imu,q)*pr_OFFLINE.FEM.matrix.Uq{q};
%         end        
%         A=M+(dt)*K;
%         for i=1:nt    
%             if i==1
%                 u(:,i)=A\(M*u0+(ct(i)*dt)*F);
%             else
%                 u(:,i)=A\(M*u(:,i-1)+(ct(i)*dt)*F); 
%             end    
%         end        
%     else
%         u = K\F;
%     end
% 
% 
%     if (plotflag) && (munum == 1)
%         if strcmp(pr_PROBDEF.type,'parabolic')==1
%             uu = Btmp*u(:,end) + uDIR;
%         else
%             uu = Btmp*u + uDIR;
%         end
%         % calculate new nodes locations and plot
%         for i = 1:numdoms
%             temp = Gaffs(i,:);
%             for j = 1:P
%                 temp = subs(temp,strcat('mu',num2str(j)),mu(j));
%             end
%             Gaffsreal(i,:) = temp;
%             temp = Caffs(i,:);
%             for j = 1:P
%                 temp = subs(temp,strcat('mu',num2str(j)),mu(j));
%             end
%             Caffsreal(i,:) = temp;
%         end
%         ps = zeros(size(p,2),1);
%         for i = 1:size(t,2)
%             ps(t([1,2,3],i)) = t(4,i)*ones(3,1);
%         end
%         for i = 1:size(p,2)
%             pmu(:,i) = [Gaffsreal(ps(i),1),Gaffsreal(ps(i),2);Gaffsreal(ps(i),3),Gaffsreal(ps(i),4)]*p(:,i)+[Caffsreal(ps(i),1);Caffsreal(ps(i),2)];
%         end
%         
%         if strcmp(pr_PROBDEF.probtype(1:2),'LE')
%             urs = reshape(uu,length(uu)/2,2);
%             ud = pmu + urs'/max(abs(uu))/3;
%         else
%             ud = pmu;
%         end
%         num_dim=size(uu,1)/size(pmu,2);
%         figure(1);
%         pdemesh(ud,e,t);
%         for k=1:num_dim
%             figure(2+k);
%             pdesurf(ud,t,uu((k-1)*size(pmu,2)+1:k*size(pmu,2)));
%             axis tight;
%             axis equal;
%         end
%     end
%     
%     eval(strcat('s_add =',probname,'_',outputname,'_','addout(mu);'));
% 
%     L = 0*du_OFFLINE.FEM.matrix.Lq{1};
%     for q = 1:Ql
%         L = L + Thetal(imu,q)*du_OFFLINE.FEM.matrix.Lq{q};
%     end;
%     s(imu,1) = L'*u;
%     s_out(imu,1) = s(imu,1) + s_add;
% end
% 
% cd(currentCD);