function Wutils(probname)
% -----rbMIT Software Copyright MIT 2006-07----
%  DBP  Huynh,NC Nguyen, AT Patera, G Rozza
% Henceforth, Software shall refer to the rbMIT_System software package: 
% the contents of the rbMIT_Library and rbMIT_Aux folders.
% 
% This License governs use of all accompanying Software, and your download and/or use of the Software constitutes acceptance 
% of this License.
% 
% You may use this Software for any non-commercial purpose, subject to the restrictions in this license. 
% Some purposes which can be non-commercial are teaching and academic research.
% 
% You may not use or distribute this Software or any derivative works in any form for commercial purposes. 
% Examples of commercial purposes would be licensing, leasing, or selling the Software, or distributing the 
% Software for use with commercial products.
% 
% You may modify this Software and distribute the modified Software for non-commercial purposes,
%  however, you may not grant rights to the Software or derivative works that are broader than those 
% provided by this License. For example, you may not distribute modifications of the Software under terms 
% that would permit commercial use.
% 
% In return, we require that you agree:
% 
% not to remove any copyright or other notices from the Software;
% 
% that if you distribute the Software in source or object form, you will include a verbatim copy of this license;
% 
% that if you distribute derivative works of the Software in source code form you do so only under a license
% that includes all of the provisions of this License, and if you distribute derivative works of the Software solely 
% in object form you do so only under a license that complies with this License;
% 
% that if you have modified the Software or created derivative works, and distribute such modifications or derivative
% works, you will cause the modified files to carry prominent notices so that recipients know that they are not receiving the original Software;
% 
% THAT THE SOFTWARE COMES "AS IS", WITH NO WARRANTIES: THIS MEANS NO EXPRESS, IMPLIED OR STATUTORY WARRANTY, 
% INCLUDING WITHOUT LIMITATION WARRANTIES OF MERCHANTABILITY OR FITNESS FOR A PARTICULAR PURPOSE OR ANY WARRANTY 
% OF TITLE OR NON-INFRINGEMENT; YOU MUST PASS THIS DISCLAIMER ON WHENEVER YOU DISTRIBUTE THE SOFTWARE OR DERIVATIVE WORKS;
% 
% THAT NEITHER MIT NOR THE AUTHORS WILL BE LIABLE FOR ANY DAMAGES RELATED TO THE SOFTWARE OR THIS LICENSE, 
% INCLUDING DIRECT, INDIRECT, SPECIAL, CONSEQUENTIAL OR INCIDENTAL DAMAGES; YOU MUST PASS THIS LIMITATION OF LIABILITY 
% ON WHENEVER YOU DISTRIBUTE THE SOFTWARE OR DERIVATIVE WORKS;
% 
% that your rights under the License end automatically if you breach the License in any way;
% 
% that MIT reserves all rights not expressly granted to you in this License.
% 
% (Note: The wording of this license agreement is derived from a Microsoft Shared Source license agreement.)
% 
% License at http://augustine.mit.edu/rbMIT_SystemLicense.htm.
%
% rbMIT Software Part_II_and_IV
%
% ---------- 
load(strcat(probname,'_SYMB'));

figure(1);
hold on;
axis equal;
for i = 1:numdoms
%     triplot(nodemap(i,:),preal(:,1),preal(:,2),'r');
    geoplot(probname,muref);
    pcen = sum(preal(nodemap(i,:),:))/3;
    text(pcen(1),pcen(2),num2str(i));
end
hold off;

for i = 1:Qa
    Qa_tex{i} = gencompfunc(probtype,i,numdoms,numnload,numnloadgroup,Lsepcoeff,Boolecoeff,1000);
        
    tmp = latex(sym(Laffsunipos{i}));
    for p = 1:P
%         tmp = regexprep(tmp, strcat('mu',num2str(p)),strcat('\\mu_',num2str(p)));
        tmp = regexprep(tmp, strcat('{\\it mu',num2str(p),'}'), strcat('\\mu_',num2str(p)));
    end
%     tmp = regexprep(tmp,'\\frac','\\dfrac');
    Qa_fun{i} = tmp;
    
    tmp = latex(vpa(sym(Laffsunipos{i}),8));
    for p = 1:P
%         tmp = regexprep(tmp, strcat('mu',num2str(p)),strcat('\\mu_',num2str(p)));
        tmp = regexprep(tmp, strcat('{\\it mu',num2str(p),'}'), strcat('\\mu_',num2str(p)));
    end
%     tmp = regexprep(tmp,'\\frac','\\dfrac');
    Qa_fun_frac{i} = tmp;    
end

fid = fopen(strcat(probname,'_','Theta_q_latex.tex'),'wt');
fprintf(fid,'\\documentclass{article}\n');
fprintf(fid,'\\begin{document}\n');
fprintf(fid,'\\begin{tabular}{|c|c|l|} \n');
fprintf(fid,'\\hline \n');
fprintf(fid,'$q$ & $\\Theta_q^{a}(\\mu)$ & $a_q(w,v)$\\\\ \n');
fprintf(fid,'\\hline \\hline \n');
for i = 1:Qa
    fprintf(fid,'$%s$ & $%s$ & $%s$ \\\\ \n',num2str(i),Qa_fun{i},Qa_tex{i});
end
fprintf(fid,'\\hline \n');
fprintf(fid,'\\end{tabular} \n');

fprintf(fid,'\n-------------------------\n');
fprintf(fid,'---real number tabular---\n');
fprintf(fid,'-------------------------\n \n');

fprintf(fid,'\\begin{tabular}{|c|c|l|} \n');
fprintf(fid,'\\hline \n');
fprintf(fid,'$q$ & $\\Theta_q^{a}(\\mu)$ & $a_q(w,v)$\\\\ \n');
fprintf(fid,'\\hline \\hline \n');
for i = 1:Qa
    fprintf(fid,'$%s$ & $%s$ & $%s$ \\\\ \n',num2str(i),Qa_fun_frac{i},Qa_tex{i});
end
fprintf(fid,'\\hline \n');
fprintf(fid,'\\end{tabular} \n');
fprintf(fid,'\\end{document}\n');
fclose(fid);

pdflatex(strcat(probname,'_','Theta_q_latex.tex'));
system(strcat(probname,'_','Theta_q_latex.pdf'));