
% -----rbMIT Software Copyright MIT 2006-07----
%  DBP  Huynh,NC Nguyen, AT Patera, G Rozza
% Henceforth, Software shall refer to the rbMIT_System software package: 
% the contents of the rbMIT_Library and rbMIT_Aux folders.
% 
% This License governs use of all accompanying Software, and your download and/or use of the Software constitutes acceptance 
% of this License.
% 
% You may use this Software for any non-commercial purpose, subject to the restrictions in this license. 
% Some purposes which can be non-commercial are teaching and academic research.
% 
% You may not use or distribute this Software or any derivative works in any form for commercial purposes. 
% Examples of commercial purposes would be licensing, leasing, or selling the Software, or distributing the 
% Software for use with commercial products.
% 
% You may modify this Software and distribute the modified Software for non-commercial purposes,
%  however, you may not grant rights to the Software or derivative works that are broader than those 
% provided by this License. For example, you may not distribute modifications of the Software under terms 
% that would permit commercial use.
% 
% In return, we require that you agree:
% 
% not to remove any copyright or other notices from the Software;
% 
% that if you distribute the Software in source or object form, you will include a verbatim copy of this license;
% 
% that if you distribute derivative works of the Software in source code form you do so only under a license
% that includes all of the provisions of this License, and if you distribute derivative works of the Software solely 
% in object form you do so only under a license that complies with this License;
% 
% that if you have modified the Software or created derivative works, and distribute such modifications or derivative
% works, you will cause the modified files to carry prominent notices so that recipients know that they are not receiving the original Software;
% 
% THAT THE SOFTWARE COMES "AS IS", WITH NO WARRANTIES: THIS MEANS NO EXPRESS, IMPLIED OR STATUTORY WARRANTY, 
% INCLUDING WITHOUT LIMITATION WARRANTIES OF MERCHANTABILITY OR FITNESS FOR A PARTICULAR PURPOSE OR ANY WARRANTY 
% OF TITLE OR NON-INFRINGEMENT; YOU MUST PASS THIS DISCLAIMER ON WHENEVER YOU DISTRIBUTE THE SOFTWARE OR DERIVATIVE WORKS;
% 
% THAT NEITHER MIT NOR THE AUTHORS WILL BE LIABLE FOR ANY DAMAGES RELATED TO THE SOFTWARE OR THIS LICENSE, 
% INCLUDING DIRECT, INDIRECT, SPECIAL, CONSEQUENTIAL OR INCIDENTAL DAMAGES; YOU MUST PASS THIS LIMITATION OF LIABILITY 
% ON WHENEVER YOU DISTRIBUTE THE SOFTWARE OR DERIVATIVE WORKS;
% 
% that your rights under the License end automatically if you breach the License in any way;
% 
% that MIT reserves all rights not expressly granted to you in this License.
% 
% (Note: The wording of this license agreement is derived from a Microsoft Shared Source license agreement.)
% 
% License at http://augustine.mit.edu/rbMIT_SystemLicense.htm.
%
% rbMIT Software Part_II_and_IV
%
% ---------- 
% figure

curvyres = 10;
numgeodr = length(geometry);
x1min = min(preal(:,1));
x2min = min(preal(:,2));
x1max = max(preal(:,1));
x2max = max(preal(:,2));
x1len = x1max - x1min;
x2len = x2max - x2min;
x1minb = x1min - .1*x1len;
x1maxb = x1max + .1*x1len;
x2minb = x2min - .1*x2len;
x2maxb = x2max + .1*x2len;
plot([x1minb,x1maxb,x1maxb,x1minb,x1minb],[x2minb,x2minb,x2maxb,x2maxb,x2minb],'k-','Linewidth',3);
hold on
for igdr = 1:numgeodr
    numeddr = size(geometry{igdr},2);
    for iedr = 1:numeddr
        eddr = geometry{igdr}(iedr);
        if(tedgeval(eddr,1) == 0)
            x1pt = [preal(edge(eddr,1),1),preal(edge(eddr,2),1)];
            x2pt = [preal(edge(eddr,1),2),preal(edge(eddr,2),2)];
            plot(x1pt,x2pt,'b-','Linewidth',1);
        else;
            labdraw = double(tedgeval(eddr,1));
            dtdraw = double((tedgeval(eddr,3) - tedgeval(eddr,2)))/curvyres;
            for itdraw = 1:curvyres;
                tvalr1 = double(tedgeval(eddr,2)) + (itdraw-1)*dtdraw;
                tvalr2 = tvalr1 + dtdraw;
                xfirstptsym = simplify(subs(curvedatsym{labdraw}.gfun,'t',tvalr1));
                xsecondptsym = simplify(subs(curvedatsym{labdraw}.gfun,'t',tvalr2));
                x1ptsym = [xfirstptsym(1),xsecondptsym(1)];
                x2ptsym = [xfirstptsym(2),xsecondptsym(2)];
                tmp1 = x1ptsym;
                tmp2 = x2ptsym;
                for i = 1:P
                    tmp1 = subs(tmp1,strcat('mu',num2str(i)),muref(i),0); %phuong 2/2/09
                    tmp2 = subs(tmp2,strcat('mu',num2str(i)),muref(i),0); %phuong 2/2/09
                end;
                plot(tmp1,tmp2,'b-','Linewidth',1);
            end;
        end;
    end;
end;
hold on; plot(preal(:,1),preal(:,2),'ko'); hold off;
