% -----rbMIT Software Copyright MIT 2006-07----
%  DBP  Huynh,NC Nguyen, AT Patera, G Rozza
% Henceforth, Software shall refer to the rbMIT_System software package: 
% the contents of the rbMIT_Library and rbMIT_Aux folders.
% 
% This License governs use of all accompanying Software, and your download and/or use of the Software constitutes acceptance 
% of this License.
% 
% You may use this Software for any non-commercial purpose, subject to the restrictions in this license. 
% Some purposes which can be non-commercial are teaching and academic research.
% 
% You may not use or distribute this Software or any derivative works in any form for commercial purposes. 
% Examples of commercial purposes would be licensing, leasing, or selling the Software, or distributing the 
% Software for use with commercial products.
% 
% You may modify this Software and distribute the modified Software for non-commercial purposes,
%  however, you may not grant rights to the Software or derivative works that are broader than those 
% provided by this License. For example, you may not distribute modifications of the Software under terms 
% that would permit commercial use.
% 
% In return, we require that you agree:
% 
% not to remove any copyright or other notices from the Software;
% 
% that if you distribute the Software in source or object form, you will include a verbatim copy of this license;
% 
% that if you distribute derivative works of the Software in source code form you do so only under a license
% that includes all of the provisions of this License, and if you distribute derivative works of the Software solely 
% in object form you do so only under a license that complies with this License;
% 
% that if you have modified the Software or created derivative works, and distribute such modifications or derivative
% works, you will cause the modified files to carry prominent notices so that recipients know that they are not receiving the original Software;
% 
% THAT THE SOFTWARE COMES "AS IS", WITH NO WARRANTIES: THIS MEANS NO EXPRESS, IMPLIED OR STATUTORY WARRANTY, 
% INCLUDING WITHOUT LIMITATION WARRANTIES OF MERCHANTABILITY OR FITNESS FOR A PARTICULAR PURPOSE OR ANY WARRANTY 
% OF TITLE OR NON-INFRINGEMENT; YOU MUST PASS THIS DISCLAIMER ON WHENEVER YOU DISTRIBUTE THE SOFTWARE OR DERIVATIVE WORKS;
% 
% THAT NEITHER MIT NOR THE AUTHORS WILL BE LIABLE FOR ANY DAMAGES RELATED TO THE SOFTWARE OR THIS LICENSE, 
% INCLUDING DIRECT, INDIRECT, SPECIAL, CONSEQUENTIAL OR INCIDENTAL DAMAGES; YOU MUST PASS THIS LIMITATION OF LIABILITY 
% ON WHENEVER YOU DISTRIBUTE THE SOFTWARE OR DERIVATIVE WORKS;
% 
% that your rights under the License end automatically if you breach the License in any way;
% 
% that MIT reserves all rights not expressly granted to you in this License.
% 
% (Note: The wording of this license agreement is derived from a Microsoft Shared Source license agreement.)
% 
% License at http://augustine.mit.edu/rbMIT_SystemLicense.htm.
%
% rbMIT Software Part_II_and_IV
%
% ---------- 

opts = optimset('TolFun',1e-12,'TolX',1e-12,'Display','off');
Ntp = 5; % number of initial points for nonlinear solver
nlsolver = 1;
if (double(tedgeval(geometry{igeo}(ie),1))>0)
    for j = 1:size(edge_list_unique,1)
        % check if j^th edge is a straight line
        flag1 = ismember(edge_list_unique(j,[1,2]),edge(find(double(tedgeval(:,1))>0),:),'rows');
        flag2 = ismember(edge_list_unique(j,[2,1]),edge(find(double(tedgeval(:,1))>0),:),'rows');
        % check collision by solving for alpha/theta symbolically
        % [c_1 + a*cos(theta) = x1 + alpha(x2-x1); c_2 + b*sin(theta) = y1 + alpha(y2-y1)]
        if ((flag1 + flag2) == 0)
            % solve for alpha
            tmp = [];
            x = preal(edge_list_unique(j,:),:);
            tmp1 = curvedat(double(tedgeval(geometry{igeo}(ie),1)),:);
            tmp2 = double(tedgeval(geometry{igeo}(ie),2:3));
            
            switch nlsolver
                case 0
                    % nlsolver = 0 (symbolic solver, work for circles/ellipses)
                    % "solve" approach
                    eqn1 = strcat(char(tmp1(1)),' = ',num2str(x(1,1)),'+(',num2str(x(2,1)-x(1,1)),')*alpha');
                    eqn2 = strcat(char(tmp1(2)),' = ',num2str(x(1,2)),'+(',num2str(x(2,2)-x(1,2)),')*alpha');
                    tmpS = solve(eqn1,eqn2);
                    for i = 1:size(tmpS.t)
                        tmpsolve(i,:) = [double(tmpS.t(i)),double(tmpS.alpha(i))];
                    end
                    tmp = sym(tmpsolve);
                case 1
                    % nlsolver = 1 (nonlinear solver, work for all cases but pretty slow)
                    % "fsolve" approach
                    eqn1 = strcat(char(subs(tmp1(1),'t','x(1)')),' - ',num2str(x(1,1)),'-(',num2str(x(2,1)-x(1,1)),')*x(2)');
                    eqn2 = strcat(char(subs(tmp1(2),'t','x(1)')),' - ',num2str(x(1,2)),'-(',num2str(x(2,2)-x(1,2)),')*x(2)');
                    funF = inline(strcat('[(',eqn1,');(',eqn2,')]'),'x');
                    xtest = [linspace(tmp2(1),tmp2(2),Ntp)' linspace(0,1,Ntp)'];
                    tmpfsolve = [];
                    for k = 1:Ntp
                        [flag,flag1,flag2] = fsolve(funF,xtest(k,:),opts);
                        if (flag2 == 1)
                            tmpfsolve = [tmpfsolve;flag];
                        end
                    end
                    tmpfsolve = unique(double(vpa(tmpfsolve,5)),'rows');
                    tmp = sym(tmpfsolve);
            end
                        
            tmp1 = double(tmp);
            if (size(tmp,1)>0)
                [tmpin,tmpon] = inpolygon(tmp1(:,1),tmp1(:,2),[tmp2(1),tmp2(2),tmp2(2),tmp2(1)],[0+1e-4,0+1e-4,1-1e-4,1-1e-4]);
                numroot = size(find((tmpin-tmpon)>0),1);
            else
                numroot = 0;
            end            

            if (numroot==0 || ~isreal(tmp1))
                continue;
            else
                ipass = 0;
            end
        end
    end
end