% -----rbMIT Software Copyright MIT 2006-07----
%  DBP  Huynh,NC Nguyen, AT Patera, G Rozza
% Henceforth, Software shall refer to the rbMIT_System software package: 
% the contents of the rbMIT_Library and rbMIT_Aux folders.
% 
% This License governs use of all accompanying Software, and your download and/or use of the Software constitutes acceptance 
% of this License.
% 
% You may use this Software for any non-commercial purpose, subject to the restrictions in this license. 
% Some purposes which can be non-commercial are teaching and academic research.
% 
% You may not use or distribute this Software or any derivative works in any form for commercial purposes. 
% Examples of commercial purposes would be licensing, leasing, or selling the Software, or distributing the 
% Software for use with commercial products.
% 
% You may modify this Software and distribute the modified Software for non-commercial purposes,
%  however, you may not grant rights to the Software or derivative works that are broader than those 
% provided by this License. For example, you may not distribute modifications of the Software under terms 
% that would permit commercial use.
% 
% In return, we require that you agree:
% 
% not to remove any copyright or other notices from the Software;
% 
% that if you distribute the Software in source or object form, you will include a verbatim copy of this license;
% 
% that if you distribute derivative works of the Software in source code form you do so only under a license
% that includes all of the provisions of this License, and if you distribute derivative works of the Software solely 
% in object form you do so only under a license that complies with this License;
% 
% that if you have modified the Software or created derivative works, and distribute such modifications or derivative
% works, you will cause the modified files to carry prominent notices so that recipients know that they are not receiving the original Software;
% 
% THAT THE SOFTWARE COMES "AS IS", WITH NO WARRANTIES: THIS MEANS NO EXPRESS, IMPLIED OR STATUTORY WARRANTY, 
% INCLUDING WITHOUT LIMITATION WARRANTIES OF MERCHANTABILITY OR FITNESS FOR A PARTICULAR PURPOSE OR ANY WARRANTY 
% OF TITLE OR NON-INFRINGEMENT; YOU MUST PASS THIS DISCLAIMER ON WHENEVER YOU DISTRIBUTE THE SOFTWARE OR DERIVATIVE WORKS;
% 
% THAT NEITHER MIT NOR THE AUTHORS WILL BE LIABLE FOR ANY DAMAGES RELATED TO THE SOFTWARE OR THIS LICENSE, 
% INCLUDING DIRECT, INDIRECT, SPECIAL, CONSEQUENTIAL OR INCIDENTAL DAMAGES; YOU MUST PASS THIS LIMITATION OF LIABILITY 
% ON WHENEVER YOU DISTRIBUTE THE SOFTWARE OR DERIVATIVE WORKS;
% 
% that your rights under the License end automatically if you breach the License in any way;
% 
% that MIT reserves all rights not expressly granted to you in this License.
% 
% (Note: The wording of this license agreement is derived from a Microsoft Shared Source license agreement.)
% 
% License at http://augustine.mit.edu/rbMIT_SystemLicense.htm.
%
% rbMIT Software Part_II_and_IV
%
% ---------- 
numgeo0 = length(geometry);
% Note: in defining domgeo, if we set "inside" to zero for domains corresponding to numgeo > numgeo0, geometries/domains newly created
% here will correctly inherit fareaload and oareaload and kappa from the original domains.  (Modifications to symbolicprimal done: atp-5/7.)
numgeotmp = length(geometry);
numedgetmp = size(edge,1);
numpttmp = size(preal,1);

% if (plotdemo)
%     disp('Initial boundaries...;')
%     figure(demogcf);
%     boundarydraw
%     pause
% %     close
% end;

figure(demogcf);
boundarydraw
set(demogcf,'Color','white');
saveas(demogcf,['log\fig\initboundary'],'fig');
if (plotdemo)
    disp('Initial boundaries...;')
    pause
else
    close(demogcf);
end
fid = fopen(logmfname,'a');
fprintf(fid,'%%\n%%%% Initial boundaries...;\n%%\n');
fprintf(fid,'open(%s);\n',['''log\fig\initboundary.fig''']);
fclose(fid);

inwardfigcount = 0;
outwardfigcount = 0;

% phuong 1/17
edgetmp = edge;
prealtmp = preal;
geometrytmp = geometry;
edgeset = [];
if not(curvalnull)
    tmp0 = find(tedgeval(:,1)~=0);
    for ii = 1:length(tmp0)
        tmp1 = tmp0(ii);
        i = double(tedgeval(tmp1,1));
        tmp = tedgeval(tmp1,2):(tedgeval(tmp1,3)-tedgeval(tmp1,2))/curvyres:tedgeval(tmp1,3);
        edgeset{tmp1} = (size(edgetmp,1)+1:size(edgetmp,1)+curvyres);
        clear tmp2;
        tmp2(1,:) = [edge(tmp1,1),size(prealtmp,1)+1];
        tmp2(2:curvyres-1,:) = [(size(prealtmp,1)+1:size(prealtmp,1)+curvyres-2)',(size(prealtmp,1)+2:size(prealtmp,1)+curvyres-1)'];
        tmp2(curvyres,:) = [size(prealtmp,1)+curvyres-1,edge(tmp1,2)];
        edgetmp = [edgetmp; tmp2];
        for j = 2:curvyres
            psnew = simplify(subs(curvedatsym{i}.gfun,t,tmp(j),0)); % phuong 2/2/09
            for k = 1:P
                psnew = subs(psnew,strcat('mu',num2str(k)),muref(k),0); % phuong 2/2/09
            end
            prealtmp = [prealtmp;psnew];
        end
    end
end

for i = 1:numgeotmp
    tmp = geometrytmp{i};
    tmp1 = find(tedgeval(:,1)~=0);
    for j = 1:length(tmp1)
        tmp2 = find(tmp == tmp1(j));
        if not(isempty(tmp2)) % phuong 1/25
            tmp = [tmp(1:tmp2-1),edgeset{tmp1(j)},tmp(tmp2+1:end)];
        end
    end
    geometrytmp{i} = tmp;
    % find a list of nodes that travel around the domain
    clear etmp;
    tmp = geometrytmp{i}(2:end);
    etmp(1) = edgetmp(geometrytmp{i}(1),1);
    for j = 2:length(geometrytmp{i})
        itmp = find(etmp(j-1) == edgetmp(tmp,1));
        if itmp>0
            etmp(j) = edgetmp(tmp(itmp),2);
            tmp(itmp) = [];
        else
            itmp = find(etmp(j-1) == edgetmp(tmp,2));
            etmp(j) = edgetmp(tmp(itmp),1);
            tmp(itmp) = [];
        end
    end
        boundaryptstmpfine{i} = prealtmp(etmp,:);
end
% phuong 1/17

for i = 1:numgeotmp
    % find a list of nodes that travel around the domain
    clear etmp;
    tmp = geometry{i}(2:end);
    etmp(1) = edge(geometry{i}(1),1);
    for j = 2:length(geometry{i})
        itmp = find(etmp(j-1) == edge(tmp,1));
        if itmp>0
            etmp(j) = edge(tmp(itmp),2);
            tmp(itmp) = [];
        else
            itmp = find(etmp(j-1) == edge(tmp,2));
            etmp(j) = edge(tmp(itmp),1);
            tmp(itmp) = [];
        end
    end
        boundaryptstmp{i} = preal(etmp,:);
end

if( max(double(tedgeval(:,1))) > 0 )
    curvedgelist = find(double(tedgeval(:,1)) ~= 0); 
else;
    return;
end
for indcedge = 1:size(curvedgelist,1);
    icedge = curvedgelist(indcedge);
    
    lab = double(tedgeval(icedge,1));
    tarc2 = tedgeval(icedge,2);
    tarc3 = tedgeval(icedge,3);
    tarch = (1/2)*(tarc2+tarc3);
    
    Osym = (curvedatsym{lab}.O)';
    tmp = Osym;
    for i = 1:P
         tmp  = subs(tmp,strcat('mu',num2str(i)),muref(i),0); % phuong 2/2/09
    end
    Oref = tmp;
    
    % find geometries with this edge; below does not work for holes and non-holes
    %geoedgeset = [];
    %for igeotmp = 1:numgeotmp;
    %    itmp = find(geometry{igeotmp} == icedge); 
    %   if(itmp > 0) 
    %        geoedgeset = [geoedgeset,igeotmp];
    %    end;
    %end;
    
    %numgeoedgeset = size(geoedgeset,2);
    
    % find which geometries are inwards and which are outwards
    
    tang = [preal(edge(icedge,2),1)-preal(edge(icedge,1),1), preal(edge(icedge,2),2)-preal(edge(icedge,1),2)];
    len = sqrt(tang(1)^2 + tang(2)^2);
    perp = [tang(2),-tang(1)]; %atp-5/9
    dot = (Oref - (1/2)*(preal(edge(icedge,2),:)+ preal(edge(icedge,1),:)))*perp'; % keep for testing
    % atp-5/9 below
    dx = diff(curvedat(lab,1),'t');
    dy = diff(curvedat(lab,2),'t');
    derg = [dx,dy];
    nnonhat = [dy,-dx];
    lennormal = simplify((dy^2 + dx^2));
    nhat = nnonhat/lennormal;
    dndt1 = diff(nhat(1),'t');
    dndt2 = diff(nhat(2),'t');
    dndt = [dndt1,dndt2];
    crossprod = nhat(1)*dndt(2) - nhat(2)*dndt(1);
    crossprodreal = subs(crossprod,'t',double(tarch),0); % phuong 2/2/09
    %atp-5/9 above
    
    %dot
    %crossreal % should have opposite signs
    
    
    ptpertp = (1/2)*(preal(edge(icedge,2),:)+ preal(edge(icedge,1),:)) + .05*len*perp;
    ptpertm = (1/2)*(preal(edge(icedge,2),:)+ preal(edge(icedge,1),:)) - .05*len*perp;
  
    tmpcount = 0;
    inwards = [];
    innum = 0;

    for n = 1:numgeotmp;
        
    
        
        if (inpolygon(ptpertp(1),ptpertp(2),boundaryptstmp{n}(:,1),boundaryptstmp{n}(:,2)))
            tmpcount = tmpcount + 1;
            %if(dot > 0)
            if(crossprodreal < 0) % atp-5/9
                inwards = [inwards,n];
                innum = innum + 1;
            end;
        end;
        
        if (inpolygon(ptpertm(1),ptpertm(2),boundaryptstmp{n}(:,1),boundaryptstmp{n}(:,2)))
            tmpcount = tmpcount + 1;
            %if(dot < 0)
            if(crossprodreal > 0) % atp-5/9
                inwards = [inwards,n];
                innum = innum + 1;
            end;
        end;
        
    end;
    % tmpcount for checking... 
    if(ismember(0,(gflag(inwards))));
        inwards = [];
        innum = 0;
    end;
    
    % take care of inwards case
    if(innum ~= 0)
        
        omega = 0;
        
        %atp-5/9 below
        %below for testing
        cond1 = 1./cos(tarch - tarc2);
        cond2 = 1./cos(tarch - tarc3);
        cond3 = sin(tarc3-tarc2)/(sin(tarc3-tarch) + sin(tarch - tarc2));
        tmpcond1 = cond1;
        tmpcond2 = cond2;
        tmpcond3 = cond3;
        for i = 1:P
                tmpcond1 = subs(tmpcond1,strcat('mu',num2str(i)),muref(i),0); % phuong 2/2/09
                tmpcond2 = subs(tmpcond2,strcat('mu',num2str(i)),muref(i),0); % phuong 2/2/09
                tmpcond3 = subs(tmpcond3,strcat('mu',num2str(i)),muref(i),0); % phuong 2/2/09
        end
        %omegamax = min([tmpcond1,tmpcond2,tmpcond3]);
        %above for testing
        
        clear cond1gen cond2gen cond3gen
        gvec = [curvedat(lab,1), curvedat(lab,2)] - Oref; %atp-5/9
        gvect1 = subs(gvec,'t',double(tarch),0); % phuong 2/2/09
        gvect2 = subs(gvec,'t',double(tarc2),0); % phuong 2/2/09
        gvect3 = subs(gvec,'t',double(tarc3),0); % phuong 2/2/09
        nhatt2 = subs(nhat,'t',double(tarc2),0); % phuong 2/2/09
        nhatt3 = subs(nhat,'t',double(tarc3),0); % phuong 2/2/09
        g1n2 = crossprodreal*gvect1*nhatt2';
        g1n3 = crossprodreal*gvect1*nhatt3';
        g2n2 = crossprodreal*gvect2*nhatt2';
        g3n3 = crossprodreal*gvect3*nhatt3';
        gt1del = crossprodreal*gvect1*[gvect3(2) - gvect3(2), gvect2(1) - gvect3(1)]';
        gsumdel = crossprodreal*(1/2)*(gvect2 + gvect3)*[gvect3(2) - gvect3(2), gvect2(1) - gvect3(1)]';
        if(g1n2 > 0) % should be able to prove
            cond1gen = g2n2/g1n2;
        end;
        if(g1n3 > 0) % should be able to prove
            cond2gen = g3n3/g1n3;
        end;
        if(gt1del > 0) % should be able to prove
            cond3gen = gsumdel/gt1del;
        end;
        
%         omegamax = min([cond1gen,cond2gen,cond3gen]);
        omegamaxt = min([cond1gen,cond2gen,cond3gen]); %atp-5/15
        omegamax = double(vpa(omegamaxt,10)); %atp-5/15

        %cond1
        %cond1gen
        %cond2
        %cond2gen
        %cond3
        %cond3gen
        
        
        %atp-5/9 above 


        omega = 1/2*(omega+omegamax); %atp-5/14 initmesh fails whether this is commented or not...probably better to leave un-commented (for symmetry in nodemap)
     
        if exist('mupad') % phuong 2/2/09
            omega = double(vpa(omega,2)); % for better symbolic fractional conversion
        end
        
        idone = 0;
    
        while (idone == 0)
        
        newptsym = Osym + omega*(simplify(subs(curvedatsym{lab}.gfun,'t',tarch,0))-Osym); %atp-5/9 % phuong 2/2/09
        tmp = newptsym;
            for i = 1:P
                tmp = subs(tmp,strcat('mu',num2str(i)),muref(i),0); % phuong 2/2/09
            end
        newpt = tmp;
        
        ptnum2 = edge(icedge,1);
        ptnum3 = edge(icedge,2);
        ptonedge2 = preal(ptnum2,:);
        ptonedge3 = preal(ptnum3,:);
    
        geosok = 1;
        for i = 1:innum;
            igeotmp = inwards(i);
            % phuong 1/17
            [inall2,outall2] = edgeallin(boundaryptstmpfine{igeotmp},newpt,ptonedge2,10);
            [inall3,outall3] = edgeallin(boundaryptstmpfine{igeotmp},newpt,ptonedge3,10);
            % phuong 1/17            
            if (inall2 == 0 | inall3 == 0)
                geosok = 0;
                break;
            end;
        end;
        
        outother = 1;  % _need_ to check holes and non-hole holes --- so check all
        for i = 1:numgeotmp
            if( ~ismember(i,inwards) )
                % phuong 1/17
                [inall2,outall2] = edgeallin(boundaryptstmpfine{i},newpt,ptonedge2,10);
                [inall3,outall3] = edgeallin(boundaryptstmpfine{i},newpt,ptonedge3,10);
                % phuong 1/17
                if (outall2 == 0 | outall3 == 0)
                    outother = 0;
                    break;
                end;
            end;
        end;
        
        % Next version: add in another test "angleok" to check that the
        % distance between the new point and closest old point is greater 
        % than (say) .2 * the length of the newly created edge. 
        
        if (geosok == 1 & outother == 1)
                idone = 1;
                preal = [preal; newpt];
                psym = [psym; newptsym];
                numpttmp = numpttmp + 1;
                edge = [edge; numpttmp , ptnum2; numpttmp , ptnum3];
                numedgetmp = numedgetmp + 2;
                geometry{numgeotmp+1} = [icedge, numedgetmp, numedgetmp-1];
                gflag(numgeotmp+1) = 1;
                numgeotmp = numgeotmp + 1;
    
                tedgeval(numedgetmp-1,1:3) = sym([0,0,1]);
                tedgeval(numedgetmp,1:3) = sym([0,0,1]);
                
                rootedge = [rootedge,numedgetmp-1,numedgetmp]; % atp-5/14
    
                clear etmp;
                tmp = geometry{numgeotmp}(2:end);
                etmp(1) = edge(geometry{numgeotmp}(1),1);
                for j = 2:length(geometry{numgeotmp})
                    itmp = find(etmp(j-1) == edge(tmp,1));
                    if itmp>0
                        etmp(j) = edge(tmp(itmp),2);
                        tmp(itmp) = [];
                    else
                        itmp = find(etmp(j-1) == edge(tmp,2));
                        etmp(j) = edge(tmp(itmp),1);
                        tmp(itmp) = [];
                    end
                end
                boundaryptstmp{numgeotmp} = preal(etmp,:);
                
                % phuong 1/17
                boundaryptstmpfine{numgeotmp} = preal(etmp,:);

%                 if(plotdemo)
%                     disp('boundaries after introduction of Inwards Curvy Triangle...;')
%                     figure(demogcf);
%                     boundarydraw
%                     pause
% %                     close
%                 end;
    
                figure(demogcf);
                boundarydraw
                set(demogcf,'Color','white');
                saveas(demogcf,strcat(['log\fig\inwardgen'],num2str(inwardfigcount)),'fig');
                if (plotdemo)
                    disp('boundaries after introduction of Inwards Curvy Triangle...;')
                    pause
                else
                    close(demogcf);
                end
                fid = fopen(logmfname,'a');
                if (inwardfigcount == 0)
                    fprintf(fid,'%%\n%%%% boundaries after introduction of Inwards Curvy Triangle...;\n%%\n');
                end
                fprintf(fid,'open(%s);\n',strcat(['''log\fig\inwardgen'],num2str(inwardfigcount),'.fig'''));
                fclose(fid);
                inwardfigcount = inwardfigcount + 1;

        else
            omega = 1/2*(omega + omegamax);
        end;   
        
        end; % end the while
        
    end; % end the inwards if
    
    
    

end; % end edge loop


% now do more difficult outwards case



iredo = 1;
edgedone = [];

while( iredo == 1 )
    
iredo = 0;

for i = 1:numgeotmp
    % find a list of nodes that travel around the domain
    clear etmp;
    tmp = geometry{i}(2:end);
    etmp(1) = edge(geometry{i}(1),1);
    for j = 2:length(geometry{i})
        itmp = find(etmp(j-1) == edge(tmp,1));
        if itmp>0
            etmp(j) = edge(tmp(itmp),2);
            tmp(itmp) = [];
        else
            itmp = find(etmp(j-1) == edge(tmp,2));
            etmp(j) = edge(tmp(itmp),1);
            tmp(itmp) = [];
        end
    end
        boundaryptstmp{i} = preal(etmp,:);
        
        % phuong 1/17
        if i>numgeo0
            boundaryptstmpfine{i} = preal(etmp,:);
        end
end

curvedgelist = find(double(tedgeval(:,1)) ~= 0); 
for indcedge = 1:size(curvedgelist,1);

    icedge = curvedgelist(indcedge);
if ( ~ismember(icedge,edgedone) )
    
    lab = double(tedgeval(icedge,1));
    tarc2 = tedgeval(icedge,2);
    tarc3 = tedgeval(icedge,3);
    tarch = (1/2)*(tarc2+tarc3);
    
    Osym = (curvedatsym{lab}.O)';
    tmp = Osym;
    for i = 1:P
         tmp  = subs(tmp,strcat('mu',num2str(i)),muref(i),0); % phuong 2/2/09
    end
    Oref = tmp;
    
    % find geometries with this edge
    %geoedgeset = [];
    %ieset = [];
    %for igeotmp = 1:numgeotmp;
    %    itmp = find(geometry{igeotmp} == icedge); 
    %   if(itmp > 0) 
    %       geoedgeset = [geoedgeset,igeotmp];
    %       ieset = [ieset,itmp];
    %   end;
    %end;
    
    %numgeoedgeset = size(geoedgeset,2);
    
    % find which geometries are inwards and which are outwards
    tang = [preal(edge(icedge,2),1)-preal(edge(icedge,1),1), preal(edge(icedge,2),2)-preal(edge(icedge,1),2)];
    len = sqrt(tang(1)^2 + tang(2)^2);
    perp = [tang(2),-tang(1)]; %atp-5/9
    dot = (Oref - (1/2)*(preal(edge(icedge,2),:)+ preal(edge(icedge,1),:)))*perp';

    % atp-5/9 below
    dx = diff(curvedat(lab,1),'t');
    dy = diff(curvedat(lab,2),'t');
    derg = [dx,dy];
    nnonhat = [dy,-dx];
    lennormal = simplify((dy^2 + dx^2));
    nhat = nnonhat/lennormal;
    dndt1 = diff(nhat(1),'t');
    dndt2 = diff(nhat(2),'t');
    dndt = [dndt1,dndt2];
    crossprod = nhat(1)*dndt(2) - nhat(2)*dndt(1);
    crossprodreal = subs(crossprod,'t',double(tarch),0); % phuong 2/2/09
    %atp-5/9 above
    
    
    
    ptpertp = (1/2)*(preal(edge(icedge,2),:)+ preal(edge(icedge,1),:)) + .05*len*perp;
    ptpertm = (1/2)*(preal(edge(icedge,2),:)+ preal(edge(icedge,1),:)) - .05*len*perp;
  
    
    tmpcount = 0;
    outwards = [];
    outnum = 0;

    for n = 1:numgeotmp;
        
    
        
        if (inpolygon(ptpertp(1),ptpertp(2),boundaryptstmp{n}(:,1),boundaryptstmp{n}(:,2)))
            tmpcount = tmpcount + 1;
            %if(dot < 0)
            if(crossprodreal > 0) % atp-5/9   
                outwards = [outwards,n];
                outnum = outnum + 1;
            end;
        end;
        
        if (inpolygon(ptpertm(1),ptpertm(2),boundaryptstmp{n}(:,1),boundaryptstmp{n}(:,2)))
            tmpcount = tmpcount + 1;
            % if(dot > 0)
            if(crossprodreal < 0) % atp-5/9
                outwards = [outwards,n];
                outnum = outnum + 1;
            end;
        end;
        
    end;
    if(ismember(0,(gflag(outwards))));
        outwards = [];
        outnum = 0;
    end;
    % tmpcount for checking... 
    %crossprodreal
    %outwards
    %outnum
    
    % take care of outwards case
    if(outnum ~= 0)
        
        %atp-5/9 below
        %keep below for testing
        cond1 = 1./cos(tarch - tarc2);
        cond2 = 1./cos(tarch - tarc3);

        tmpcond1 = cond1;
        tmpcond2 = cond2;

        for i = 1:P
                tmpcond1 = subs(tmpcond1,strcat('mu',num2str(i)),muref(i),0); % phuong 2/2/09
                tmpcond2 = subs(tmpcond2,strcat('mu',num2str(i)),muref(i),0); % phuong 2/2/09

        end
        %above for testing
        
        clear cond1gen cond2gen cond3gen
        gvec = [curvedat(lab,1), curvedat(lab,2)] - Oref; %atp-5/9
        gvect1 = subs(gvec,'t',double(tarch),0); % phuong 2/2/09
        gvect2 = subs(gvec,'t',double(tarc2),0); % phuong 2/2/09
        gvect3 = subs(gvec,'t',double(tarc3),0); % phuong 2/2/09
        nhatt2 = subs(nhat,'t',double(tarc2),0); % phuong 2/2/09
        nhatt3 = subs(nhat,'t',double(tarc3),0); % phuong 2/2/09
        g1n2 = crossprodreal*gvect1*nhatt2';
        g1n3 = crossprodreal*gvect1*nhatt3';
        g2n2 = crossprodreal*gvect2*nhatt2';
        g3n3 = crossprodreal*gvect3*nhatt3';
        if(g1n2 > 0) % should be able to prove
            cond1gen = g2n2/g1n2;
        end;
        if(g1n3 > 0) % should be able to prove
            cond2gen = g3n3/g1n3;
        end;   
        
        safetol = 1.5; % value >= 1
%         omega = 1 + safetol*(max([cond1gen,cond2gen])-1);
        omegat = 1 + safetol*(max([cond1gen,cond2gen])-1); %atp-5/15
        if exist('mupad') %phuong 2/2/09
            omega = double(vpa(omegat,2)); 
        else
            omega = double(vpa(omegat,10));
        end
        %atp-5/9 above
        %icedge
        %cond1gen
        %cond2gen
        %omega
        newptsym = Osym + omega*(simplify(subs(curvedatsym{lab}.gfun,'t',tarch,0))-Osym);  %atp-5/9 % phuong 2/2/09
        tmp = newptsym;
            for i = 1:P
                tmp = subs(tmp,strcat('mu',num2str(i)),muref(i),0); % phuong 2/2/09
            end
        newpt = tmp;
        %newpt

        ptnum2 = edge(icedge,1);
        ptnum3 = edge(icedge,2);
        ptonedge2 = preal(ptnum2,:);
        ptonedge3 = preal(ptnum3,:);
    
        geosok = 1;
        for i = 1:outnum;
            igeotmp = outwards(i);
            % phuong 1/17
            [inall2,outall2] = edgeallin(boundaryptstmpfine{igeotmp},newpt,ptonedge2,10);
            [inall3,outall3] = edgeallin(boundaryptstmpfine{igeotmp},newpt,ptonedge3,10);
            % phuong 1/17
            if (inall2 == 0 | inall3 == 0)
                geosok = 0;
                break;
            end;
        end;
        
        outother = 1;  % _need_ to check holes and non-hole holes --- so check all
        for i = 1:numgeotmp
            if( ~ismember(i,outwards) )
                % phuong 1/17
                [inall2,outall2] = edgeallin(boundaryptstmpfine{i},newpt,ptonedge2,10);
                [inall3,outall3] = edgeallin(boundaryptstmpfine{i},newpt,ptonedge3,10);
                % phuong 1/17
                if (outall2 == 0 | outall3 == 0)
                    outother = 0;
                    break;
                end;
            end;
        end;
        
        if (geosok == 0 | outother == 0)
                for iigeo = 1:numgeo;
                    tmpgeo = find(geometry{iigeo} == icedge); 
                    if tmpgeo>0
                        igeo = iigeo;
                        ie = tmpgeo;
                    end;
                end;
                edgetst = edge(icedge,:);
                edgesplit
                numpttmp = numpttmp + 1;
                numedgetmp = numedgetmp + 1;
                iredo = 1;
        else
            edgedone = [edgedone,icedge];
            preal = [preal; newpt];
            psym = [psym; newptsym];
            numpttmp = numpttmp + 1;
            edge = [edge; numpttmp , ptnum2; numpttmp , ptnum3];
            numedgetmp = numedgetmp + 2;
            geometry{numgeotmp+1} = [icedge, numedgetmp, numedgetmp-1];
            gflag(numgeotmp+1) = 1;
            numgeotmp = numgeotmp + 1;
    
            tedgeval(numedgetmp-1,1:3) = sym([0,0,1]);
            tedgeval(numedgetmp,1:3) = sym([0,0,1]);
            
            rootedge = [rootedge,numedgetmp-1,numedgetmp]; % atp-5/14
    
            clear etmp;
            tmp = geometry{numgeotmp}(2:end);
            etmp(1) = edge(geometry{numgeotmp}(1),1);
            for j = 2:length(geometry{numgeotmp})
                itmp = find(etmp(j-1) == edge(tmp,1));
                if itmp>0
                    etmp(j) = edge(tmp(itmp),2);
                    tmp(itmp) = [];
                else
                    itmp = find(etmp(j-1) == edge(tmp,2));
                    etmp(j) = edge(tmp(itmp),1);
                    tmp(itmp) = [];
                end
            end
            boundaryptstmp{numgeotmp} = preal(etmp,:);
            
            % phuong 1/17
            boundaryptstmpfine{numgeotmp} = preal(etmp,:);
            
%             if(plotdemo)
%                     disp('boundaries after introduction of Outwards Curvy Triangle...;')
%                     figure(demogcf);
%                     boundarydraw
%                     pause
% %                     close
%             end;

            figure(demogcf);
            boundarydraw
            set(demogcf,'Color','white');
            saveas(demogcf,strcat(['log\fig\outwardgen'],num2str(outwardfigcount)),'fig');
            if (plotdemo)
                disp('boundaries after introduction of Outwards Curvy Triangle...;')
                pause
            else
                close(demogcf);
            end
            fid = fopen(logmfname,'a');
            if (outwardfigcount == 0)
                    fprintf(fid,'%%\n%%%% boundaries after introduction of Outwards Curvy Triangle...;\n%%\n');
            end
            fprintf(fid,'open(%s);\n',strcat(['''log\fig\outwardgen'],num2str(outwardfigcount),'.fig'''));
            fclose(fid);
            outwardfigcount = outwardfigcount + 1;

        end;
    end; %end outwards if
        
    if(iredo == 1)
        break;
    end;

end; % end edgedone if (later change to while edgedone is nonempty for better readability...)    
end; % end edge loop

end; % end while
   