function funcstr = gencompfunc(probtype,i,numdoms,numnload,numnloadgroup,groupcoeff,Boolecoeff,termcountlimit)
% -----rbMIT Software Copyright MIT 2006-07----
%  DBP  Huynh,NC Nguyen, AT Patera, G Rozza
% Henceforth, Software shall refer to the rbMIT_System software package: 
% the contents of the rbMIT_Library and rbMIT_Aux folders.
% 
% This License governs use of all accompanying Software, and your download and/or use of the Software constitutes acceptance 
% of this License.
% 
% You may use this Software for any non-commercial purpose, subject to the restrictions in this license. 
% Some purposes which can be non-commercial are teaching and academic research.
% 
% You may not use or distribute this Software or any derivative works in any form for commercial purposes. 
% Examples of commercial purposes would be licensing, leasing, or selling the Software, or distributing the 
% Software for use with commercial products.
% 
% You may modify this Software and distribute the modified Software for non-commercial purposes,
%  however, you may not grant rights to the Software or derivative works that are broader than those 
% provided by this License. For example, you may not distribute modifications of the Software under terms 
% that would permit commercial use.
% 
% In return, we require that you agree:
% 
% not to remove any copyright or other notices from the Software;
% 
% that if you distribute the Software in source or object form, you will include a verbatim copy of this license;
% 
% that if you distribute derivative works of the Software in source code form you do so only under a license
% that includes all of the provisions of this License, and if you distribute derivative works of the Software solely 
% in object form you do so only under a license that complies with this License;
% 
% that if you have modified the Software or created derivative works, and distribute such modifications or derivative
% works, you will cause the modified files to carry prominent notices so that recipients know that they are not receiving the original Software;
% 
% THAT THE SOFTWARE COMES "AS IS", WITH NO WARRANTIES: THIS MEANS NO EXPRESS, IMPLIED OR STATUTORY WARRANTY, 
% INCLUDING WITHOUT LIMITATION WARRANTIES OF MERCHANTABILITY OR FITNESS FOR A PARTICULAR PURPOSE OR ANY WARRANTY 
% OF TITLE OR NON-INFRINGEMENT; YOU MUST PASS THIS DISCLAIMER ON WHENEVER YOU DISTRIBUTE THE SOFTWARE OR DERIVATIVE WORKS;
% 
% THAT NEITHER MIT NOR THE AUTHORS WILL BE LIABLE FOR ANY DAMAGES RELATED TO THE SOFTWARE OR THIS LICENSE, 
% INCLUDING DIRECT, INDIRECT, SPECIAL, CONSEQUENTIAL OR INCIDENTAL DAMAGES; YOU MUST PASS THIS LIMITATION OF LIABILITY 
% ON WHENEVER YOU DISTRIBUTE THE SOFTWARE OR DERIVATIVE WORKS;
% 
% that your rights under the License end automatically if you breach the License in any way;
% 
% that MIT reserves all rights not expressly granted to you in this License.
% 
% (Note: The wording of this license agreement is derived from a Microsoft Shared Source license agreement.)
% 
% License at http://augustine.mit.edu/rbMIT_SystemLicense.htm.
%
% rbMIT Software Part_II_and_IV
%
% ---------- 
if (not(exist('termcountlimit')))
    termcountlimit = 5;
end

tmp = '';
termcount = 0; %atp-5/22 (all termcount business below)

switch probtype
    case {'TH','TH2','ST','ST2'} % phuong 1/9 (ST and ST2 will not work for now)
        Laffsize2 = 9;
    case {'LE1','LE2','LE3','LE4','LE5'}
        Laffsize2 = 36;
end

numKgroup = length(groupcoeff);

for iterm = 1:numKgroup
    for j = 1:numdoms
        for k = 1:Laffsize2
            tmp1 = Boolecoeff((iterm-1)*numdoms*Laffsize2+(j-1)*Laffsize2+k,i);
            if tmp1 ~= 0
                termcount = termcount + 1;
                if (termcount < termcountlimit)
                    if (num2str(tmp1) ~= '1')
                        tmp = strcat(tmp,'+',num2str(tmp1),intgen1(j,k,Laffsize2,groupcoeff(iterm)));
                    else
                        tmp = strcat(tmp,'+',intgen1(j,k,Laffsize2,groupcoeff(iterm)));
                    end
                end
                if(termcount == termcountlimit)
                    tmp = strcat(tmp,'+ ...');
                end
            end
        end
    end
end

switch probtype
    case {'TH','TH2'}
        if (termcount < termcountlimit)
            for iterm = 1:numnloadgroup
                for j = 1:numnload
                    tmp1 = Boolecoeff(numKgroup*numdoms*Laffsize2+(iterm-1)*numnload+j,i);
                    if tmp1 ~= 0
                        termcount = termcount + 1;
                        if (termcount < termcountlimit)
                            if (num2str(tmp1) ~= '1')
                                tmp = strcat(tmp,'+',num2str(tmp1),intgen2(j));
                            else
                                tmp = strcat(tmp,'+',intgen2(j));
                            end
                        end
                        if(termcount == termcountlimit)
                            tmp = strcat(tmp,'+ ...');
                        end
                    end
                end
            end
        end
end

if length(tmp)>0
    tmp = tmp(2:end);
end
tmp = regexprep(tmp,'+-','-');
funcstr = tmp;

function [int_tex] = intgen1(dom,index,Laffsize2,groupcoeff)
groupcoeff = regexprep(char(sym(groupcoeff)),{'x','y'},{'x_1','x_2'});
if strcmp(groupcoeff,'1')
    groupcoeff = '';
end
outer_tex = strcat('\int_{\Omega_{',num2str(dom),'}}');
switch Laffsize2
    case 9
        inner_tex{1} = '\frac{\partial w}{\partial x_1}\frac{\partial v}{\partial x_1}';
        inner_tex{2} = '\frac{\partial w}{\partial x_2}\frac{\partial v}{\partial x_1}';
        inner_tex{3} = 'w\frac{\partial v}{\partial x_1}';        
        inner_tex{4} = '\frac{\partial w}{\partial x_1}\frac{\partial v}{\partial x_2}';        
        inner_tex{5} = '\frac{\partial w}{\partial x_2}\frac{\partial v}{\partial x_2}';
        inner_tex{6} = 'w\frac{\partial v}{\partial x_2}';        
        inner_tex{7} = '\frac{\partial w}{\partial x_1}v';        
        inner_tex{8} = '\frac{\partial w}{\partial x_2}v';
        inner_tex{9} = 'wv';
    case 36
        inner_tex{1}  = '\frac{\partial w_1}{\partial x_1}\frac{\partial v_1}{\partial x_1}';
        inner_tex{2}  = '\frac{\partial w_1}{\partial x_2}\frac{\partial v_1}{\partial x_1}';
        inner_tex{3}  = '\frac{\partial w_2}{\partial x_1}\frac{\partial v_1}{\partial x_1}';
        inner_tex{4}  = '\frac{\partial w_2}{\partial x_2}\frac{\partial v_1}{\partial x_1}';
        inner_tex{7}  = '\frac{\partial w_1}{\partial x_1}\frac{\partial v_1}{\partial x_2}';
        inner_tex{8}  = '\frac{\partial w_1}{\partial x_2}\frac{\partial v_1}{\partial x_2}';
        inner_tex{9}  = '\frac{\partial w_2}{\partial x_1}\frac{\partial v_1}{\partial x_2}';
        inner_tex{10} = '\frac{\partial w_2}{\partial x_2}\frac{\partial v_1}{\partial x_2}';
        inner_tex{13} = '\frac{\partial w_1}{\partial x_1}\frac{\partial v_2}{\partial x_1}';
        inner_tex{14} = '\frac{\partial w_1}{\partial x_2}\frac{\partial v_2}{\partial x_1}';
        inner_tex{15} = '\frac{\partial w_2}{\partial x_1}\frac{\partial v_2}{\partial x_1}';
        inner_tex{16} = '\frac{\partial w_2}{\partial x_2}\frac{\partial v_2}{\partial x_1}';
        inner_tex{19} = '\frac{\partial w_1}{\partial x_1}\frac{\partial v_2}{\partial x_2}';
        inner_tex{20} = '\frac{\partial w_1}{\partial x_2}\frac{\partial v_2}{\partial x_2}';
        inner_tex{21} = '\frac{\partial w_2}{\partial x_1}\frac{\partial v_2}{\partial x_2}';
        inner_tex{22} = '\frac{\partial w_2}{\partial x_2}\frac{\partial v_2}{\partial x_2}';
end
int_tex = strcat(outer_tex,groupcoeff,inner_tex{index},'d\Omega');

function [int_tex] = intgen2(edge)
int_tex = strcat('\int_{\Gamma_{',num2str(edge),'}}','wv','d\Gamma');