% -----rbMIT Software Copyright MIT 2006-07----
%  DBP  Huynh,NC Nguyen, AT Patera, G Rozza
% Henceforth, Software shall refer to the rbMIT_System software package: 
% the contents of the rbMIT_Library and rbMIT_Aux folders.
% 
% This License governs use of all accompanying Software, and your download and/or use of the Software constitutes acceptance 
% of this License.
% 
% You may use this Software for any non-commercial purpose, subject to the restrictions in this license. 
% Some purposes which can be non-commercial are teaching and academic research.
% 
% You may not use or distribute this Software or any derivative works in any form for commercial purposes. 
% Examples of commercial purposes would be licensing, leasing, or selling the Software, or distributing the 
% Software for use with commercial products.
% 
% You may modify this Software and distribute the modified Software for non-commercial purposes,
%  however, you may not grant rights to the Software or derivative works that are broader than those 
% provided by this License. For example, you may not distribute modifications of the Software under terms 
% that would permit commercial use.
% 
% In return, we require that you agree:
% 
% not to remove any copyright or other notices from the Software;
% 
% that if you distribute the Software in source or object form, you will include a verbatim copy of this license;
% 
% that if you distribute derivative works of the Software in source code form you do so only under a license
% that includes all of the provisions of this License, and if you distribute derivative works of the Software solely 
% in object form you do so only under a license that complies with this License;
% 
% that if you have modified the Software or created derivative works, and distribute such modifications or derivative
% works, you will cause the modified files to carry prominent notices so that recipients know that they are not receiving the original Software;
% 
% THAT THE SOFTWARE COMES "AS IS", WITH NO WARRANTIES: THIS MEANS NO EXPRESS, IMPLIED OR STATUTORY WARRANTY, 
% INCLUDING WITHOUT LIMITATION WARRANTIES OF MERCHANTABILITY OR FITNESS FOR A PARTICULAR PURPOSE OR ANY WARRANTY 
% OF TITLE OR NON-INFRINGEMENT; YOU MUST PASS THIS DISCLAIMER ON WHENEVER YOU DISTRIBUTE THE SOFTWARE OR DERIVATIVE WORKS;
% 
% THAT NEITHER MIT NOR THE AUTHORS WILL BE LIABLE FOR ANY DAMAGES RELATED TO THE SOFTWARE OR THIS LICENSE, 
% INCLUDING DIRECT, INDIRECT, SPECIAL, CONSEQUENTIAL OR INCIDENTAL DAMAGES; YOU MUST PASS THIS LIMITATION OF LIABILITY 
% ON WHENEVER YOU DISTRIBUTE THE SOFTWARE OR DERIVATIVE WORKS;
% 
% that your rights under the License end automatically if you breach the License in any way;
% 
% that MIT reserves all rights not expressly granted to you in this License.
% 
% (Note: The wording of this license agreement is derived from a Microsoft Shared Source license agreement.)
% 
% License at http://augustine.mit.edu/rbMIT_SystemLicense.htm.
%
% rbMIT Software Part_II_and_IV
%
% ---------- 

PI = pi; % phuong 2/2/09

% default problem type
if (~exist('probtype'))
    probtype = 'TH';
end
% temporary fix 4-9
if exist('meshOPT')
    femOPT = meshOPT;
end

% pi = sym('pi','real');
t = sym('t');
syms x y xbar ybar Cfun1 Cfun2 Gfun11 Gfun12 Gfun21 Gfun22;
% murefsym
murefsym = sym2fracsym(sym(muref));
% number of geometries (+holes)
numgeo = length(geometry);
% domain decomposition
P = length(muref);
for i = 1:P
    eval(strcat('syms mu',num2str(i),' real'));
end
psym = sym2fracsym(sym(points));
tmp = psym;
for i = 1:P
    tmp = subs(tmp,strcat('mu',num2str(i)),muref(i),0); % phuong 2/2/09
end
preal = tmp;
% check mu sign - phuong 15-8
for i = 1:P
    psign(i) = 0;
    if mu_min(i) > 0
        psign(i) = 1;
    end
    if mu_max(i) < 0
        psign(i) = -1;
    end
end

% tedgeval: lab, t1, t2
% lab is defined in curvedat
% lab = 0 (default) is a straight line
for i = 1:size(edge,1)
    tedgeval(i,1:3) = sym([0,0,1]);
end

curvalnull = 1;
if ( exist('curvedat') && ~ismember('[]',curvedat,'rows') )
    tmp = sym2fracsym(sym(curvedat));
    clear curvedat;
    % curvedat(#num): f1 f2
    % curvedatsym(#num): O, S, Q, S, gfun = [g1full g2full]
	for i = 1:size(tmp,1)
        curvedatsym{i}.O = transpose(tmp(i,1:2));
        curvedatsym{i}.S = [tmp(i,3),0;0,tmp(i,4)];
        curvedatsym{i}.Q = [cos(tmp(i,5)),sin(tmp(i,5));-sin(tmp(i,5)),cos(tmp(i,5))];
        curvedatsym{i}.G = transpose(tmp(i,6:7));
        curvedatsym{i}.gfun(1:2) = curvedatsym{i}.O + curvedatsym{i}.Q*curvedatsym{i}.S*curvedatsym{i}.G;
        curvedat(i,1:2) = curvedatsym{i}.gfun(1:2);
    end
    curvalnull = 0;
    tmp = curvedat;
    for i = 1:P
         tmp = subs(tmp,strcat('mu',num2str(i)),muref(i),0); % phuong 2/2/09
    end
    curvedat = tmp;
    % tedgeval
    tmp = sym2fracsym(sym(tarclist));
    for i = 1:P
         tmp = subs(tmp,strcat('mu',num2str(i)),muref(i),0); % phuong 2/2/09
    end
    clear tarclist;
    for i = 1:size(tmp,1)
        tedgeval(tmp(i,1),1:3) = tmp(i,2:4);
    end
end

switch probtype
    case {'TH','TH2'}
        % fareaload conversion
        for i = 1:length(geometry)
            farealoadtmp(i,1) = sym(0);
        end
        if (exist('fareaload') && (~ismember('[]',fareaload,'rows')))
            fareaload = sym2fracsym(sym(fareaload));
            for i = 1:size(fareaload,1)
                farealoadtmp(double(fareaload(i,1))) = sym(fareaload(i,2));
            end
        end
        fareaload = farealoadtmp;
        clear farealoadtmp;
        % tensor conversion
        for j = 1:numgeo
            kappa{j} = sym2fracsym(sym(kappa{j}));
            tmp = kappa{j};
        end
        % b.c conversion "const du/dn + c1(u-c2) = c3"
        if ( not(exist('nload')) || ismember('[]',nload,'rows') )  % atp-4/23 (parens)
            clear nload;
            nloadnull = 1;
            nload.edge = [];
            nload.g = [];
            nload.q = [];
        else
            nloadnull = 0;
            tmp = sym2fracsym(sym(nload));
            clear nload;
            nload.edge = double(tmp(:,1));
            nload.g = sym(tmp(:,4))+sym(tmp(:,2)).*sym(tmp(:,3));
            nload.q = sym(tmp(:,2));
        end
        % Dirichlet b.c conversion
        if ( not(exist('dirichlet')) || ismember('[]',dirichlet,'rows') ) % atp-4/23 (parens)
            clear dirichlet;
            dirichlet.edge = [];
            dirichlet.r = [];
        else
            tmp = sym2fracsym(sym(dirichlet));
            clear dirichlet;
            dirichlet.edge = double(tmp(:,1));
            dirichlet.r = sym(tmp(:,2));
        end
    case {'LE1','LE2','LE3','LE4','LE5'}
        % fareaload conversion
        for i = 1:length(geometry)
            farealoadtmp(i,:) = sym([0,0]);
        end
        if (exist('fareaload') && (~ismember('[]',fareaload,'rows')))
            fareaload = sym2fracsym(sym(fareaload));
            for i = 1:size(fareaload,1)
                farealoadtmp(double(fareaload(i,1)),:) = sym([fareaload(i,2),fareaload(i,3)]);
            end
        end
        fareaload = farealoadtmp;
        clear farealoadtmp;
        % matprop conversion 
        % matprop{#num#}: E1, nu_12, E2, G12
        % isotropic (LE1&LE2): E2 and G12 have no effects
        % orthotropic (LE3): nu21 is obtained from E2*nu_12 = E1*nu_21
        matproptmp = matprop;        
        clear matprop;
        for j = 1:numgeo
            tmp = sym2fracsym(sym(matproptmp{j}));
            switch probtype
                case {'LE1','LE2','LE5'}
                    matprop{j}.main = tmp(1:2); % E, nu
                    if (length(tmp)>2)
                        matprop{j}.aux = tmp(3:4);
                    else
                        matprop{j}.aux = sym([0,0]);
                    end
                case {'LE3'} % orthotropic plane strain
                    matprop{j}.main = tmp(1:7); % E1, E2, E3, nu12, nu23, nu31, G12
                    if (length(tmp)>7)
                        matprop{j}.aux = tmp(8:9);
                    else
                        matprop{j}.aux = sym([0,0]);
                    end
                case {'LE4'} % orthotropic plane stress
                    matprop{j}.main = tmp(1:4); % E1, E2, nu12, G12
                    if (length(tmp)>4)
                        matprop{j}.aux = tmp(5:6);
                    else
                        matprop{j}.aux = sym([0,0]);
                    end
            end
            tmp1 = matprop{j}.main;
            tmp2 = matprop{j}.aux;
            for i = 1:P
                tmp1 = subs(tmp1,strcat('mu',num2str(i)),muref(i),0); % phuong 2/2/09
                tmp2 = subs(tmp2,strcat('mu',num2str(i)),muref(i),0); % phuong 2/2/09
            end
            matpropreal{j}.main = tmp1;
            matpropreal{j}.aux = tmp2;
        end
        clear matproptmp;
        % b.c conversion
        if ( not(exist('nload')) || ismember('[]',nload,'rows') )  % atp-4/23 (parens)
            clear nload;
            nloadnull = 1;
            nload.edge = [];
            nload.g = [];
            nload.q = [];
        else
            nloadnull = 0;
            tmp = sym2fracsym(sym(nload));
            clear nload;
            nload.edge = double(tmp(:,1));
            nload.g = sym([tmp(:,3), tmp(:,2)]); % phuong 3/9      
            nload.q = 0*nload.g; % phuong 3/9            
        end
        % Dirichlet b.c conversion
        if ( not(exist('dirichlet'))  || ismember('[]',dirichlet,'rows') ) % atp-4/23 (parens)
            clear dirichlet;
            dirichlet.edge = [];
            dirichlet.r = [];
        else
            tmp = sym2fracsym(sym(dirichlet));
            clear dirichlet;
            dirichlet.edge = double(tmp(:,1));
            dirichlet.r = sym([tmp(:,2),tmp(:,3)]);
        end
end

% rhoc conversion
if (not(exist('rhoc')))
    rhoc = sym(ones(1,length(geometry)));
else
    rhoc = sym2fracsym(sym(rhoc));
end

% begin phuong7/3
% mesh quality control
if not(exist('femOPT'))
    femOPT.codes = 'PDETB';
    femOPT.maxsize = 250;
%     meshOPT.refine = 'subdivision';
    femOPT.refine = 'adaptive';
else
    if not(isfield(femOPT,'codes'))
        femOPT.codes = 'PDETB';
    end
    if not(isfield(femOPT,'maxsize'))
        femOPT.maxsize = 250;
    end
    if not(isfield(femOPT,'refine'))
        %     meshOPT.refine = 'subdivision';
        femOPT.refine = 'adaptive';
    end
end
% end phuong7/3

% axisymmetric modifications
if strcmp(probtype,'TH2')
    fareaload = x*fareaload;
    for j = 1:numgeo
        kappa{j} = x*kappa{j};
    end
    for j = 1:length(nload.edge)
        nload.g(j) = x*nload.g(j);
        nload.q(j) = x*nload.q(j);
    end
end
if (strcmp(probtype,'TH2')) || (strcmp(probtype,'LE5'))
    rhoc = rhoc*x;
end

% save original data
input_list = struct2cell(whos);
original_input.dummy = '';
for i = 1:size(input_list,2)
    original_input = setfield(original_input,input_list{1,i},eval(input_list{1,i}));
end
clear input_list;