% -----rbMIT Software Copyright MIT 2006-07----
%  DBP  Huynh,NC Nguyen, AT Patera, G Rozza
% Henceforth, Software shall refer to the rbMIT_System software package: 
% the contents of the rbMIT_Library and rbMIT_Aux folders.
% 
% This License governs use of all accompanying Software, and your download and/or use of the Software constitutes acceptance 
% of this License.
% 
% You may use this Software for any non-commercial purpose, subject to the restrictions in this license. 
% Some purposes which can be non-commercial are teaching and academic research.
% 
% You may not use or distribute this Software or any derivative works in any form for commercial purposes. 
% Examples of commercial purposes would be licensing, leasing, or selling the Software, or distributing the 
% Software for use with commercial products.
% 
% You may modify this Software and distribute the modified Software for non-commercial purposes,
%  however, you may not grant rights to the Software or derivative works that are broader than those 
% provided by this License. For example, you may not distribute modifications of the Software under terms 
% that would permit commercial use.
% 
% In return, we require that you agree:
% 
% not to remove any copyright or other notices from the Software;
% 
% that if you distribute the Software in source or object form, you will include a verbatim copy of this license;
% 
% that if you distribute derivative works of the Software in source code form you do so only under a license
% that includes all of the provisions of this License, and if you distribute derivative works of the Software solely 
% in object form you do so only under a license that complies with this License;
% 
% that if you have modified the Software or created derivative works, and distribute such modifications or derivative
% works, you will cause the modified files to carry prominent notices so that recipients know that they are not receiving the original Software;
% 
% THAT THE SOFTWARE COMES "AS IS", WITH NO WARRANTIES: THIS MEANS NO EXPRESS, IMPLIED OR STATUTORY WARRANTY, 
% INCLUDING WITHOUT LIMITATION WARRANTIES OF MERCHANTABILITY OR FITNESS FOR A PARTICULAR PURPOSE OR ANY WARRANTY 
% OF TITLE OR NON-INFRINGEMENT; YOU MUST PASS THIS DISCLAIMER ON WHENEVER YOU DISTRIBUTE THE SOFTWARE OR DERIVATIVE WORKS;
% 
% THAT NEITHER MIT NOR THE AUTHORS WILL BE LIABLE FOR ANY DAMAGES RELATED TO THE SOFTWARE OR THIS LICENSE, 
% INCLUDING DIRECT, INDIRECT, SPECIAL, CONSEQUENTIAL OR INCIDENTAL DAMAGES; YOU MUST PASS THIS LIMITATION OF LIABILITY 
% ON WHENEVER YOU DISTRIBUTE THE SOFTWARE OR DERIVATIVE WORKS;
% 
% that your rights under the License end automatically if you breach the License in any way;
% 
% that MIT reserves all rights not expressly granted to you in this License.
% 
% (Note: The wording of this license agreement is derived from a Microsoft Shared Source license agreement.)
% 
% License at http://augustine.mit.edu/rbMIT_SystemLicense.htm.
%
% rbMIT Software Part_II_and_IV
%
% ---------- 

% -----rbMIT_System Software Copyright MIT 2006-07-----
% 
% 
% The user agrees to rbMIT_System MIT usage, distribution, and citation terms and conditions 
% described in the License at http://augustine.mit.edu/rbMIT_SystemLicense.htm.
% rbMIT_System Software PartI_V2
%
% Step1_coer_noncompliant [symbolic case: 2-d]
%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Meshing procedure
% return [p,e,t] afterward

%%%%%%%%%%%%%%%%% PDE toolbox fix - phuong 9/25/08
tmp = ver;
j = 0;
for i = 1:length(tmp)
    if strcmp(tmp(i).Name,'Partial Differential Equation Toolbox')
    	  j = i;
    end
end
tmp = tmp(j).Version;
j = [];
for i = length(tmp):-1:1
    if ~strcmp(tmp(i),'.')
        j = [tmp(i),j];
    else
        break;
    end
end
if str2num(j)>10
    femOPT.codes = 'HB';
    femOPT.refine = 'subdivision';
    if (plotdemo)
        disp('PDE Toolbox Ver 1.0.10 or higher... solver is switched to ''HB''!');
    end
end
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

% standard meshing with refinement
disp('Meshing...');

switch femOPT.codes
    case {'HB','PDETB'}
        % get real "q" and "g" values
        tmpg = nload.g;
        tmpq = nload.q;
        tmpf = fareaload;
        for i = 1:P
            tmpg = subs(tmpg,strcat('mu',num2str(i)),muref(i));
            tmpq = subs(tmpq,strcat('mu',num2str(i)),muref(i));
            tmpf = subs(tmpf,strcat('mu',num2str(i)),muref(i));
        end
        nload.greal = tmpg;
        nload.qreal = tmpq;
        farealoadreal = tmpf;
        % prepare the pdebc structure for meshing
        switch probtype
            case {'TH','TH2'}
                % prepare the "b" (pdebc) boundary conditions
                for i = 1:length(edge_list_unique)
                    pdebc(1:10,i) = [0 0 1 1 '1' '0' '0' '0' '0' '0']';
                end
                % assemble zero Neumann b.c
                for i = 1:size(edge,1)
                    [flag, tmploc] =  ismember(edge(i,[1,2]),edge_list_unique,'rows');
                    if not(flag)
                        [flag, tmploc] =  ismember(edge(i,[2,1]),edge_list_unique,'rows');
                    end
                    if tmploc > 0
                        pdebc(1:10,tmploc) = [1 0 1 1 '0' '0' '0' '0' '0' '0']';
                    end
                end
                % assemble Dirichlet b.c
                for i = 1:size(dirichlet.edge,1)
                    [flag, tmploc] = ismember(edge(dirichlet.edge(i),[1,2]),edge_list_unique,'rows');
                    if not(flag)
                        [flag, tmploc] = ismember(edge(dirichlet.edge(i),[2,1]),edge_list_unique,'rows');
                    end
                    if tmploc > 0
                        tmp = [1 1 1 1 1 length(char(dirichlet.r(i))) '0' '0' '1' char(dirichlet.r(i))]';
                        pdebc(1:length(tmp),tmploc) = tmp;
                    end
                end
                % assemble Neumann b.c
                for iterm = 1:numnloadgroup
                    for i = 1:length(nload.edge)
                        [flag, tmploc] =  ismember(edge(nload.edge(i),[1,2]),edge_list_unique,'rows');
                        if not(flag)
                            [flag, tmploc] =  ismember(edge(nload.edge(i),[2,1]),edge_list_unique,'rows');
                        end
                        % assemble the global "b" (pdebc) contains all Dirichlet b.c and loads
                        tmp1 = regexprep(char(sym(nload.qreal(i))),{'*','\^'},{'.*','.^'});
                        tmp2 = regexprep(char(sym(nload.greal(i))),{'*','\^'},{'.*','.^'});
                        tmp = [1 0 length(tmp1) length(tmp2) tmp1 tmp2 '0' '0' '0' '0']';
                        pdebc(1:length(tmp),tmploc) = tmp;
                    end
                end
            case {'LE1','LE2','LE3','LE4','LE5'}
                % prepare the "b" (pdebc) boundary conditions
                for i = 1:length(edge_list_unique)
                    pdebc(1:14,i) = [0 0 1 1 1 1 1 1 '0' '0' '0' '0' '0' '0']';
                end
                % assemble zero Neumann b.c
                for i = 1:size(edge,1)
                    [flag, tmploc] =  ismember(edge(i,[1,2]),edge_list_unique,'rows');
                    if not(flag)
                        [flag, tmploc] =  ismember(edge(i,[2,1]),edge_list_unique,'rows');
                    end
                    if tmploc > 0
                        pdebc(1:14,tmploc) = [2 0 1 1 1 1 1 1 '0' '0' '0' '0' '0' '0']';
                    end
                end
                % assemble Dirichlet b.c
                for i = 1:size(dirichlet.edge,1)
                    [flag, tmploc] = ismember(edge(dirichlet.edge(i),[1,2]),edge_list_unique,'rows');
                    if not(flag)
                        [flag, tmploc] = ismember(edge(dirichlet.edge(i),[2,1]),edge_list_unique,'rows');
                    end
                    if tmploc > 0
                        % pdebc(1:26,tmploc) = [2 2 1 1 1 1 1 1 1 1 1 1 1 1 '0' '0' '0' '0' '0' '0' '1' '0' '0' '1' '0' '0']';
                        if (isfield(edgebcstruct{dirichlet.edge(i)},'rx') && isfield(edgebcstruct{dirichlet.edge(i)},'ry'))
                            tmp = [2 2 1 1 1 1 1 1 1 1 1 1 length(char(edgebcstruct{dirichlet.edge(i)}.rx)) length(char(edgebcstruct{dirichlet.edge(i)}.ry)) '0' '0' '0' '0' '0' '0' '1' '0' '0' '1' char(edgebcstruct{dirichlet.edge(i)}.rx) char(edgebcstruct{dirichlet.edge(i)}.ry)]';
                        elseif (isfield(edgebcstruct{dirichlet.edge(i)},'rx'))
                            % phuong-6/14 fixed
                            tmp = [2 1 1 1 1 1 1 1 1 1 length(char(edgebcstruct{dirichlet.edge(i)}.rx)) '0' '0' '0' '0' '0' '0' '1' '0' char(edgebcstruct{dirichlet.edge(i)}.rx)]';
                        elseif (isfield(edgebcstruct{dirichlet.edge(i)},'ry'))
                            % phuong-6/14 fixed
                            tmp = [2 1 1 1 1 1 1 1 1 1 length(char(edgebcstruct{dirichlet.edge(i)}.ry)) '0' '0' '0' '0' '0' '0' '0' '1' char(edgebcstruct{dirichlet.edge(i)}.ry)]';
                        end
                        pdebc(1:length(tmp),tmploc) = tmp;
                    end
                end
                % assemble Neumann b.c
                for iterm = 1:numnloadgroup
                    for i = 1:length(nload.edge)
                        [flag, tmploc] =  ismember(edge(nload.edge(i),[1,2]),edge_list_unique,'rows');
                        if not(flag)
                            [flag, tmploc] =  ismember(edge(nload.edge(i),[2,1]),edge_list_unique,'rows');
                        end
                        % assemble the global "b" (pdebc) contains all Dirichlet b.c and loads
                        tmp1 = regexprep(char(sym(nload.greal(i,1))),{'*','\^'},{'.*','.^'});
                        tmp2 = regexprep(char(sym(nload.greal(i,2))),{'*','\^'},{'.*','.^'});
                        tmp = [2 0 1 1 1 1 length(tmp1) length(tmp2) '0' '0' '0' '0' tmp1 tmp2]';
                        pdebc(1:length(tmp),tmploc) = tmp;
                    end
                end
        end

        [mesh.p,mesh.e,mesh.t] = initmesh(strcat(probname,'_','pdedom'));
        if strcmp(probtype,'LE5')
            femOPT.refine = 'subdivision'; % cannot do adaptmesh for axisymmetric linear elasticity now
        end
        switch femOPT.refine
            case 'adaptive'
                switch probtype
                    case {'TH','TH2'}
                        % reshape(kappareal{1}(1:2,1:2),4,1),kappareal{1}(3,3),double(fareaload(1)),...
                        [tmp,mesh.p,mesh.e,mesh.t] = adaptmesh(strcat(probname,'_','pdedom'),pdebc,...
                            [1;0;0;1],1,0,...
                            'maxt',femOPT.maxsize*2,... % roughly
                            'ngen',80); % max 80 iterations
                    case {'LE1','LE2','LE3','LE4'} % just roughly based on a particular isotropic plane stress, no exactly, will be fixed later
                        tmp = [1/(1-0.3^2), 0, 0, 0.3/(1-0.3^2); 0, 1/2/(1+0.3), 1/2/(1+0.3), 0; 0, 1/2/(1+0.3), 1/2/(1+0.3), 0; 0.3/(1-0.3^2), 0, 0, 1/(1-0.3^2)];
                        tmp = reshape(tmp,16,1);
                        [tmp,mesh.p,mesh.e,mesh.t] = adaptmesh(strcat(probname,'_','pdedom'),pdebc,...
                            tmp([1,5,2,6,9,13,10,14,3,7,4,8,11,15,12,16]),[0;0;0;0],[0;0],...
                            'maxt',femOPT.maxsize*2,... % roughly
                            'ngen',80); % max 80 iterations
%                         tmp = [1/(1-0.3^2), 0, 0, 0.3/(1-0.3^2); 0, 1/2/(1+0.3), 1/2/(1+0.3), 0; 0, 1/2/(1+0.3), 1/2/(1+0.3), 0; 0.3/(1-0.3^2), 0, 0, 1/(1-0.3^2)];
%                         [tmp,mesh.p,mesh.e,mesh.t] = adaptmesh(strcat(probname,'_','pdedom'),pdebc,...
%                             reshape(tmp,16,1),[0;0;0;0],[0;0],...
%                             'maxt',femOPT.maxsize*2,... % roughly
%                             'ngen',80); % max 80 iterations
                end
            case 'subdivision'
                while size(mesh.p,2)<femOPT.maxsize
                    [mesh.p,mesh.e,mesh.t] = refinemesh(strcat(probname,'_','pdedom'),mesh.p,mesh.e,mesh.t); % user may wish to refine more or less
                end
        end
    case 'COMSOL'
        % just subdivision for now
        tmpfem.geom = geomobject(strcat(probname,'_','pdedom'));
        qtol = 5;
        etol = 0;
        while (qtol > 0) && (etol < femOPT.maxsize)
            tmpfem.mesh = meshinit(tmpfem,'hauto',qtol);
            qtol = qtol - 1;
            etol = length(tmpfem.mesh.t);
        end
        mesh = tmpfem.mesh;
end
% for "backward compatible"
p = mesh.p; e = mesh.e; t = mesh.t;
