%---------------------------------
% PDE solver
% -----rbMIT Software Copyright MIT 2006-07----
%  DBP  Huynh,NC Nguyen, AT Patera, G Rozza
% Henceforth, Software shall refer to the rbMIT_System software package: 
% the contents of the rbMIT_Library and rbMIT_Aux folders.
% 
% This License governs use of all accompanying Software, and your download and/or use of the Software constitutes acceptance 
% of this License.
% 
% You may use this Software for any non-commercial purpose, subject to the restrictions in this license. 
% Some purposes which can be non-commercial are teaching and academic research.
% 
% You may not use or distribute this Software or any derivative works in any form for commercial purposes. 
% Examples of commercial purposes would be licensing, leasing, or selling the Software, or distributing the 
% Software for use with commercial products.
% 
% You may modify this Software and distribute the modified Software for non-commercial purposes,
%  however, you may not grant rights to the Software or derivative works that are broader than those 
% provided by this License. For example, you may not distribute modifications of the Software under terms 
% that would permit commercial use.
% 
% In return, we require that you agree:
% 
% not to remove any copyright or other notices from the Software;
% 
% that if you distribute the Software in source or object form, you will include a verbatim copy of this license;
% 
% that if you distribute derivative works of the Software in source code form you do so only under a license
% that includes all of the provisions of this License, and if you distribute derivative works of the Software solely 
% in object form you do so only under a license that complies with this License;
% 
% that if you have modified the Software or created derivative works, and distribute such modifications or derivative
% works, you will cause the modified files to carry prominent notices so that recipients know that they are not receiving the original Software;
% 
% THAT THE SOFTWARE COMES "AS IS", WITH NO WARRANTIES: THIS MEANS NO EXPRESS, IMPLIED OR STATUTORY WARRANTY, 
% INCLUDING WITHOUT LIMITATION WARRANTIES OF MERCHANTABILITY OR FITNESS FOR A PARTICULAR PURPOSE OR ANY WARRANTY 
% OF TITLE OR NON-INFRINGEMENT; YOU MUST PASS THIS DISCLAIMER ON WHENEVER YOU DISTRIBUTE THE SOFTWARE OR DERIVATIVE WORKS;
% 
% THAT NEITHER MIT NOR THE AUTHORS WILL BE LIABLE FOR ANY DAMAGES RELATED TO THE SOFTWARE OR THIS LICENSE, 
% INCLUDING DIRECT, INDIRECT, SPECIAL, CONSEQUENTIAL OR INCIDENTAL DAMAGES; YOU MUST PASS THIS LIMITATION OF LIABILITY 
% ON WHENEVER YOU DISTRIBUTE THE SOFTWARE OR DERIVATIVE WORKS;
% 
% that your rights under the License end automatically if you breach the License in any way;
% 
% that MIT reserves all rights not expressly granted to you in this License.
% 
% (Note: The wording of this license agreement is derived from a Microsoft Shared Source license agreement.)
% 
% License at http://augustine.mit.edu/rbMIT_SystemLicense.htm.
%
% rbMIT Software Part_II_and_IV
%
% ---------- 
%% gen "probname_pdedom.m"
tri_edge_list = [nodemap(:,[1,2]);nodemap(:,[2,3]);nodemap(:,[3,1])];
[edge_list, tmp1, tmp2] = unique(tri_edge_list,'rows');
tedgetmp = [tmp2(1:numdoms),tmp2(numdoms+1:numdoms*2),tmp2(2*numdoms+1:3*numdoms)];
edge_list_unique = unique(sort(edge_list,2),'rows');
for i = 1:length(edge_list_unique)
    [flag1, tmploc1] =  ismember(edge_list_unique(i,[1,2]),edge_list,'rows');
    [flag2, tmploc2] =  ismember(edge_list_unique(i,[2,1]),edge_list,'rows');
    tmp1 = 0;
    tmp2 = 0;
    if flag1
        [tmp, tmp1] = ismember(tmploc1, tedgetmp);
        tmp1 = mod(tmp1-1,numdoms)+1;
    end
    if flag2
        [tmp, tmp2] = ismember(tmploc2, tedgetmp);
        tmp2 = mod(tmp2-1,numdoms)+1;
    end
    ntmp = preal(edge_list_unique(i,:),:);
    adjdoms(i,:) = [tmp1,tmp2];
end
teqvedgeval = sym(zeros(length(edge_list_unique),3));
for i = 1:length(edge_list_unique)
    teqvedgeval(i,:) = [0,0,1];
    [flag1, tmploc1] =  ismember(edge_list_unique(i,[1,2]),edge,'rows');
    [flag2, tmploc2] =  ismember(edge_list_unique(i,[2,1]),edge,'rows');
    if (tmploc1 > 0)
        if (double(tedgeval(tmploc1,1))>0)
            teqvedgeval(i,:) = sym([tedgeval(tmploc1,1),tedgeval(tmploc1,2),tedgeval(tmploc1,3)]);
        end
    end
    if (tmploc2 > 0)
        if (double(tedgeval(tmploc2,1))>0)
            teqvedgeval(i,:) = sym([tedgeval(tmploc2,1),tedgeval(tmploc2,3),tedgeval(tmploc2,2)]);
        end
    end
end

fid = fopen(strcat(probname,'_','pdedom.m'),'wt');
fprintf(fid,'%% -----rbMIT_System Software Copyright MIT 2006-07-----\n');
fprintf(fid,'%% ----- Geometry file %s -----\n',strcat(probname,'_pdedom.m'));
fprintf(fid,'\n');
fprintf(fid,'function [x,y] = %s(bs,s)\n',strcat(probname,'_pdedom'));
fprintf(fid,'\n');
fprintf(fid,'nbs = %d;\n',length(edge_list_unique));
fprintf(fid,'\n');
fprintf(fid,'if nargin==0\n');
fprintf(fid,'    x=nbs;\n');
fprintf(fid,'    return\n');
fprintf(fid,'end\n');
fprintf(fid,'\n');
for i = 1:length(muref)
    fprintf(fid,'%s = %f;\n',strcat('mu',num2str(i)),muref(i));
end
fprintf(fid,'\n');
fprintf(fid,'psym = [%s, %s',char(psym(1,1)),char(psym(1,2)));
for i = 2:length(psym)
    fprintf(fid,'; %s, %s',char(psym(i,1)),char(psym(i,2)));
end
fprintf(fid,'];\n');
fprintf(fid,'\n');
for i = 1:length(edge_list_unique)
    fprintf(fid,'dl(:,%d) = [%f; %f; %d; %d];\n',i,0,1,adjdoms(i,1),adjdoms(i,2));
end
fprintf(fid,'\n');
fprintf(fid,'bs1=bs(:)'';\n');
fprintf(fid,'\n');
fprintf(fid,'if nargin==1\n');
fprintf(fid,'    x=dl(:,bs1);\n');
fprintf(fid,'    return\n');
fprintf(fid,'end\n');
fprintf(fid,'\n');
fprintf(fid,'x=zeros(size(s));\n');
fprintf(fid,'y=zeros(size(s));\n');
fprintf(fid,'[m,n]=size(bs);\n');
fprintf(fid,'if m==1 && n==1,\n');
fprintf(fid,'    bs=bs*ones(size(s)); %% expand bs\n');
fprintf(fid,'elseif m~=size(s,1) || n~=size(s,2),\n');
fprintf(fid,'    error(''PDE:%s:SizeBs'', ''bs must be scalar or of same size as s.'');\n',strcat(probname,'_','pdedom'));
fprintf(fid,'end\n');
fprintf(fid,'\n');
fprintf(fid,'if ~isempty(s)\n');
for i = 1:length(edge_list_unique)
    fprintf(fid,'   %% boundary segment %d\n',i);
    fprintf(fid,'   ii=find(bs==%d);\n',i);
    fprintf(fid,'   if length(ii)\n');
    if (double(teqvedgeval(i,1)) > 0)
        fprintf(fid,'       for iii = 1:length(ii)\n');
        fprintf(fid,'           t = s(ii(iii))*(%s)+(%s);\n',char(teqvedgeval(i,3)-teqvedgeval(i,2)),char(teqvedgeval(i,2)));
        fprintf(fid,'           x(ii(iii)) = %s;\n',char(curvedatsym{double(teqvedgeval(i,1))}.gfun(1)));
        fprintf(fid,'           y(ii(iii)) = %s;\n',char(curvedatsym{double(teqvedgeval(i,1))}.gfun(2)));
        % fix the "geometry error" bug
        fprintf(fid,'            if (s(ii(iii)) == 0)\n');
        fprintf(fid,'                x(ii(iii)) = psym(%d,1);\n',edge_list_unique(i,1));
        fprintf(fid,'                y(ii(iii)) = psym(%d,2);\n',edge_list_unique(i,1));
        fprintf(fid,'            end\n');
        fprintf(fid,'            if (s(ii(iii)) == 1)\n');
        fprintf(fid,'                x(ii(iii)) = psym(%d,1);\n',edge_list_unique(i,2));
        fprintf(fid,'                y(ii(iii)) = psym(%d,2);\n',edge_list_unique(i,2));
        fprintf(fid,'            end\n');
        % endfix
        fprintf(fid,'       end\n');        
    else
        fprintf(fid,'       t = s(ii);\n');
        fprintf(fid,'       x(ii) = psym(%d,1) + t*(psym(%d,1)-psym(%d,1));\n',edge_list_unique(i,1),edge_list_unique(i,2),edge_list_unique(i,1));
        fprintf(fid,'       y(ii) = psym(%d,2) + t*(psym(%d,2)-psym(%d,2));\n',edge_list_unique(i,1),edge_list_unique(i,2),edge_list_unique(i,1));
    end
    fprintf(fid,'   end\n');
end
fprintf(fid,'end\n');
fprintf(fid,'\n');
fclose(fid);

% define a bc "structure"
clear edgebcstruct;
switch probtype
    case {'TH','TH2'}
        for i = 1:length(edge)
            edgebcstruct{i}.dummy = [];
        end
        for i = 1:size(dirichlet.edge,1)
            edgebcstruct{dirichlet.edge(i)} = setfield(edgebcstruct{dirichlet.edge(i)},'r',dirichlet.r(i));
        end
        for i = 1:size(nload.edge,1)
            edgebcstruct{nload.edge(i)} = setfield(edgebcstruct{nload.edge(i)},'g',nload.g(i));
            edgebcstruct{nload.edge(i)} = setfield(edgebcstruct{nload.edge(i)},'q',nload.q(i));
        end
    case {'LE1','LE2','LE3','LE4','LE5'}
        for i = 1:length(edge)
            edgebcstruct{i}.dummy = [];
        end
        for i = 1:size(dirichlet.edge,1)
            edgebcstruct{dirichlet.edge(i)} = setfield(edgebcstruct{dirichlet.edge(i)},strcat('r',char(dirichlet.r(i,1))),dirichlet.r(i,2));
        end
        for i = 1:size(nload.g,1)
            edgebcstruct{nload.edge(i)} = setfield(edgebcstruct{nload.edge(i)},'gx',nload.g(i,1));
            edgebcstruct{nload.edge(i)} = setfield(edgebcstruct{nload.edge(i)},'gy',nload.g(i,2));
        end
end

switch probtype
    case {'TH','TH2'}
        fembc.n = 1;
        for i = 1:numnload
            [flag, tmploc] =  ismember(edge(nload.edge(i),[1,2]),edge_list_unique,'rows');
            if not(flag)
                [flag, tmploc] =  ismember(edge(nload.edge(i),[2,1]),edge_list_unique,'rows');
            end
            for iterm = 1:numnloadgroup
                fembc.neumann{iterm}{i}.edge = tmploc;
                fembc.neumann{iterm}{i}.q = {char(sym(nload_coeff(iterm)))};
                fembc.neumann{iterm}{i}.g = {char(sym(nload_coeff(iterm)))};
            end
        end
        for i = 1:size(dirichlet.edge,1)
            [flag, tmploc] =  ismember(edge(dirichlet.edge(i),[1,2]),edge_list_unique,'rows');
            if not(flag)
                [flag, tmploc] =  ismember(edge(dirichlet.edge(i),[2,1]),edge_list_unique,'rows');
            end
            fembc.dirichlet{1}{i}.edge = tmploc;
            fembc.dirichlet{1}{i}.h = {{1}};
            fembc.dirichlet{1}{i}.r = {char(sym(dirichlet.r(i)))};
        end
    case {'LE1','LE2','LE3','LE4','LE5'}
        fembc.n = 2;
        for i = 1:numnload
            [flag, tmploc] =  ismember(edge(nload.edge(i),[1,2]),edge_list_unique,'rows');
            if not(flag)
                [flag, tmploc] =  ismember(edge(nload.edge(i),[2,1]),edge_list_unique,'rows');
            end
            for iterm = 1:numnloadgroup
                fembc.neumann{iterm}{i}.edge = tmploc;
                fembc.neumann{iterm}{i}.q = {0,0;0,0};
                fembc.neumann{iterm}{i}.g = {char(sym(nload_coeff(iterm)));char(sym(nload_coeff(iterm)))};
            end
        end
        for i = 1:size(dirichlet.edge,1)
            [flag, tmploc] =  ismember(edge(dirichlet.edge(i),[1,2]),edge_list_unique,'rows');
            if not(flag)
                [flag, tmploc] =  ismember(edge(dirichlet.edge(i),[2,1]),edge_list_unique,'rows');
            end
            fembc.dirichlet{1}{i}.edge = tmploc;
            % when we do slanted constraint, we need to replace these "0" and "1" by something...
            % this will be the most messiest part
            if (isfield(edgebcstruct{dirichlet.edge(i)},'rx') && isfield(edgebcstruct{dirichlet.edge(i)},'ry'))
                    fembc.dirichlet{1}{i}.h = {{1,0};{0,1}}; 
                    fembc.dirichlet{1}{i}.r = {char(edgebcstruct{dirichlet.edge(i)}.rx);char(edgebcstruct{dirichlet.edge(i)}.ry)};
                elseif (isfield(edgebcstruct{dirichlet.edge(i)},'rx'))
                    fembc.dirichlet{1}{i}.h = {{1,0}}; 
                    fembc.dirichlet{1}{i}.r = {char(edgebcstruct{dirichlet.edge(i)}.rx)};
                elseif (isfield(edgebcstruct{dirichlet.edge(i)},'ry'))
                    fembc.dirichlet{1}{i}.h = {{0,1}}; 
                    fembc.dirichlet{1}{i}.r = {char(edgebcstruct{dirichlet.edge(i)}.ry)};
            end
        end
end
if not(isfield(fembc,'neumann'))
    for iterm = 1:numnloadgroup
        fembc.neumann{iterm} = [];
    end
end
if not(isfield(fembc,'dirichlet'))
    fembc.dirichlet = [];
end
    