figure(demogcf+2);
pdemesh(mesh.p,mesh.e,mesh.t);
set(demogcf+2,'Color','white');
saveas(demogcf+2,'log\fig\pdemesh','fig');
if (plotdemo)
    disp('FE mesh...;')
    pause
end;
close(demogcf+2);
fid = fopen(logmfname,'a');
fprintf(fid,'%%\n%%%% FE mesh...;\n%%\n');
fprintf(fid,'open(%s);\n','''log\fig\pdemesh.fig''');
fclose(fid);

% get \theta_a(muref)
for i = 1:Qa
    tmp = sym(Laffsunipos{i});  % Phuong: i was a q
    for j = 1:P
        tmp = subs(tmp,strcat('mu',num2str(j)),muref(j),0); % phuong 2/2/09
    end
    theta_a_ref(i) = tmp;
end

% compute all "bc" temporary components
for iterm = 1:numnloadgroup
    [tmp1,tmp2] = pde_assem2(femOPT,mesh,fembc.n,fembc.neumann{iterm},[]);
    Qtmp{iterm} = tmp1;
    Gtmp{iterm} = tmp2;
end

% tic
switch probtype
    case {'TH','TH2'}
        % assemble our "Kq" and "Fq"
        for i = 1:Qa
            Kq{i} = sparse(size(mesh.p,2),size(mesh.p,2));
        end
        for i = 1:Qm %cuong-23/6
            Mq{i} = sparse(size(mesh.p,2),size(mesh.p,2));
        end
        for i = 1:Qf
            Fq{i} = zeros(size(mesh.p,2),1);
        end
        M_ref = sparse(size(mesh.p,2),size(mesh.p,2));
        Masstmp = pde_assem1(femOPT,mesh,[],{0,0,0;0,0,0;0,0,1},0);
        Masstmp = Masstmp{3,3};
        % get Kq from assema
        for iterm = 1:numKgroup
            tmp1 = regexprep(regexprep(char(sym(kappa_coeff(iterm))),'*','.*'),'\^','.^');
            tmp0 = '0';
            for j = 2:length(tmp1)
                tmp0(j) = ' ';
            end            
            for i = 1:numdoms
                Ktmp = pde_assem1(femOPT,mesh,i,{tmp1,tmp1,tmp1;tmp1,tmp1,tmp1;tmp1,tmp1,tmp1},0);
                for j = 1:Qa
                    for i1 = 1:3
                        for i2 = 1:3
                            Kq{j} = Kq{j} + Boolecoeff((iterm-1)*Laffsize^2*numdoms+(i-1)*9+(i1-1)*3+i2,j)*Ktmp{i1,i2};
                        end
                    end
                end
            end            
        end
        for iterm = 1:numrhocgroup
            tmp1 = regexprep(regexprep(char(sym(rhoc_coeff(iterm))),'*','.*'),'\^','.^');
            for i = 1:numdoms
                Ktmp = pde_assem1(femOPT,mesh,i,{0,0,0;0,0,0;0,0,tmp1},0);
                for j = 1:Qm
                    Mq{j} = Mq{j} + MBoolecoeff((iterm-1)*numdoms+i,j)*Ktmp{3,3};
                end
            end
        end
        
        % get Fq from assemb
        % contribute from Neumann "flux"
        for iterm = 1:numnloadgroup
            for i = 1:length(nload.edge)
                for j = 1:Qf
                    Fq{j} = Fq{j} + RBoolecoeff((iterm-1)*numnload+i,j)*Gtmp{iterm}{i}{1};
                end
            end
        end
        % contribute from "f"
        for iterm = 1:numnloadgroup
            tmp1 = regexprep(regexprep(char(sym(nload_coeff(iterm))),'*','.*'),'\^','.^');
            for i = 1:numdoms
                [tmp,Ftmp] = pde_assem1(femOPT,mesh,i,{0,0,0;0,0,0;0,0,0},tmp1);
                for j = 1:Qf
                    Fq{j} = Fq{j} + RBoolecoeff(numnloadgroup*numnload+(iterm-1)*numdoms+i,j)*Ftmp{1};
                end
            end
        end
        % contribute from Neumann "Bi" and "ambient temp"
        for iterm = 1:numnloadgroup
            for i = 1:length(nload.edge)
                for j = 1:Qa
                    Kq{j} = Kq{j} + Boolecoeff(numKgroup*Laffsize^2*numdoms+(iterm-1)*numnload+i,j)*Qtmp{iterm}{i}{1,1};
                end
            end
        end
    case {'LE1','LE2','LE3','LE4','LE5'}
        % assemble our "Kq" and "Fq"
        for i = 1:Qa
            Kq{i} = sparse(2*size(mesh.p,2),2*size(mesh.p,2));
        end
        for i = 1:Qm %cuong-23/6
            Mq{i} = sparse(2*size(mesh.p,2),2*size(mesh.p,2));
        end
        for i = 1:Qf
            Fq{i} = zeros(2*size(mesh.p,2),1);
        end
        M_ref = sparse(2*size(mesh.p,2),2*size(mesh.p,2));
        Masstmp = pde_assem1(femOPT,mesh,[],{0,0,0,0,0,0; 0,0,0,0,0,0; 0,0,0,0,0,0; 0,0,0,0,0,0; 0,0,0,0,1,0; 0,0,0,0,0,1},{0;0});
        Masstmp = Masstmp{5,5} + Masstmp{6,6};
        for iterm = 1:numKgroup
            tmp1 = regexprep(regexprep(char(sym(matE_coeff(iterm))),'*','.*'),'\^','.^');
            tmp0 = '0';
            for j = 2:length(tmp1)
                tmp0(j) = ' ';
            end 
            for i = 1:numdoms
                Ktmp = pde_assem1(femOPT,mesh,i,{tmp1,tmp1,tmp1,tmp1,tmp1,tmp1; tmp1,tmp1,tmp1,tmp1,tmp1,tmp1;...
                                                           tmp1,tmp1,tmp1,tmp1,tmp1,tmp1; tmp1,tmp1,tmp1,tmp1,tmp1,tmp1;...
                                                           tmp1,tmp1,tmp1,tmp1,tmp1,tmp1; tmp1,tmp1,tmp1,tmp1,tmp1,tmp1},{0;0});
                for j = 1:Qa
                    for i1 = 1:6
                        for i2 = 1:6
                            Kq{j} = Kq{j} + Boolecoeff((iterm-1)*Laffsize^2*numdoms+(i-1)*Laffsize^2+(i1-1)*6+i2,j)*Ktmp{i1,i2};
                        end
                    end
                end
                
            end
        end
        %cuong-23/6 % this has to be outside the numKgroup loop (phuong)
        for iterm = 1:numrhocgroup
            tmp1 = regexprep(regexprep(char(sym(rhoc_coeff(iterm))),'*','.*'),'\^','.^');
            for i = 1:numdoms
                Ktmp = pde_assem1(femOPT,mesh,i,{0,0,0,0,0,0; 0,0,0,0,0,0; 0,0,0,0,0,0; 0,0,0,0,0,0;...
                                                           0,0,0,0,tmp1,0; 0,0,0,0,0,tmp1},{0;0});
                for j = 1:Qm
                    Mq{j} = Mq{j} + MBoolecoeff((iterm-1)*numdoms*2+(i-1)*2+1,j)*Ktmp{5,5};
                    Mq{j} = Mq{j} + MBoolecoeff((iterm-1)*numdoms*2+(i-1)*2+2,j)*Ktmp{6,6};
                end
            end
        end
        %cuong-23/6
        % get Fq from assemb
        for iterm = 1:numnloadgroup
            for i = 1:length(nload.edge)
                for j = 1:Qf
                    Fq{j} = Fq{j} + RBoolecoeff((iterm-1)*numnload*2+(i-1)*2+1,j)*Gtmp{iterm}{i}{1};
                    Fq{j} = Fq{j} + RBoolecoeff((iterm-1)*numnload*2+(i-1)*2+2,j)*Gtmp{iterm}{i}{2};
                end
            end
        end
        % contribute from "f"
        for iterm = 1:numnloadgroup
            tmp1 = regexprep(regexprep(char(sym(nload_coeff(iterm))),'*','.*'),'\^','.^');
            tmp0 = '0';
            for j = 2:length(tmp1)
                tmp0(j) = ' ';
            end 
            for i = 1:numdoms
                [tmp,Ftmp] = pde_assem1(femOPT,mesh,i,zeros(6,6),{tmp1;tmp1});
                for j = 1:Qf
                    Fq{j} = Fq{j} + RBoolecoeff(numnloadgroup*numnload*2+(iterm-1)*numdoms*2+(i-1)*2+1,j)*Ftmp{1};
                    Fq{j} = Fq{j} + RBoolecoeff(numnloadgroup*numnload*2+(iterm-1)*numdoms*2+(i-1)*2+2,j)*Ftmp{2};
                end
            end
        end
end
% toc

% contribute from Dirichlet b.c
% Step1: get uDIR by PDE Toolbox
% we can not use assempde as PDE toolbox does not support multiple "kappa"
[tmp1,tmp2,Htmp,Rtmp] = pde_assem2(femOPT,mesh,fembc.n,[],fembc.dirichlet);
[Btmp,Borth] = pdenullorth(Htmp{1});
if size(Borth,2)==0
    udtmp=zeros(size(Kq{1},1),1);
    Btmp = speye(size(Kq{1},1)); % phuong 25-9
else
    udtmp=full(Borth*((Htmp{1}*Borth)\Rtmp{1}));
end
Ktmp = 0*Kq{1};
for i = 1:Qa
    Ktmp = Ktmp + theta_a_ref(i)*Kq{i}; % atp-4/23 here (versus for M_ref) theta_a_ref is a good choice (probably the best of several choices)
end
uDIR = -Btmp*((Btmp'*Ktmp*Btmp)\(Btmp'*Ktmp*udtmp))+udtmp;
% Step 2: add the lifting vector to the current vector and update Qf
% cuong-8/18: fix bug 
for i = 1:Qa
    tmp = Kq{i}*uDIR;
    if nnz(tmp)>0;
        Qf = Qf + 1;
        Raffsunipos{Qf} = char(-sym(Laffsunipos{i}));
        Fq{Qf} = tmp;
    end
end
% cuong-8/18

% after this point, we compress Fq, as we now have (new) contributions
% from Kq's and they are unpredictable at first
if exist('RBoolecoeff') 
    old_RBoolecoeff = RBoolecoeff;
end
[Raffsunipos,RBoolecoeff] = symcompress(P, Raffsunipos,eye(Qf));
if length(Raffsunipos) == 0 %% null-defined Fq, which is not likely
    Fq{1} = zeros(length(Kq{1}),1);
    Raffsunipos{1} = '0';
    RBoolecoeff(1) = 1;
end
Ftmp = Fq;
clear Fq;
Qf = length(Raffsunipos);
for i = 1:size(RBoolecoeff,2)
    Fq{i} = zeros(length(Ftmp{1}),1);
    for j = 1:size(RBoolecoeff,1)
        Fq{i} = Fq{i} + RBoolecoeff(j,i)*Ftmp{j};
    end
end

% alternative elimination (for eigenproblems, but uDIR saved for L) --- need to check
ztmp = 0*Kq{1};
ztmpv = 0*Fq{1};
for i = 1:Qa
    Kqdirflux{i} = Kq{i};
    Ktmpq = Btmp'*Kq{i}*Btmp;
    Kq{i} = Ktmpq;
end;
% alternative approach for multiple kappa values
M_ref = Btmp'*Masstmp*Btmp;
for i = 1:Qf;
    Fqdirflux{i} = Fq{i};
    Ftmpq = Btmp'*Fq{i};
    Fq{i} = Ftmpq;
end
%cuong-23/6
for i = 1:Qm 
    Mqdirflux{i} = Mq{i};
    Mtmpq = Btmp'*Mq{i}*Btmp;
    Mq{i} = Mtmpq;
end
