% -----rbMIT Software Copyright MIT 2006-07----
%  DBP  Huynh,NC Nguyen, AT Patera, G Rozza
% Henceforth, Software shall refer to the rbMIT_System software package: 
% the contents of the rbMIT_Library and rbMIT_Aux folders.
% 
% This License governs use of all accompanying Software, and your download and/or use of the Software constitutes acceptance 
% of this License.
% 
% You may use this Software for any non-commercial purpose, subject to the restrictions in this license. 
% Some purposes which can be non-commercial are teaching and academic research.
% 
% You may not use or distribute this Software or any derivative works in any form for commercial purposes. 
% Examples of commercial purposes would be licensing, leasing, or selling the Software, or distributing the 
% Software for use with commercial products.
% 
% You may modify this Software and distribute the modified Software for non-commercial purposes,
%  however, you may not grant rights to the Software or derivative works that are broader than those 
% provided by this License. For example, you may not distribute modifications of the Software under terms 
% that would permit commercial use.
% 
% In return, we require that you agree:
% 
% not to remove any copyright or other notices from the Software;
% 
% that if you distribute the Software in source or object form, you will include a verbatim copy of this license;
% 
% that if you distribute derivative works of the Software in source code form you do so only under a license
% that includes all of the provisions of this License, and if you distribute derivative works of the Software solely 
% in object form you do so only under a license that complies with this License;
% 
% that if you have modified the Software or created derivative works, and distribute such modifications or derivative
% works, you will cause the modified files to carry prominent notices so that recipients know that they are not receiving the original Software;
% 
% THAT THE SOFTWARE COMES "AS IS", WITH NO WARRANTIES: THIS MEANS NO EXPRESS, IMPLIED OR STATUTORY WARRANTY, 
% INCLUDING WITHOUT LIMITATION WARRANTIES OF MERCHANTABILITY OR FITNESS FOR A PARTICULAR PURPOSE OR ANY WARRANTY 
% OF TITLE OR NON-INFRINGEMENT; YOU MUST PASS THIS DISCLAIMER ON WHENEVER YOU DISTRIBUTE THE SOFTWARE OR DERIVATIVE WORKS;
% 
% THAT NEITHER MIT NOR THE AUTHORS WILL BE LIABLE FOR ANY DAMAGES RELATED TO THE SOFTWARE OR THIS LICENSE, 
% INCLUDING DIRECT, INDIRECT, SPECIAL, CONSEQUENTIAL OR INCIDENTAL DAMAGES; YOU MUST PASS THIS LIMITATION OF LIABILITY 
% ON WHENEVER YOU DISTRIBUTE THE SOFTWARE OR DERIVATIVE WORKS;
% 
% that your rights under the License end automatically if you breach the License in any way;
% 
% that MIT reserves all rights not expressly granted to you in this License.
% 
% (Note: The wording of this license agreement is derived from a Microsoft Shared Source license agreement.)
% 
% License at http://augustine.mit.edu/rbMIT_SystemLicense.htm.
%
% rbMIT Software Part_II_and_IV
%
% ---------- 

% coefficient separations
switch probtype
    case {'TH','TH2'}
        % kappa symbolic separations
        [kappa_coeff, kappa_mat, kappa_coeffc] = symvarsep(kappa);
        numKgroup = length(kappa_coeffc);
        Lsepcoeff = kappa_coeff;
        
        [nload_coeff, tmp2, nload_coeffc] = symvarsep([nload.q(:);nload.g(:);fareaload]);
        numnloadgroup = length(nload_coeff);
        for i = 1:numnloadgroup
            nload_qvec{i} = tmp2{i}(1:numnload);
            nload_gvec{i} = tmp2{i}(numnload+1:2*numnload);
            fareaload_vec{i} = tmp2{i}(numnload*2+1:end);
        end
    case {'LE1','LE2','LE3','LE4'}   
        % E symbolic separations
        % no separation for E in 'LE3' and 'LE4' but we do it anyway to keep it compatible
        clear tmp;
        for i = 1:length(matprop)
            tmp{i} = matprop{i}.main(1);
        end
        [matE_coeff, matE_term, matE_coeffc] = symvarsep(tmp);
        numKgroup = length(matE_coeffc);
        Lsepcoeff = matE_coeff;
        if nloadnull
            tmp1 = [];
        else
            tmp1 = [nload.q(:,1);nload.q(:,2);nload.g(:,1);nload.g(:,2)];
        end
        [nload_coeff, tmp2, nload_coeffc] = symvarsep([tmp1;fareaload(:,1);fareaload(:,2)]);
        numnloadgroup = length(nload_coeff);
        for i = 1:numnloadgroup
            nload_qvec{i,1} = tmp2{i}(1:numnload);
            nload_qvec{i,2} = tmp2{i}(numnload+1:numnload*2);
            nload_gvec{i,1} = tmp2{i}(numnload*2+1:numnload*3);
            nload_gvec{i,2} = tmp2{i}(numnload*3+1:numnload*4);
            fareaload_vec{i,1} = tmp2{i}(numnload*4+1:numnload*4+numfareaload);
            fareaload_vec{i,2} = tmp2{i}(numnload*4+numfareaload+1:end);
        end
    case {'LE5'}
        % E symbolic separations
        clear tmp;
        for i = 1:length(matprop)
            tmp{i} = matprop{i}.main(1)*x;
            tmp{length(matprop)+i} = matprop{i}.main(1)*x^2;
            tmp{length(matprop)*2+i} = matprop{i}.main(1)*x^3;
        end
        [matE_coeff, matE_term, matE_coeffc] = symvarsep(tmp);
        numKgroup = length(matE_coeffc);
        Lsepcoeff = matE_coeff;
        if nloadnull
            [nload_coeff, tmp2, nload_coeffc] = symvarsep([fareaload(:,1)*x;fareaload(:,2)*x;...
                                                           fareaload(:,1)*x^2;fareaload(:,2)*x^2]);
        else
            [nload_coeff, tmp2, nload_coeffc] = symvarsep([nload.q(:,1)*x;nload.q(:,2)*x;nload.g(:,1)*x;nload.g(:,2)*x;fareaload(:,1)*x;fareaload(:,2)*x;...
                                                           nload.q(:,1)*x^2;nload.q(:,2)*x^2;nload.g(:,1)*x^2;nload.g(:,2)*x^2;fareaload(:,1)*x^2;fareaload(:,2)*x^2]);
        end
        numnloadgroup = length(nload_coeff);
        for i = 1:numnloadgroup
            nload_qvecx{i,1} = tmp2{i}(1:numnload);
            nload_qvecx{i,2} = tmp2{i}(numnload+1:numnload*2);
            nload_gvecx{i,1} = tmp2{i}(numnload*2+1:numnload*3);
            nload_gvecx{i,2} = tmp2{i}(numnload*3+1:numnload*4);
            fareaload_vecx{i,1} = tmp2{i}(numnload*4+1:numnload*4+numfareaload);
            fareaload_vecx{i,2} = tmp2{i}(numnload*4+numfareaload+1:numnload*4+numfareaload*2);
            nload_qvecx2{i,1} = tmp2{i}(numnload*4+numfareaload*2+1:numnload*4+numfareaload*2+numnload);
            nload_qvecx2{i,2} = tmp2{i}(numnload*4+numfareaload*2+numnload+1:numnload*4+numfareaload*2+numnload*2);
            nload_gvecx2{i,1} = tmp2{i}(numnload*4+numfareaload*2+numnload*2+1:numnload*4+numfareaload*2+numnload*3);
            nload_gvecx2{i,2} = tmp2{i}(numnload*4+numfareaload*2+numnload*3+1:numnload*4+numfareaload*2+numnload*4);
            fareaload_vecx2{i,1} = tmp2{i}(numnload*4+numfareaload*2+numnload*4+1:numnload*4+numnload*4+numfareaload*2+numfareaload);
            fareaload_vecx2{i,2} = tmp2{i}(numnload*4+numfareaload*2+numnload*4+numfareaload+1:end);
        end
end

% finally separate rhoc
[rhoc_coeff, rhoc_vec, rhoc_coeffc] = symvarsep(rhoc);
numrhocgroup = length(rhoc_coeff);
        
% symbolically compute all Laffs coefficient
for i = 1:numdoms
    vreal = char(psym(nodemap(i,:),:));
    for j = 1:P
        vreal = regexprep(vreal,strcat('mu',num2str(j)),char(murefsym(j)));
    end
    vreal = simplify(sym(vreal));
    % phuong 2/2/09
    if exist('mupad') % mupad gave bad inversion results if there is double involve 
        vreal = sym(double(vreal)); % convert to real to symbolic
    end
    vsym = reshape(psym(nodemap(i,:),:)',6,1);
    for j = 1:3
        Mtmp(j*2-1:j*2,:) = [1, 0, vreal(j,1), vreal(j,2), 0, 0; 0, 1, 0, 0, vreal(j,1), vreal(j,2)];
    end
    affvectmp = simplify(inv(sym(Mtmp))*vsym);
    Gafftmp = [affvectmp(3), affvectmp(4); affvectmp(5), affvectmp(6)]; % atp-6/1 (uncomment to get new)
    Jafftmp = det(Gafftmp);
    switch probtype
        case {'TH','TH2'}
            Daffsize = 3;
            Laffsize = 3;
            Dafftmp = sym(zeros(Daffsize,Daffsize));
            Dafftmp(1:2,1:2) = inv(Gafftmp);
            Dafftmp(3,3) = 1;
            % trick to avoid doing symbolic matrix separation
            for j = 1:9
                kappatmp = sym(zeros(3,3));
                kappatmp(floor((j-1)/3)+1, mod(j-1,3)+1) = 1;
                Laff_tmp{j} = Jafftmp*Dafftmp*kappatmp*transpose(Dafftmp);
            end
            for j = 1:numKgroup
                kappatmp = simplify(subs(kappa_mat{domgeo(i)}{j},...
                           {Cfun1,Cfun2,Gfun11,Gfun12,Gfun21,Gfun22},...
                           {affvectmp(1),affvectmp(2),affvectmp(3),affvectmp(4),affvectmp(5),affvectmp(6)},0));
                Lafftmp = kappatmp(1,1)*Laff_tmp{1} + kappatmp(1,2)*Laff_tmp{2} + kappatmp(1,3)*Laff_tmp{3}...
                          + kappatmp(2,1)*Laff_tmp{4} + kappatmp(2,2)*Laff_tmp{5} + kappatmp(2,3)*Laff_tmp{6}...
                          + kappatmp(3,1)*Laff_tmp{7} + kappatmp(3,2)*Laff_tmp{8}+ kappatmp(3,3)*Laff_tmp{9};
                Laff((j-1)*Laffsize^2*numdoms+(i-1)*Laffsize^2+1:(j-1)*Laffsize^2*numdoms+i*Laffsize^2) = simplify(reshape(Lafftmp',Laffsize,Laffsize));
            end
        case {'LE1','LE2','LE3','LE4','LE5'}
            Daffsize = 4;
            Laffsize = 6;
            Dafftmp = sym(zeros(4,4));
            Dafftmp([1,2],[1,2]) = inv(Gafftmp);
            Dafftmp([3,4],[3,4]) = inv(Gafftmp);
            if strcmp(probtype,'LE5')
                Daffsize = 5;
                Laffsize = 6;
                Dafftmp = sym(zeros(4,4));
                Dafftmp([1,2],[1,2]) = inv(Gafftmp);
                Dafftmp([3,4],[3,4]) = inv(Gafftmp);
                Dafftmp(5,5) = 1;
            end
            for j = 1:numKgroup
                switch probtype
                    case {'LE1','LE2'} % isotropic
                        Etmp = simplify(subs(matE_term{domgeo(i)}{j},...
                                        {Cfun1,Cfun2,Gfun11,Gfun12,Gfun21,Gfun22},...
                                        {affvectmp(1),affvectmp(2),affvectmp(3),affvectmp(4),affvectmp(5),affvectmp(6)},0));
                        nutmp = matprop{domgeo(i)}.main(2);
                        switch probtype
                            case 'LE1'
                                lame1 = Etmp*nutmp/((1+nutmp)*(1-2*nutmp));
                                lame2 = Etmp/(2*(1+nutmp));
                            case 'LE2'
                                lame1 = Etmp*nutmp/(1-nutmp^2);
                                lame2 = Etmp/(2*(1+nutmp));
                        end
                        % Cijkl = lame1*[1,0,0,1;0,0,0,0;0,0,0,0;1,0,0,1] + lame2*[2,0,0,0;0,1,1,0;0,1,1,0;0,0,0,2];
                        % trick to avoid doing symbolic matrix separation
                        Laff_tmp{1} = Jafftmp*Dafftmp*[1,0,0,1;0,0,0,0;0,0,0,0;1,0,0,1]*transpose(Dafftmp);
                        Laff_tmp{2} = Jafftmp*Dafftmp*[2,0,0,0;0,1,1,0;0,1,1,0;0,0,0,2]*transpose(Dafftmp);
                        Lafftmp = lame1*Laff_tmp{1} + lame2*Laff_tmp{2};
                        % "Mass" components
                        Lafftmp(5,5) = matprop{domgeo(i)}.aux(1)*Jafftmp;
                        Lafftmp(6,6) = matprop{domgeo(i)}.aux(2)*Jafftmp;
                    case {'LE3','LE4'} % orthotropic
                        switch probtype
                            case 'LE3'
                                E11 = matprop{domgeo(i)}.main(1); E22 = matprop{domgeo(i)}.main(2); E33 = matprop{domgeo(i)}.main(3);
                                nu12 = matprop{domgeo(i)}.main(4); nu23 = matprop{domgeo(i)}.main(5); nu13 = matprop{domgeo(i)}.main(6);
                                G12 = matprop{domgeo(i)}.main(7);
                                tmp = sym(zeros(3,3));
                                tmp([1:2],[1:2]) = [-(E22-nu23^2*E33)*E11^2, -(nu12*E22+nu23*nu13*E33)*E11*E22;...
                                    -(nu12*E22+nu23*nu13*E33)*E11*E22, -(E11-nu13^2*E33)*E22^2]/(-E11*E22+E11*nu23^2*E33+nu12^2*E22^2+2*nu12*E22*nu23*nu13*E33+nu13^2*E22*E33);
                                tmp(3,3) = G12;
                            case 'LE4'
                                E11 = matprop{domgeo(i)}.main(1); E22 = matprop{domgeo(i)}.main(2);
                                nu12 = matprop{domgeo(i)}.main(3);
                                G12 = matprop{domgeo(i)}.main(4);
                                tmp = [-1/(-E11+nu12^2*E22)*E11^2, -nu12*E11/(-E11+nu12^2*E22)*E22, 0;...
                                    -nu12*E11/(-E11+nu12^2*E22)*E22, -E11/(-E11+nu12^2*E22)*E22, 0;...
                                    0, 0, G12];
                        end
                        tmp = [1,0,0,0;0,0,0,1;0,1,1,0]'*tmp*[1,0,0,0;0,0,0,1;0,1,1,0];
                        % trick to avoid doing symbolic matrix separation
                        Lafftmp = Jafftmp*Dafftmp*tmp*transpose(Dafftmp);% "Mass" components
                        Lafftmp(5,5) = matprop{domgeo(i)}.aux(1)*Jafftmp;
                        Lafftmp(6,6) = matprop{domgeo(i)}.aux(2)*Jafftmp;
                    case {'LE5'} % axisymmetric
                        Etmp = simplify(subs(matE_term{domgeo(i)}{j},...
                                        {Cfun1,Cfun2,Gfun11,Gfun12,Gfun21,Gfun22},...
                                        {affvectmp(1),affvectmp(2),affvectmp(3),affvectmp(4),affvectmp(5),affvectmp(6)},0));
                        Eytmp = simplify(subs(matE_term{domgeo(i)+length(matprop)}{j},...
                                         {Cfun1,Cfun2,Gfun11,Gfun12,Gfun21,Gfun22},...
                                         {affvectmp(1),affvectmp(2),affvectmp(3),affvectmp(4),affvectmp(5),affvectmp(6)},0));
                        Ey2tmp = simplify(subs(matE_term{domgeo(i)+length(matprop)*2}{j},...
                                          {Cfun1,Cfun2,Gfun11,Gfun12,Gfun21,Gfun22},...
                                          {affvectmp(1),affvectmp(2),affvectmp(3),affvectmp(4),affvectmp(5),affvectmp(6)},0));            
                        nutmp = matprop{domgeo(i)}.main(2);
                        
                        lame1 = (1-nutmp)/((1+nutmp)*(1-2*nutmp));
                        lame2 = nutmp/((1+nutmp)*(1-2*nutmp));
                        lame3 = 1/(2*(1+nutmp));

                        Cmattmp = [Ey2tmp*lame1, 0, 0, Eytmp*lame2, Eytmp*(lame1+lame2);...
                                   0, Ey2tmp*lame3, Eytmp*lame3, 0, 0;...
                                   0, Eytmp*lame3, Etmp*lame3, 0, 0;...
                                   Eytmp*lame2, 0, 0, Etmp*lame1, 2*Etmp*lame2;...
                                   Eytmp*(lame1+lame2), 0, 0, 2*Etmp*lame2, 2*Etmp*(lame1+lame2)];
                        Lafftmp = Jafftmp*Dafftmp*Cmattmp*transpose(Dafftmp);
                        Lafftmp(6,6) = matprop{domgeo(i)}.aux(2)*Jafftmp;
                end
                Laff((j-1)*Laffsize^2*numdoms+(i-1)*Laffsize^2+1:(j-1)*Laffsize^2*numdoms+i*Laffsize^2) = simplify(reshape(transpose(Lafftmp),Laffsize,Laffsize));
            end
    end
    
    Caff((i-1)*2+1:i*2) = simplify(affvectmp(1:2));
    Gaff((i-1)*4+1:i*4) = simplify(affvectmp(3:6));
    Jaffs(i) = simplify(Jafftmp);
    Daff((i-1)*Daffsize^2+1:i*Daffsize^2) = simplify(reshape(transpose(Dafftmp),Daffsize,Daffsize));
end
Caffs = transpose(reshape(Caff,2,numdoms));
Gaffs = transpose(reshape(Gaff,4,numdoms));
Daffs = transpose(reshape(Daff,Daffsize^2,numdoms));
Laffs = transpose(reshape(Laff,Laffsize^2,numdoms*numKgroup));
% find an unique Laffs set
Laffstmp = transpose(Laffs);
Laffstmp = Laffstmp(:);
for i = 1:length(Laffstmp)
    if exist('mupad') % phuong 2/2/09 (speed up mupad)
        Laffstmp(i) = simplify(Laffstmp(i));;
    else
        [tmp,tmp2] = simple(Laffstmp(i));
        Laffstmp(i) = tmp;
    end
end
for i = 1:length(Laffstmp)
    if( isempty( findsym( Laffstmp(i) ) ) )
        if( abs( double(Laffstmp(i)) ) <= 1e-10)
            Laffstmp(i) = sym('0');
        end;
    end;
end

for i = 1:length(Laffstmp)
    Laffstmpc{i} = char(Laffstmp(i));
end

[Laffsunique,upun,downun] = unique(Laffstmpc);
[Laffsunipos,updiff] = setdiff(Laffsunique,{'0.','0','0.0'}); %phuong 2/2/09
Qa = length(Laffsunipos);
% map the Boolecoeff matrix
for q = 1:Qa
    Boolecoeff(:,q) = (downun(:) == updiff(q));
end

% symbolically compute all Raffs coefficient
% contributions from Neumann b.c
for i = 1:length(nload.edge)
    % get Gaff
    for j = 1:numdoms
        flag = ismember(edge(nload.edge(i),:),[nodemap(j,[1,2]);nodemap(j,[2,1]);nodemap(j,[2,3]);nodemap(j,[3,2]);nodemap(j,[1,3]);nodemap(j,[3,1])],'rows');
        if flag
            nGaff{i} = Gaffs(j,:);
            nCaff{i} = Caffs(j,:);
            break;
        end
    end
    [en,et] = getedgevec(edge(nload.edge(i),:),psym,preal,nodemap); % phuong 9/3
    ettmp(i,:) = et; entmp(i,:) = en;
    Rafftmp(i) = abs(simplify(sqrt((nGaff{i}(1)*et(1) + nGaff{i}(2)*et(2))^2+(nGaff{i}(3)*et(1)+nGaff{i}(4)*et(2))^2)));
    % phuong 15-8 (try to eliminate some "abs" if there is any)
    tmp = char(Rafftmp(i));
    for j = 1:P
        if psign(j) ~= 0
            tmp = regexprep(tmp,['abs\(mu',num2str(j),'\)'],['(',num2str(psign(j)),'*mu',num2str(j),')']);
        end
    end
    Rafftmp(i) = simplify(sym(tmp));
    % phuong 15-8
end
switch probtype
    case {'TH','TH2'}
        % contributions from nload "g"
        for iterm = 1:numnloadgroup
            for i = 1:length(nload.edge)
                tmp = simplify(subs(nload_gvec{iterm}(i),...
                      {Cfun1,Cfun2,Gfun11,Gfun12,Gfun21,Gfun22},...
                      {nCaff{i}(1),nCaff{i}(2),nGaff{i}(1),nGaff{i}(2),nGaff{i}(3),nGaff{i}(4)},0));
                Raffs((iterm-1)*numnload+i) = simplify(Rafftmp(i)*tmp);
            end
        end
        % contributions from fareaload "f"
        for iterm = 1:numnloadgroup
            for i = 1:numdoms
                tmp = simplify(subs(fareaload_vec{iterm}(domgeo(i)),...
                               {Cfun1,Cfun2,Gfun11,Gfun12,Gfun21,Gfun22},...
                               {Caffs(i,1),Caffs(i,2),Gaffs(i,1),Gaffs(i,2),Gaffs(i,3),Gaffs(i,4)},0));
                Raffs(numnloadgroup*numnload+(iterm-1)*numdoms+i) = simplify(Jaffs(i)*tmp);
            end
        end
    case {'LE1','LE2','LE3','LE4'}
        % contributions from nload "g"
        for iterm = 1:numnloadgroup
            for i = 1:length(nload.edge)
                tmp1 = simplify(subs(nload_gvec{iterm,1}(i),...
                       {Cfun1,Cfun2,Gfun11,Gfun12,Gfun21,Gfun22},...
                       {nCaff{i}(1),nCaff{i}(2),nGaff{i}(1),nGaff{i}(2),nGaff{i}(3),nGaff{i}(4)},0));
                tmp2 = simplify(subs(nload_gvec{iterm,2}(i),...
                       {Cfun1,Cfun2,Gfun11,Gfun12,Gfun21,Gfun22},...
                       {nCaff{i}(1),nCaff{i}(2),nGaff{i}(1),nGaff{i}(2),nGaff{i}(3),nGaff{i}(4)},0));
                Raffs((iterm-1)*numnload*2+(i-1)*2+1) = simplify(Rafftmp(i)*tmp1*ettmp(i,1)+Rafftmp(i)*tmp2*entmp(i,1));
                Raffs((iterm-1)*numnload*2+(i-1)*2+2) = simplify(Rafftmp(i)*tmp1*ettmp(i,2)+Rafftmp(i)*tmp2*entmp(i,2));
            end
        end
        % contributions from fareaload "f"
        for iterm = 1:numnloadgroup
            for i = 1:numdoms
                tmp1 = simplify(subs(fareaload_vec{iterm,1}(domgeo(i)),...
                                {Cfun1,Cfun2,Gfun11,Gfun12,Gfun21,Gfun22},...
                                {Caffs(i,1),Caffs(i,2),Gaffs(i,1),Gaffs(i,2),Gaffs(i,3),Gaffs(i,4)},0));
                tmp2 = simplify(subs(fareaload_vec{iterm,2}(domgeo(i)),...
                                {Cfun1,Cfun2,Gfun11,Gfun12,Gfun21,Gfun22},...
                                {Caffs(i,1),Caffs(i,2),Gaffs(i,1),Gaffs(i,2),Gaffs(i,3),Gaffs(i,4)},0));           
                Raffs(numnloadgroup*numnload*2+(iterm-1)*numdoms*2+(i-1)*2+1) = simplify(Jaffs(i)*tmp1);
                Raffs(numnloadgroup*numnload*2+(iterm-1)*numdoms*2+(i-1)*2+2) = simplify(Jaffs(i)*tmp2);
            end
        end
    case {'LE5'}
        % contributions from nload "g"
        for iterm = 1:numnloadgroup
            for i = 1:length(nload.edge)
                tmp1 = simplify(subs(nload_gvecx2{iterm,1}(i),...
                       {Cfun1,Cfun2,Gfun11,Gfun12,Gfun21,Gfun22},...
                       {nCaff{i}(1),nCaff{i}(2),nGaff{i}(1),nGaff{i}(2),nGaff{i}(3),nGaff{i}(4)},0));
                tmp2 = simplify(subs(nload_gvecx2{iterm,2}(i),...
                       {Cfun1,Cfun2,Gfun11,Gfun12,Gfun21,Gfun22},...
                       {nCaff{i}(1),nCaff{i}(2),nGaff{i}(1),nGaff{i}(2),nGaff{i}(3),nGaff{i}(4)},0));
                tmp3 = simplify(subs(nload_gvecx{iterm,1}(i),...
                       {Cfun1,Cfun2,Gfun11,Gfun12,Gfun21,Gfun22},...
                       {nCaff{i}(1),nCaff{i}(2),nGaff{i}(1),nGaff{i}(2),nGaff{i}(3),nGaff{i}(4)},0));
                tmp4 = simplify(subs(nload_gvecx{iterm,2}(i),...
                       {Cfun1,Cfun2,Gfun11,Gfun12,Gfun21,Gfun22},...
                       {nCaff{i}(1),nCaff{i}(2),nGaff{i}(1),nGaff{i}(2),nGaff{i}(3),nGaff{i}(4)},0));
                Raffs((iterm-1)*numnload*2+(i-1)*2+1) = simplify(Rafftmp(i)*tmp1*ettmp(i,1)+Rafftmp(i)*tmp2*entmp(i,1));
                Raffs((iterm-1)*numnload*2+(i-1)*2+2) = simplify(Rafftmp(i)*tmp3*ettmp(i,2)+Rafftmp(i)*tmp4*entmp(i,2));
            end
        end
        % contributions from fareaload "f"
        for iterm = 1:numnloadgroup
            for i = 1:numdoms
                tmp1 = simplify(subs(fareaload_vecx2{iterm,1}(domgeo(i)),...
                                {Cfun1,Cfun2,Gfun11,Gfun12,Gfun21,Gfun22},...
                                {Caffs(i,1),Caffs(i,2),Gaffs(i,1),Gaffs(i,2),Gaffs(i,3),Gaffs(i,4)},0));
                tmp2 = simplify(subs(fareaload_vecx{iterm,2}(domgeo(i)),...
                                {Cfun1,Cfun2,Gfun11,Gfun12,Gfun21,Gfun22},...
                                {Caffs(i,1),Caffs(i,2),Gaffs(i,1),Gaffs(i,2),Gaffs(i,3),Gaffs(i,4)},0));           
                Raffs(numnloadgroup*numnload*2+(iterm-1)*numdoms*2+(i-1)*2+1) = simplify(Jaffs(i)*tmp1);
                Raffs(numnloadgroup*numnload*2+(iterm-1)*numdoms*2+(i-1)*2+2) = simplify(Jaffs(i)*tmp2);
            end
        end        
end
% find an unique Raffs set
Raffstmp = Raffs(:);
for i = 1:length(Raffstmp)
    Raffstmpc{i} = char(Raffstmp(i));
end
[Raffsunique,upun,downun] = unique(Raffstmpc);
[Raffsunipos,updiff] = setdiff(Raffsunique,{'0.','0','0.0'}); %phuong 2/2/09
Qf = length(Raffsunipos);
% map the RBoolecoeff matrix
for q = 1:Qf
    RBoolecoeff(:,q) = (downun(:) == updiff(q));
end

% cuong-6/23
% symbolically compute all Maffs coefficient
for iterm = 1:numrhocgroup
    for i = 1:numdoms
        rhoctmp = simplify(subs(rhoc_vec{iterm}(domgeo(i)),...
                           {Cfun1,Cfun2,Gfun11,Gfun12,Gfun21,Gfun22},...
                           {Caffs(i,1),Caffs(i,2),Gaffs(i,1),Gaffs(i,2),Gaffs(i,3),Gaffs(i,4)},0));
        switch probtype
            case {'TH','TH2'}
                Maffs((iterm-1)*numdoms+i) = simplify(rhoctmp*Jaffs(i));
            case {'LE1','LE2','LE3','LE4','LE5'}
                Maffs((iterm-1)*numdoms*2+(i-1)*2+1) = simplify(rhoctmp*Jaffs(i));
                Maffs((iterm-1)*numdoms*2+(i-1)*2+2) = simplify(rhoctmp*Jaffs(i));
        end
    end
end
% find an unique Maffs set
Maffstmp = Maffs(:);
for i = 1:length(Maffstmp)
    Maffstmpc{i} = char(Maffstmp(i));
end
[Maffsunique,upun,downun] = unique(Maffstmpc);
[Maffsunipos,updiff] = setdiff(Maffsunique,{'0.','0','0.0'}); %phuong 2/2/09
Qm = length(Maffsunipos);
% map the MBoolecoeff matrix
for q = 1:Qm
    MBoolecoeff(:,q) = (downun(:) == updiff(q));
end
% cuong-6/23 

% add all possible "q" coefficients
switch probtype
    case {'TH','TH2'}
        if (nloadnull ~= 1)  % Phuong to check O.K. (checked)
            for iterm = 1:length(nload_qvec)
                for i = 1:numnload
                    tmp = simplify(subs(nload_qvec{iterm}(i),...
                          {Cfun1,Cfun2,Gfun11,Gfun12,Gfun21,Gfun22},...
                          {nCaff{i}(1),nCaff{i}(2),nGaff{i}(1),nGaff{i}(2),nGaff{i}(3),nGaff{i}(4)},0));
                    qaffstmp(i) = simplify(Rafftmp(i)*tmp);
                end
                for i = 1:length(qaffstmp)
                    qaffstmpc{i} = char(qaffstmp(i));
                end
                [qaffsunique,tmp,qindex] = unique(qaffstmpc);
                % add to the Boolean matrix
                Boolecoeff = [Boolecoeff;zeros(length(nload_qvec{iterm}),Qa)];
                for i = 1:length(qaffsunique)
                    if not(strcmp(qaffsunique{i},'0')) && not(strcmp(qaffsunique{i},'0.')) && not(strcmp(qaffsunique{i},'0.0')) % phuong 2/2/09
                        Qa = length(Laffsunipos)+1;
                        Laffsunipos{Qa} = qaffsunique{i};
                        Boolecoeff(:,Qa) = zeros(size(Boolecoeff,1),1);
                        tmp = find(qindex == i);
                        Boolecoeff(numKgroup*numdoms*Laffsize^2+(iterm-1)*numnload+tmp,Qa) = ones(length(tmp),1);
                    end
                end
            end
        end
end
% eliminate some funny functions (signum)
for i = 1: length(Laffsunipos)
    Laffsunipos{i} = regexprep(Laffsunipos{i},'signum','');
end
for i = 1: length(Maffsunipos)
    Maffsunipos{i} = regexprep(Maffsunipos{i},'signum','');
end
% further "compress" Laffs and Maffs
[Laffsunipos, Boolecoeff] = symcompress(P, Laffsunipos, Boolecoeff);
[Maffsunipos, MBoolecoeff] = symcompress(P, Maffsunipos, MBoolecoeff);

Qa = length(Laffsunipos);
Qf = length(Raffsunipos);
Qm = length(Maffsunipos); % cuong-6/23 