
% -----rbMIT Software Copyright MIT 2006-07-08---
%  DBP  Huynh,NC Nguyen, AT Patera, G Rozza
% Henceforth, Software shall refer to the rbMIT_System software package: 
% the contents of the rbMIT_Library and rbMIT_Aux folders.
% 
% This License governs use of all accompanying Software, and your download and/or use of the Software constitutes acceptance 
% of this License.
% 
% You may use this Software for any non-commercial purpose, subject to the restrictions in this license. 
% Some purposes which can be non-commercial are teaching and academic research.
% 
% You may not use or distribute this Software or any derivative works in any form for commercial purposes. 
% Examples of commercial purposes would be licensing, leasing, or selling the Software, or distributing the 
% Software for use with commercial products.
% 
% You may modify this Software and distribute the modified Software for non-commercial purposes,
%  however, you may not grant rights to the Software or derivative works that are broader than those 
% provided by this License. For example, you may not distribute modifications of the Software under terms 
% that would permit commercial use.
% 
% In return, we require that you agree:
% 
% not to remove any copyright or other notices from the Software;
% 
% that if you distribute the Software in source or object form, you will include a verbatim copy of this license;
% 
% that if you distribute derivative works of the Software in source code form you do so only under a license
% that includes all of the provisions of this License, and if you distribute derivative works of the Software solely 
% in object form you do so only under a license that complies with this License;
% 
% that if you have modified the Software or created derivative works, and distribute such modifications or derivative
% works, you will cause the modified files to carry prominent notices so that recipients know that they are not receiving the original Software;
% 
% THAT THE SOFTWARE COMES "AS IS", WITH NO WARRANTIES: THIS MEANS NO EXPRESS, IMPLIED OR STATUTORY WARRANTY, 
% INCLUDING WITHOUT LIMITATION WARRANTIES OF MERCHANTABILITY OR FITNESS FOR A PARTICULAR PURPOSE OR ANY WARRANTY 
% OF TITLE OR NON-INFRINGEMENT; YOU MUST PASS THIS DISCLAIMER ON WHENEVER YOU DISTRIBUTE THE SOFTWARE OR DERIVATIVE WORKS;
% 
% THAT NEITHER MIT NOR THE AUTHORS WILL BE LIABLE FOR ANY DAMAGES RELATED TO THE SOFTWARE OR THIS LICENSE, 
% INCLUDING DIRECT, INDIRECT, SPECIAL, CONSEQUENTIAL OR INCIDENTAL DAMAGES; YOU MUST PASS THIS LIMITATION OF LIABILITY 
% ON WHENEVER YOU DISTRIBUTE THE SOFTWARE OR DERIVATIVE WORKS;
% 
% that your rights under the License end automatically if you breach the License in any way;
% 
% that MIT reserves all rights not expressly granted to you in this License.
% 
% (Note: The wording of this license agreement is derived from a Microsoft Shared Source license agreement.)
% 
% License at http://augustine.mit.edu/rbMIT_SystemLicense.htm.
%
% rbMIT Software Part_II_and_IV
%
% ---------- 

% Step1 output symbolic (2-d)
% determine system
if ispc
    sslash = '\';
elseif isunix
    sslash = '/';
end
load(strcat('..',sslash,probname,'_','SYMB'))
load(strcat('..',sslash,probname,'_','pr_PROBDEF'))
pr_PROBDEF = evalin('base',strcat(probname,'_','pr_PROBDEF'));

clear du_PROBDEF du_OFFLINE du_ONLINE

% dirfluxflag conversion
if ( exist('dLIFT') && (~ismember('[]',dLIFT,'rows')) ) % atp-4/23 (parens just in case)
    tmp = sym2fracsym(sym(dLIFT));
    clear dLIFT;
    if ( ~isempty( setdiff(double(tmp(:,1)),dirichlet.edge) )   ) % atp-4/23 homogeneous Dirichlet edges are also O.K.
        fprintf('Error: dLIFT is invalid!\n');
        fprintf('       dLIFT must be a subset of the Dirichlet edges!\n'); % atp-4/23 homogeneous Dirichlet edges are also O.K.
        return;
    end
    switch probtype
        case {'TH','TH2'}
            dLIFT.edge = double(tmp(:,1));
            dLIFT.r = sym(tmp(:,2));
        case {'LE1','LE2','LE3','LE4','LE5'}
            dLIFT.edge = double(tmp(:,1));
            dLIFT.r = sym([tmp(:,2),tmp(:,3)]);
    end
    dirfluxflag = 1;    
else
    dirfluxflag = 0;
end

switch probtype
    case {'TH','TH2'}
        % oareaload conversion
        for i = 1:length(geometry)
            oarealoadtmp(i,1) = sym(0);
        end
        if ( exist('oareaload') && (~ismember('[]',oareaload,'rows')) ) % atp-4/23 (parens)
            oareaload = sym2fracsym(sym(oareaload));
            for i = 1:size(oareaload,1)
                oarealoadtmp(double(oareaload(i,1))) = sym(oareaload(i,2));
            end
        end
        oareaload = oarealoadtmp;
        clear oarealoadtmp;

        % oload conversion
        if ( not(exist('oload')) || ismember('[]',oload,'rows') ) % atp-4/23
            clear oload;
            oloadnull = 1;
            oload.edge = [];
            oload.g = [];
        else
            oloadnull = 0;
            tmp = sym2fracsym(sym(oload));
            clear oload;
            oload.edge = double(tmp(:,1));
            oload.g = sym(tmp(:,2));
        end
        % axisymmetric modifications
        if strcmp(probtype,'TH2')
            oareaload = x*oareaload;
            for j = 1:length(oload.edge)
                oload.g(j) = x*oload.g(j);
            end
        end
    case {'LE1','LE2','LE3','LE4','LE5'}
        % oareaload conversion
        for i = 1:length(geometry)
            oarealoadtmp(i,:) = sym([0,0]);
        end
        if (exist('oareaload') && (~ismember('[]',oareaload,'rows')))
            oareaload = sym2fracsym(sym(oareaload));
            for i = 1:size(oareaload,1)
                oarealoadtmp(double(oareaload(i,1)),:) = sym([oareaload(i,2),oareaload(i,3)]);
            end
        end
        oareaload = oarealoadtmp;
        clear oarealoadtmp;
        % b.c conversion
        if ( not(exist('oload')) || ismember('[]',oload,'rows') )  % atp-4/23 (parens)
            clear oload;
            oloadnull = 1;
            oload.edge = [];
            oload.g = [];
            oload.q = [];
        else
            oloadnull = 0;
            tmp = sym2fracsym(sym(oload));
            clear oload;
            oload.edge = double(tmp(:,1));
            oload.g = sym([tmp(:,3), tmp(:,2)]); % phuong 3/9
            oload.q = 0*oload.g; % phuong 3/9
        end
end

ne = size(edge,1);  % atp: to check this really works...% atpfixed below
% atp-4/24 below (added dLIFT stuff)
if(ne > ne0 & oloadnull == 0)
    for ie = ne0+1:ne;
        nol = length(oload.edge);
        tmp = find(rootedge(ie) == oload.edge);
        if tmp>0
            oload.edge(nol+1) = ie;
            oload.g(nol+1,:) = oload.g(tmp,:);
        end
        if (exist('dLIFT'))
            ndLIFT = length(dLIFT.edge);
            tmp = find(rootedge(ie) == dLIFT.edge);
            if tmp>0
                dLIFT.edge(ndLIFT+1) = ie;
                dLIFT.r(ndLIFT+1,:) = dLIFT.r(tmp,:);
            end
        end
    end;
end; % atpfixed above
% atp-4/24 above

numoload = length(oload.edge);
numoareaload = size(oareaload,1);
% coefficient separations
switch probtype
    case {'TH','TH2'}
        % oload symbolic separations
        [oload_coeff, tmp2, oload_coeffc] = symvarsep([oload.g(:);oareaload]);
        numoloadgroup = length(oload_coeff);
        for i = 1:numoloadgroup
            oload_gvec{i} = tmp2{i}(1:numoload);
            oareaload_vec{i} = tmp2{i}(numoload+1:end);
        end
    case {'LE1','LE2','LE3','LE4'}   
        % oload symbolic separations
        if oloadnull
            tmp1 = [];
        else
            tmp1 = [oload.q(:,1);oload.q(:,2);oload.g(:,1);oload.g(:,2)];
        end
        [oload_coeff, tmp2, oload_coeffc] = symvarsep([tmp1;oareaload(:,1);oareaload(:,2)]);
        numoloadgroup = length(oload_coeff);
        for i = 1:numoloadgroup
            oload_qvec{i,1} = tmp2{i}(1:numoload);
            oload_qvec{i,2} = tmp2{i}(numoload+1:numoload*2);
            oload_gvec{i,1} = tmp2{i}(numoload*2+1:numoload*3);
            oload_gvec{i,2} = tmp2{i}(numoload*3+1:numoload*4);
            oareaload_vec{i,1} = tmp2{i}(numoload*4+1:numoload*4+numoareaload);
            oareaload_vec{i,2} = tmp2{i}(numoload*4+numoareaload+1:end);
        end
    case {'LE5'}
        if oloadnull
            [oload_coeff, tmp2, oload_coeffc] = symvarsep([oareaload(:,1)*x^2;oareaload(:,2)*x^2;...
                                                           oareaload(:,1)*x^3;oareaload(:,2)*x^3]);
        else
            [oload_coeff, tmp2, oload_coeffc] = symvarsep([oload.q(:,1)*x;oload.q(:,2)*x;oload.g(:,1)*x;oload.g(:,2)*x;oareaload(:,1)*x^2;oareaload(:,2)*x^2;...
                                                           oload.q(:,1)*x^2;oload.q(:,2)*x^2;oload.g(:,1)*x^2;oload.g(:,2)*x^2;oareaload(:,1)*x^3;oareaload(:,2)*x^3]);
        end
        numoloadgroup = length(oload_coeff);
        for i = 1:numoloadgroup
            oload_qvecx{i,1} = tmp2{i}(1:numoload);
            oload_qvecx{i,2} = tmp2{i}(numoload+1:numoload*2);
            oload_gvecx{i,1} = tmp2{i}(numoload*2+1:numoload*3);
            oload_gvecx{i,2} = tmp2{i}(numoload*3+1:numoload*4);
            oareaload_vecx{i,1} = tmp2{i}(numoload*4+1:numoload*4+numoareaload);
            oareaload_vecx{i,2} = tmp2{i}(numoload*4+numoareaload+1:numoload*4+numoareaload*2);
            oload_qvecx2{i,1} = tmp2{i}(numoload*4+numoareaload*2+1:numoload*4+numoareaload*2+numoload);
            oload_qvecx2{i,2} = tmp2{i}(numoload*4+numoareaload*2+numoload+1:numoload*4+numoareaload*2+numoload*2);
            oload_gvecx2{i,1} = tmp2{i}(numoload*4+numoareaload*2+numoload*2+1:numoload*4+numoareaload*2+numoload*3);
            oload_gvecx2{i,2} = tmp2{i}(numoload*4+numoareaload*2+numoload*3+1:numoload*4+numoareaload*2+numoload*4);
            oareaload_vecx2{i,1} = tmp2{i}(numoload*4+numoareaload*2+numoload*4+1:numoload*4+numoload*4+numoareaload*2+numoareaload);
            oareaload_vecx2{i,2} = tmp2{i}(numoload*4+numoareaload*2+numoload*4+numoareaload+1:end);
        end
end

switch probtype
    case {'TH','TH2'}
        fembco.n = 1;
        for i = 1:numoload
            [flag, tmploc] =  ismember(edge(oload.edge(i),[1,2]),edge_list_unique,'rows');
            if not(flag)
                [flag, tmploc] =  ismember(edge(oload.edge(i),[2,1]),edge_list_unique,'rows');
            end
            for iterm = 1:numoloadgroup
                fembco.neumann{iterm}{i}.edge = tmploc;
                fembco.neumann{iterm}{i}.q = {char(sym(oload_coeff(iterm)))};
                fembco.neumann{iterm}{i}.g = {char(sym(oload_coeff(iterm)))};
            end
        end
        for i = 1:size(dirichlet.edge,1)
            [flag, tmploc] =  ismember(edge(dirichlet.edge(i),[1,2]),edge_list_unique,'rows');
            if not(flag)
                [flag, tmploc] =  ismember(edge(dirichlet.edge(i),[2,1]),edge_list_unique,'rows');
            end
            fembco.dirichlet{1}{i}.edge = tmploc;
            fembco.dirichlet{1}{i}.h = {{1}};
            if exist('dLIFT')
                dLIFTtmp = dLIFT.edge;
            else
                dLIFTtmp = [];
            end
            [tmp1, tmp2] = ismember(dirichlet.edge(i),dLIFTtmp);
            if tmp1
                fembco.dirichlet{1}{i}.r = {char(dLIFT.r(tmp2))};
            else
                fembco.dirichlet{1}{i}.r = {'0'};
            end
        end
    case {'LE1','LE2','LE3','LE4','LE5'}
        fembco.n = 2;
        for i = 1:numoload
            [flag, tmploc] =  ismember(edge(oload.edge(i),[1,2]),edge_list_unique,'rows');
            if not(flag)
                [flag, tmploc] =  ismember(edge(oload.edge(i),[2,1]),edge_list_unique,'rows');
            end
            for iterm = 1:numoloadgroup
                fembco.neumann{iterm}{i}.edge = tmploc;
                fembco.neumann{iterm}{i}.q = {0,0;0,0};
                fembco.neumann{iterm}{i}.g = {char(sym(oload_coeff(iterm)));char(sym(oload_coeff(iterm)))};
            end
        end
        for i = 1:size(dirichlet.edge,1)
            [flag, tmploc] =  ismember(edge(dirichlet.edge(i),[1,2]),edge_list_unique,'rows');
            if not(flag)
                [flag, tmploc] =  ismember(edge(dirichlet.edge(i),[2,1]),edge_list_unique,'rows');
            end
            fembco.dirichlet{1}{i}.edge = tmploc;
            if exist('dLIFT')
                dLIFTtmp = dLIFT.edge;
            else
                dLIFTtmp = [];
            end
            [tmp1, tmp2] = ismember(dirichlet.edge(i),dLIFTtmp);
            % when we do slanted constraint, we need to replace these "0" and "1" by something...
            % this will be the most messiest part
            if (isfield(edgebcstruct{dirichlet.edge(i)},'rx') && isfield(edgebcstruct{dirichlet.edge(i)},'ry'))
                    fembco.dirichlet{1}{i}.h = {{1,0};{0,1}}; 
                    if tmp1
                        fembco.dirichlet{1}{i}.r = {char(dLIFT.r(tmp2,1));char(dLIFT.r(tmp2,2))};
                    else
                        fembco.dirichlet{1}{i}.r = {'0';'0'};
                    end
                elseif (isfield(edgebcstruct{dirichlet.edge(i)},'rx'))
                    fembco.dirichlet{1}{i}.h = {{1,0}}; 
                    if tmp1
                        fembco.dirichlet{1}{i}.r = {char(dLIFT.r(tmp2,1))};
                    else
                        fembco.dirichlet{1}{i}.r = {'0'};
                    end
                elseif (isfield(edgebcstruct{dirichlet.edge(i)},'ry'))
                    fembco.dirichlet{1}{i}.h = {{0,1}}; 
                    if tmp1
                        fembco.dirichlet{1}{i}.r = {char(dLIFT.r(tmp2,2))};
                    else
                        fembco.dirichlet{1}{i}.r = {'0'};
                    end
            end
        end
end
if not(isfield(fembco,'neumann'))
    for iterm = 1:numoloadgroup
        fembco.neumann{iterm} = [];
    end
end
if not(isfield(fembco,'dirichlet'))
    fembco.dirichlet = [];
end

for iterm = 1:numoloadgroup
    [tmp1,tmp2] = pde_assem2(femOPT,mesh,fembco.n,fembco.neumann{iterm},[]);
    Qtmp{iterm} = tmp1;
    Gtmp{iterm} = tmp2;
end

% find Oaffs (separated treatments)
if dirfluxflag == 1
    % Case 1: "dirflux" output type
    % assemble pdebcodf boundary structure
    % compute outLIFT (Btmp should be the same as no additional Dirichlet b.c was introduced?) atp-4/23 yes, should be O.K.
    [tmp1,tmp2,Htmp,Rtmp] = pde_assem2(femOPT,mesh,fembco.n,[],fembco.dirichlet);
    [tmp,Borth] = pdenullorth(Htmp{1});
    if size(Borth,2)==0
        udtmp=zeros(size(Kq{1},1),1);
    else
        udtmp=full(Borth*((Htmp{1}*Borth)\Rtmp{1}));
    end
    Ktmp = 0*Kqdirflux{1};
    for i = 1:Qa
        Ktmp = Ktmp + theta_a_ref(i)*Kqdirflux{i};
    end
    outLIFT = -Btmp*((Btmp'*Ktmp*Btmp)\(Btmp'*Ktmp*udtmp))+udtmp;
    % assemble all dirflux components
    Qdirflux = 0;
    for i = 1:Qa
        tmp = Kqdirflux{i}'*outLIFT; % transpose
        if nnz(tmp)>0;
            Qdirflux = Qdirflux + 1;
            dirfluxOaffstmp{Qdirflux} = char(sym(Laffsunipos{i}));
            dirfluxLqtmp{Qdirflux} = tmp;
        end
    end
    Oaffstmpc = dirfluxOaffstmp;
else
    % Case 2: "regular" output type
    % symbolically compute all Oaffs coefficient
    % contributions from Neumann b.c
    switch probtype
        case {'TH','TH2'}
            for i = 1:length(oload.edge)
                % get Gaff
                for j = 1:numdoms
                    flag = ismember(edge(oload.edge(i),:),[nodemap(j,[1,2]);nodemap(j,[2,1]);nodemap(j,[2,3]);nodemap(j,[3,2]);nodemap(j,[1,3]);nodemap(j,[3,1])],'rows');
                    if flag
                        oGaff{i} = Gaffs(j,:);
                        oCaff{i} = Caffs(j,:);
                        break;
                    end
                end
                [en, et] = getedgevec(edge(oload.edge(i),:),psym,preal,nodemap); % phuong 9/3
                Oafftmp(i) = abs(simplify(sqrt((oGaff{i}(1)*et(1)+oGaff{i}(2)*et(2))^2+(oGaff{i}(3)*et(1)+oGaff{i}(4)*et(2))^2)));
                % phuong 15-8 (try to eliminate some "abs" if there is any)
                tmp = char(Oafftmp(i));
                for j = 1:P
                    if psign(j) ~= 0
                        tmp = regexprep(tmp,['abs\(mu',num2str(j),'\)'],['(',num2str(psign(j)),'*mu',num2str(j),')']);
                    end
                end
                Oafftmp(i) = simplify(sym(tmp));
            end
            % phuong 15-8
            for iterm = 1:numoloadgroup
                for i = 1:length(oload.edge)
                    tmp = simplify(subs(oload_gvec{iterm}(i),...
                                  {Cfun1,Cfun2,Gfun11,Gfun12,Gfun21,Gfun22},...
                                  {oCaff{i}(1),oCaff{i}(2),oGaff{i}(1),oGaff{i}(2),oGaff{i}(3),oGaff{i}(4)},0));
                    Oaffs((iterm-1)*numoload+i) = simplify(Oafftmp(i)*tmp);
                end
            end
            for iterm = 1:numoloadgroup
                for i = 1:numdoms
                    tmp = simplify(subs(oareaload_vec{iterm}(domgeo(i)),...
                                   {Cfun1,Cfun2,Gfun11,Gfun12,Gfun21,Gfun22},...
                                   {Caffs(i,1),Caffs(i,2),Gaffs(i,1),Gaffs(i,2),Gaffs(i,3),Gaffs(i,4)},0));
                    Oaffs(numoloadgroup*numoload+(iterm-1)*numdoms+i) = simplify(Jaffs(i)*tmp);
                end
            end
            Oaffstmp = Oaffs(:);
            for i = 1:length(Oaffstmp)
                Oaffstmpc{i} = char(Oaffstmp(i));
            end
        case {'LE1','LE2','LE3','LE4','LE5'}
            for i = 1:length(oload.edge)
                % get Gaff
                for j = 1:numdoms
                    flag = ismember(edge(oload.edge(i),:),[nodemap(j,[1,2]);nodemap(j,[2,1]);nodemap(j,[2,3]);nodemap(j,[3,2]);nodemap(j,[1,3]);nodemap(j,[3,1])],'rows');
                    if flag
                        oGaff{i} = Gaffs(j,:);
                        oCaff{i} = Caffs(j,:);
                        break;
                    end
                end
                [en,et] = getedgevec(edge(oload.edge(i),:),psym,preal,nodemap); % phuong 9/3
                eottmp(i,:) = et; eontmp(i,:) = en;
            end
            for i = 1:length(oload.edge)
                Oafftmp(i) = abs(simplify(sqrt((oGaff{i}(1)*et(1)+oGaff{i}(2)*et(2))^2+(oGaff{i}(3)*et(1)+oGaff{i}(4)*et(2))^2)));
                % phuong 15-8 (try to eliminate some "abs" if there is any)
                tmp = char(Oafftmp(i));
                for j = 1:P
                    if psign(j) ~= 0
                        tmp = regexprep(tmp,['abs\(mu',num2str(j),'\)'],['(',num2str(psign(j)),'*mu',num2str(j),')']);
                    end
                end
                Oafftmp(i) = simplify(sym(tmp));
                % phuong 15-8
            end
            if not(strcmp(probtype,'LE5')) % all 'LE' except 'LE5'
                for iterm = 1:numoloadgroup
                    for i = 1:length(oload.edge)
                        tmp1 = simplify(subs(oload_gvec{iterm,1}(i),...
                            {Cfun1,Cfun2,Gfun11,Gfun12,Gfun21,Gfun22},...
                            {oCaff{i}(1),oCaff{i}(2),oGaff{i}(1),oGaff{i}(2),oGaff{i}(3),oGaff{i}(4)},0));
                        tmp2 = simplify(subs(oload_gvec{iterm,2}(i),...
                            {Cfun1,Cfun2,Gfun11,Gfun12,Gfun21,Gfun22},...
                            {oCaff{i}(1),oCaff{i}(2),oGaff{i}(1),oGaff{i}(2),oGaff{i}(3),oGaff{i}(4)},0));
                        Oaffs((iterm-1)*numoload*2+(i-1)*2+1) = simplify(Oafftmp(i)*tmp1*eottmp(i,1)+Oafftmp(i)*tmp2*eontmp(i,1));
                        Oaffs((iterm-1)*numoload*2+(i-1)*2+2) = simplify(Oafftmp(i)*tmp1*eottmp(i,2)+Oafftmp(i)*tmp2*eontmp(i,2));
                    end
                end
                for iterm = 1:numoloadgroup
                    for i = 1:numdoms
                        tmp1 = simplify(subs(oareaload_vec{iterm,1}(domgeo(i)),...
                            {Cfun1,Cfun2,Gfun11,Gfun12,Gfun21,Gfun22},...
                            {Caffs(i,1),Caffs(i,2),Gaffs(i,1),Gaffs(i,2),Gaffs(i,3),Gaffs(i,4)},0));
                        tmp2 = simplify(subs(oareaload_vec{iterm,2}(domgeo(i)),...
                            {Cfun1,Cfun2,Gfun11,Gfun12,Gfun21,Gfun22},...
                            {Caffs(i,1),Caffs(i,2),Gaffs(i,1),Gaffs(i,2),Gaffs(i,3),Gaffs(i,4)},0));
                        Oaffs(numoloadgroup*numoload*2+(iterm-1)*numdoms*2+(i-1)*2+1) = simplify(Jaffs(i)*tmp1);
                        Oaffs(numoloadgroup*numoload*2+(iterm-1)*numdoms*2+(i-1)*2+2) = simplify(Jaffs(i)*tmp2);
                    end
                end
            else % 'LE5' case
                for iterm = 1:numoloadgroup
                    for i = 1:length(oload.edge)
                        tmp1 = simplify(subs(oload_gvecx2{iterm,1}(i),...
                            {Cfun1,Cfun2,Gfun11,Gfun12,Gfun21,Gfun22},...
                            {oCaff{i}(1),oCaff{i}(2),oGaff{i}(1),oGaff{i}(2),oGaff{i}(3),oGaff{i}(4)},0));
                        tmp2 = simplify(subs(oload_gvecx2{iterm,2}(i),...
                            {Cfun1,Cfun2,Gfun11,Gfun12,Gfun21,Gfun22},...
                            {oCaff{i}(1),oCaff{i}(2),oGaff{i}(1),oGaff{i}(2),oGaff{i}(3),oGaff{i}(4)},0));
                        tmp3 = simplify(subs(oload_gvecx{iterm,1}(i),...
                            {Cfun1,Cfun2,Gfun11,Gfun12,Gfun21,Gfun22},...
                            {oCaff{i}(1),oCaff{i}(2),oGaff{i}(1),oGaff{i}(2),oGaff{i}(3),oGaff{i}(4)},0));
                        tmp4 = simplify(subs(oload_gvecx{iterm,2}(i),...
                            {Cfun1,Cfun2,Gfun11,Gfun12,Gfun21,Gfun22},...
                            {oCaff{i}(1),oCaff{i}(2),oGaff{i}(1),oGaff{i}(2),oGaff{i}(3),oGaff{i}(4)},0));
                        Oaffs((iterm-1)*numoload*2+(i-1)*2+1) = simplify(Oafftmp(i)*tmp1*eottmp(i,1)+Oafftmp(i)*tmp2*eontmp(i,1));
                        Oaffs((iterm-1)*numoload*2+(i-1)*2+2) = simplify(Oafftmp(i)*tmp3*eottmp(i,2)+Oafftmp(i)*tmp4*eontmp(i,2));
                    end
                end
                for iterm = 1:numoloadgroup
                    for i = 1:numdoms
                        tmp1 = simplify(subs(oareaload_vecx2{iterm,1}(domgeo(i)),...
                            {Cfun1,Cfun2,Gfun11,Gfun12,Gfun21,Gfun22},...
                            {Caffs(i,1),Caffs(i,2),Gaffs(i,1),Gaffs(i,2),Gaffs(i,3),Gaffs(i,4)},0));
                        tmp2 = simplify(subs(oareaload_vecx{iterm,2}(domgeo(i)),...
                            {Cfun1,Cfun2,Gfun11,Gfun12,Gfun21,Gfun22},...
                            {Caffs(i,1),Caffs(i,2),Gaffs(i,1),Gaffs(i,2),Gaffs(i,3),Gaffs(i,4)},0));
                        Oaffs(numoloadgroup*numoload*2+(iterm-1)*numdoms*2+(i-1)*2+1) = simplify(Jaffs(i)*tmp1);
                        Oaffs(numoloadgroup*numoload*2+(iterm-1)*numdoms*2+(i-1)*2+2) = simplify(Jaffs(i)*tmp2);
                    end
                end
            end
            Oaffstmp = Oaffs(:);
            for i = 1:length(Oaffstmp)
                Oaffstmpc{i} = char(Oaffstmp(i));
            end
    end
end

% the unique business is the same for both Cases
if (exist('Oaffs') | Qdirflux > 0)
    % find an unique Oaffs set
    [Oaffsunique,upun,downun] = unique(Oaffstmpc);
    [Oaffsunipos,updiff] = setdiff(Oaffsunique,{'0.','0','0.0'}); % phuong 2/2/09
    Ql = length(Oaffsunipos);
    % map the OBoolecoeff matrix
    for q = 1:Ql
        OBoolecoeff(:,q) = (downun(:) == updiff(q));
    end
    if (exist('OBoolecoeff'))
        OBoolecoeff = double(OBoolecoeff);
    else
        OBoolecoeff = eye(Ql);
    end
    [Oaffsunipos, OBoolecoeff] = symcompress(P, Oaffsunipos,OBoolecoeff);
    
    Ql = length(Oaffsunipos);
else
    Ql = 0;
end

% Lq assembly (separated treatments)
if (dirfluxflag == 1)
    % Case 1: "dirflux" output assembly    
    % initialize Lq
    for i = 1:Ql
        Lq{i} = zeros(size(Kqdirflux{1},1),1);
    end
    % generate Lq from dirfluxLqtmp
    for i = 1:Qdirflux  % atp-4/23 should this be Qdirfluxflag or Qa --- instead of Qf (I changed from Qf to Qdirflux)?
        for j = 1:Ql
            Lq{j} = Lq{j} + OBoolecoeff(i,j)*dirfluxLqtmp{i};
        end
    end
    % generate outcoeffs
    for i = 1:Qf;
        outcoeffs(i) = -outLIFT'*Fqdirflux{i}; % atp-4/23 yes, this looks right --- can you check again (I will too)
    end
else
    % Case 2: "regular" output assembly
    % assemble Neumann b.c for Outputs
    switch probtype
        case {'TH','TH2'}
            % initialize Lq
            for i = 1:Ql
                Lq{i} = zeros(size(Kqdirflux{1},1),1);
            end
            % get Lq from assemb
            % contribute from Neumann "load"
            for iterm = 1:numoloadgroup
                for i = 1:length(oload.edge)
                    for j = 1:Ql
                        Lq{j} = Lq{j} + OBoolecoeff((iterm-1)*numoload+i,j)*Gtmp{iterm}{i}{1};
                    end
                end
            end
            % contribute from "f"
            for iterm = 1:numoloadgroup
                tmp1 = regexprep(regexprep(char(sym(oload_coeff(iterm))),'*','.*'),'\^','.^');
                for i = 1:numdoms
                    [tmp,Ltmp] = pde_assem1(femOPT,mesh,i,zeros(3,3),tmp1);
                    for j = 1:Ql
                        Lq{j} = Lq{j} + OBoolecoeff(numoloadgroup*numoload+(iterm-1)*numdoms+i,j)*Ltmp{1};
                    end
                end
            end
        case {'LE1','LE2','LE3','LE4','LE5'}
            % initialize Lq
            for i = 1:Ql
                Lq{i} = zeros(size(Kqdirflux{1},1),1);
            end
            % get Lq from assemb
            % contribute from Neumann "load"
            for iterm = 1:numoloadgroup
                for i = 1:length(oload.edge)
                    for j = 1:Ql
                        Lq{j} = Lq{j} + OBoolecoeff((iterm-1)*numoload*2+(i-1)*2+1,j)*Gtmp{iterm}{i}{1};
                        Lq{j} = Lq{j} + OBoolecoeff((iterm-1)*numoload*2+(i-1)*2+2,j)*Gtmp{iterm}{i}{2};
                    end
                end
            end
            % contribute from "f"
            for iterm = 1:numoloadgroup
                tmp1 = regexprep(regexprep(char(sym(oload_coeff(iterm))),'*','.*'),'\^','.^');
                tmp0 = '0';
                for j = 2:length(tmp1)
                    tmp0(j) = ' ';
                end
                for i = 1:numdoms
                    [tmp,Ltmp] = pde_assem1(femOPT,mesh,i,zeros(6,6),{tmp1;tmp1});
                    for j = 1:Ql
                        Lq{j} = Lq{j} + OBoolecoeff(numoloadgroup*numoload*2+(iterm-1)*numdoms*2+(i-1)*2+1,j)*Ltmp{1};
                        Lq{j} = Lq{j} + OBoolecoeff(numoloadgroup*numoload*2+(iterm-1)*numdoms*2+(i-1)*2+2,j)*Ltmp{2};
                    end
                end
            end
    end
            
    % generate outcoeffs
    for i = 1:Ql;
        outcoeffs(i) = uDIR'*Lq{i}; % Gianluigi to add this to Online_RB evaluation
    end
end

% rows/columns eliminations
% ztmpv = 0*Lq{1}; % check this is O.K. (should be: uDIR accommodated above)
for i = 1:Ql
    Ltmpq = Btmp'*Lq{i};
    Lq{i} = Ltmpq;
end

fprintf('Dual affine decomposition/FE vectors complete: %d affine terms in ell.\n',Ql);

save(strcat(probname,'_',outputname,'_','du_SYMB')) % just for debugging purposes --- not needed

% cuong-8/15 
if exist('dt') & exist('nt')
    du_OFFLINE.FEM.timestep.dt=dt;
    du_OFFLINE.FEM.timestep.nt=nt;
    du_OFFLINE.GREEDY.Offline='offline_parabolic_dual';
    du_OFFLINE.GREEDY.Online='online_parabolic_dual';
    % Assemble dirflux due to mass matrix
    if dirfluxflag == 1        
        du2_OFFLINE.FEM.timestep.dt=dt;
        du2_OFFLINE.FEM.timestep.nt=nt;
        du2_OFFLINE.GREEDY.Offline='offline_parabolic_dual';
        du2_OFFLINE.GREEDY.Online='online_parabolic_dual';
        % assemble all dirflux components
        QMdirflux = 0;
        for i = 1:Qm
            tmp = Mqdirflux{i}'*outLIFT; % transpose
            if nnz(tmp)>0;
                QMdirflux = QMdirflux + 1;
                dirfluxOMaffstmp{QMdirflux} = char(sym(Maffsunipos{i}));
                dirfluxLMqtmp{QMdirflux} = tmp;
            end
        end
        OMaffstmpc = dirfluxOMaffstmp;     
        [OMaffsunique,upun,downun] = unique(OMaffstmpc);
        [OMaffsunipos,updiff] = setdiff(OMaffsunique,{'0.','0','0.0'}); % phuong 2/2/09
        Qlm = length(OMaffsunipos);
        % map the OBoolecoeff matrix
        for q = 1:Qlm
            OMBoolecoeff(:,q) = (downun(:) == updiff(q));
        end
        if (exist('OMBoolecoeff'))
            OMBoolecoeff = double(OMBoolecoeff);
        else
            OMBoolecoeff = [];
        end
        [OMaffsunipos, OMBoolecoeff] = symcompress(P,OMaffsunipos,OMBoolecoeff);    
        Qlm=length(OMaffsunipos);
        %"dirflux" output assembly    
        % initialize LMq
        for i = 1:Qlm
            LMq{i} = zeros(size(Mqdirflux{1},1),1);
        end
        % generate Lq from dirfluxLqtmp
        for i = 1:QMdirflux
            for j = 1:Qlm
                LMq{j} = LMq{j} + OMBoolecoeff(i,j)*dirfluxLMqtmp{i};
            end
        end
        for i = 1:Qlm
            Ltmpq = Btmp'*LMq{i};
            LMq{i} = Ltmpq;
        end    
        du2_PROBDEF.Q_affine.l = Qlm;
        for q = 1:Qlm
            eval(strcat('du2_PROBDEF.OMaffsunipos{',num2str(q),'}= OMaffsunipos{q};'));
        end;
        for q = 1:Qlm
            eval(strcat('du2_OFFLINE.FEM.matrix.Lq{',num2str(q),'}= LMq{q};'));
        end;
    end
end
% cuong-8/15

% Fill du_PROBDEF structure.
du_PROBDEF.Q_affine.l = Ql ; % scalar $Q_l$
for q = 1:Ql;
    eval(strcat('du_PROBDEF.Oaffsunipos{',num2str(q),'}= Oaffsunipos{q};'));
end;
%
du_PROBDEF.dirfluxflag = dirfluxflag;
du_PROBDEF.outcoeffs = outcoeffs; % to add to Online_RB evaluation * Laffs unless dirfluxflag = 1 then * Raffs
assignin('base', strcat(probname,'_',outputname,'_','du_PROBDEF'), du_PROBDEF);
save(strcat(probname,'_',outputname,'_','du_PROBDEF'),strcat(probname,'_',outputname,'_','du_PROBDEF')); % save *PROBNAME_du_PROBDEF structure to file *PROBNAME_du_PROBDEF.mat


% Fill the "INs" part of the PROBNAME_du_OFFLINE structure.
% Enter the FEM vectors.
% cuong-6/29 
if exist('dt') & exist('nt')
    du_OFFLINE.FEM.timestep.dt=dt;
    du_OFFLINE.FEM.timestep.nt=nt;
    du_OFFLINE.GREEDY.Offline='offline_parabolic_dual';
    du_OFFLINE.GREEDY.Online='online_parabolic_dual';
end
% cuong-6/29

for q = 1:Ql;
    eval(strcat('du_OFFLINE.FEM.matrix.Lq{',num2str(q),'}= Lq{q};'));
end;


assignin('base',strcat(probname,'_',outputname,'_','du_OFFLINE'),du_OFFLINE);
save(strcat(probname,'_',outputname,'_','du_OFFLINE'),strcat(probname,'_',outputname,'_','du_OFFLINE')) % save *PROBNAME_du_OFFLINE structure (so far) to file *PROBNAME_du_OFFLINE.mat


% generate the output file "Get_Theta_q.m"
fid = fopen(strcat(probname,'_',outputname,'_','Get_Theta_q.m'),'wt');
fprintf(fid,'%% -----rbMIT_System Software Copyright MIT 2006-07-----\n');
fprintf(fid,'%%\n'); 
fprintf(fid,'%%\n');
fprintf(fid,'%% The user agrees to rbMIT_System MIT usage, distribution, and citation terms and conditions \n');
fprintf(fid,'%% described in the License at http://augustine.mit.edu/rbMIT_SystemLicense.htm.\n');
fprintf(fid,'%% rbMIT_System Software PartI_SV1\n');
fprintf(fid,'%%\n');
fprintf(fid,'\n');
fprintf(fid,'function [Thetavectorvalue] = Get_Theta_q(DEF, muvectorvalue);\n');
fprintf(fid,'P = %d ; %% $P$, the number of parameters\n',pr_PROBDEF.P);
fprintf(fid,'Qa = %d;\n',pr_PROBDEF.Q_affine.a);
fprintf(fid,'Qf = %d;\n',pr_PROBDEF.Q_affine.f);
fprintf(fid,'nummupts=size(muvectorvalue,1); %% nummupts=M\n');
fprintf(fid,'for m=1:nummupts\n');
for pp=1:pr_PROBDEF.P
fprintf(fid,'    %s = muvectorvalue(m,%d);\n',strcat('mu',num2str(pp)),pp);
end
fprintf(fid,'    %% Compute the Theta_l^q, 1 \\le q \\le Q_l.\n');
for q=1:du_PROBDEF.Q_affine.l
fprintf(fid,'    Theta_l(1,%d) = %s;\n',q,du_PROBDEF.Oaffsunipos{q});
end
fprintf(fid,'    Thetavectorvalue(m,:) = [Theta_l];\n');
fprintf(fid,'end\n');
fclose(fid);

% cuong 8/15
if exist('dt') & exist('nt') & (dirfluxflag == 1)
    du2_PROBDEF.dirfluxflag = dirfluxflag;
    du2_PROBDEF.outcoeffs = outcoeffs; % to add to Online_RB evaluation * Laffs unless dirfluxflag = 1 then * Raffs
    assignin('base', strcat(probname,'_',outputname,'_','du2_PROBDEF'), du2_PROBDEF);
    save(strcat(probname,'_',outputname,'_','du2_PROBDEF'),strcat(probname,'_',outputname,'_','du2_PROBDEF')); % save *PROBNAME_du_PROBDEF structure to file *PROBNAME_du_PROBDEF.mat
    assignin('base',strcat(probname,'_',outputname,'_','du2_OFFLINE'),du2_OFFLINE);
    save(strcat(probname,'_',outputname,'_','du2_OFFLINE'),strcat(probname,'_',outputname,'_','du2_OFFLINE')) % save *PROBNAME_du_OFFLINE structure (so far) to file *PROBNAME_du_OFFLINE.mat

    fid = fopen(strcat(probname,'_',outputname,'_','Get_Theta_LM_q.m'),'wt');
    fprintf(fid,'%% -----rbMIT_System Software Copyright MIT 2006-07-----\n');
    fprintf(fid,'%%\n'); 
    fprintf(fid,'%%\n');
    fprintf(fid,'%% The user agrees to rbMIT_System MIT usage, distribution, and citation terms and conditions \n');
    fprintf(fid,'%% described in the License at http://augustine.mit.edu/rbMIT_SystemLicense.htm.\n');
    fprintf(fid,'%% rbMIT_System Software PartI_SV1\n');
    fprintf(fid,'%%\n');
    fprintf(fid,'\n');
    fprintf(fid,'function [Thetavectorvalue] = Get_Theta_q(DEF, muvectorvalue);\n');
    fprintf(fid,'P = %d ; %% $P$, the number of parameters\n',pr_PROBDEF.P);
    fprintf(fid,'Qa = %d;\n',pr_PROBDEF.Q_affine.a);
    fprintf(fid,'Qf = %d;\n',pr_PROBDEF.Q_affine.f);
    fprintf(fid,'nummupts=size(muvectorvalue,1); %% nummupts=M\n');
    fprintf(fid,'for m=1:nummupts\n');
    for pp=1:pr_PROBDEF.P
        fprintf(fid,'    %s = muvectorvalue(m,%d);\n',strcat('mu',num2str(pp)),pp);
    end
    fprintf(fid,'    %% Compute the Theta_lm^q, 1 \\le q \\le Q_lm.\n');
    for q=1:du2_PROBDEF.Q_affine.l
        fprintf(fid,'    Theta_l(1,%d) = %s;\n',q,du2_PROBDEF.OMaffsunipos{q});
    end
    fprintf(fid,'    Thetavectorvalue(m,:) = [Theta_l];\n');
    fprintf(fid,'end\n');
    fclose(fid);
end
% cuong 8/15

% generate the output file "outadd"
if(dirfluxflag == 0)
    
    fid = fopen(strcat(probname,'_',outputname,'_','addout.m'),'wt');
    fprintf(fid,'%% -----rbMIT_System Software Copyright MIT 2006-07-----\n');
    fprintf(fid,'%%\n');
    fprintf(fid,'%%\n');
    fprintf(fid,'%% The user agrees to rbMIT_System MIT usage, distribution, and citation terms and conditions \n');
    fprintf(fid,'%% described in the License at http://augustine.mit.edu/rbMIT_SystemLicense.htm.\n');
    fprintf(fid,'%% rbMIT_System Software PartI_SV1\n');
    fprintf(fid,'%%\n');
    fprintf(fid,'\n');
    fprintf(fid,'function [sNadd] = addout(mu);\n');
    fprintf(fid,'P = %d ; %% $P$, the number of parameters\n',pr_PROBDEF.P);
    fprintf(fid,'Ql = %d;\n',du_PROBDEF.Q_affine.l);
    for pp=1:pr_PROBDEF.P
        fprintf(fid,'    %s = mu(%d);\n',strcat('mu',num2str(pp)),pp);
    end
    fprintf(fid,' sNadd = 0;\n');
    for q=1:du_PROBDEF.Q_affine.l
        fprintf(fid,'    sNadd = sNadd + (%s )* %d;\n',du_PROBDEF.Oaffsunipos{q},du_PROBDEF.outcoeffs(q)); % atp-4/23 without parentheses evaluated to wrong quantity!
    end
    fclose(fid);

else
    
    fid = fopen(strcat(probname,'_',outputname,'_','addout.m'),'wt');
    fprintf(fid,'%% -----rbMIT_System Software Copyright MIT 2006-07-----\n');
    fprintf(fid,'%%\n');
    fprintf(fid,'%%\n');
    fprintf(fid,'%% The user agrees to rbMIT_System MIT usage, distribution, and citation terms and conditions \n');
    fprintf(fid,'%% described in the License at http://augustine.mit.edu/rbMIT_SystemLicense.htm.\n');
    fprintf(fid,'%% rbMIT_System Software PartI_SV1\n');
    fprintf(fid,'%%\n');
    fprintf(fid,'\n');
    fprintf(fid,'function [sNadd] = addout(mu);\n');
    fprintf(fid,'P = %d ; %% $P$, the number of parameters\n',pr_PROBDEF.P);
    fprintf(fid,'Qf = %d;\n',pr_PROBDEF.Q_affine.f);
    for pp=1:pr_PROBDEF.P
        fprintf(fid,'    %s = mu(%d);\n',strcat('mu',num2str(pp)),pp);
    end
    fprintf(fid,' sNadd = 0;\n');
    for q=1:pr_PROBDEF.Q_affine.f % atp-4/24 (was Q_l)
        fprintf(fid,'    sNadd = sNadd + (%s )* %d;\n',pr_PROBDEF.Raffsunipos{q},du_PROBDEF.outcoeffs(q)); % atp-4/23 without parentheses evaluated to wrong quantity!
    end
    fclose(fid);

end
    
save symb_temp probname outputname;
clear;
load symb_temp;
delete symb_temp.mat;