% -----rbMIT Software Copyright MIT 2006-07----
%  DBP  Huynh,NC Nguyen, AT Patera, G Rozza
% Henceforth, Software shall refer to the rbMIT_System software package: 
% the contents of the rbMIT_Library and rbMIT_Aux folders.
% 
% This License governs use of all accompanying Software, and your download and/or use of the Software constitutes acceptance 
% of this License.
% 
% You may use this Software for any non-commercial purpose, subject to the restrictions in this license. 
% Some purposes which can be non-commercial are teaching and academic research.
% 
% You may not use or distribute this Software or any derivative works in any form for commercial purposes. 
% Examples of commercial purposes would be licensing, leasing, or selling the Software, or distributing the 
% Software for use with commercial products.
% 
% You may modify this Software and distribute the modified Software for non-commercial purposes,
%  however, you may not grant rights to the Software or derivative works that are broader than those 
% provided by this License. For example, you may not distribute modifications of the Software under terms 
% that would permit commercial use.
% 
% In return, we require that you agree:
% 
% not to remove any copyright or other notices from the Software;
% 
% that if you distribute the Software in source or object form, you will include a verbatim copy of this license;
% 
% that if you distribute derivative works of the Software in source code form you do so only under a license
% that includes all of the provisions of this License, and if you distribute derivative works of the Software solely 
% in object form you do so only under a license that complies with this License;
% 
% that if you have modified the Software or created derivative works, and distribute such modifications or derivative
% works, you will cause the modified files to carry prominent notices so that recipients know that they are not receiving the original Software;
% 
% THAT THE SOFTWARE COMES "AS IS", WITH NO WARRANTIES: THIS MEANS NO EXPRESS, IMPLIED OR STATUTORY WARRANTY, 
% INCLUDING WITHOUT LIMITATION WARRANTIES OF MERCHANTABILITY OR FITNESS FOR A PARTICULAR PURPOSE OR ANY WARRANTY 
% OF TITLE OR NON-INFRINGEMENT; YOU MUST PASS THIS DISCLAIMER ON WHENEVER YOU DISTRIBUTE THE SOFTWARE OR DERIVATIVE WORKS;
% 
% THAT NEITHER MIT NOR THE AUTHORS WILL BE LIABLE FOR ANY DAMAGES RELATED TO THE SOFTWARE OR THIS LICENSE, 
% INCLUDING DIRECT, INDIRECT, SPECIAL, CONSEQUENTIAL OR INCIDENTAL DAMAGES; YOU MUST PASS THIS LIMITATION OF LIABILITY 
% ON WHENEVER YOU DISTRIBUTE THE SOFTWARE OR DERIVATIVE WORKS;
% 
% that your rights under the License end automatically if you breach the License in any way;
% 
% that MIT reserves all rights not expressly granted to you in this License.
% 
% (Note: The wording of this license agreement is derived from a Microsoft Shared Source license agreement.)
% 
% License at http://augustine.mit.edu/rbMIT_SystemLicense.htm.
%
% rbMIT Software Part_II_and_IV
%
% ---------- 

% -----rbMIT_System Software Copyright MIT 2006-07-----
% 
% 
% The user agrees to rbMIT_System MIT usage, distribution, and citation terms and conditions 
% described in the License at http://augustine.mit.edu/rbMIT_SystemLicense.htm.
% rbMIT_System Software PartI_V2
%
% Step1_coer_noncompliant [symbolic case: 2-d]
%
clear PROBDEF OFFLINE ONLINE
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

% begin symbolic pre-processor
clear maplemex;
% write log
warning off;
mkdir('log');
mkdir('log\fig');
warning on;
logmfname = strcat(probname,'_log.m');
if (exist(logmfname) == 2)
    delete(logmfname);
end
fid = fopen(logmfname,'w');
fprintf(fid,'%%%% %s LOG\n',probname);
fclose(fid);

demogcf = floor(rand*1000);

primal_dataprep;

ne0 = size(edge,1); %atp-5/7 below: moved here before curvypreprocess
for i = 1:ne0;
    rootedge(i) = i;
end;

curvypreprocess;

% delaunay loop
idone = 0;
iflip = 1;

% generate an inital delaunay mesh and all unique edges
tri = delaunay(preal(:,1),preal(:,2),{'Qt','Qbb','Qc','Qz'});

figure(demogcf);
triplotcurvy
hold on; plot(preal(:,1),preal(:,2),'ko'); 
x1min = min(preal(:,1)); x2min = min(preal(:,2)); x1max = max(preal(:,1)); x2max = max(preal(:,2)); x1len = x1max - x1min; x2len = x2max - x2min; 
x1minb = x1min - .1*x1len; x1maxb = x1max + .1*x1len; x2minb = x2min - .1*x2len; x2maxb = x2max + .1*x2len;
plot([x1minb,x1maxb,x1maxb,x1minb,x1minb],[x2minb,x2minb,x2maxb,x2maxb,x2minb],'k-','Linewidth',3);
hold off;
set(demogcf,'Color','white');
saveas(demogcf,'log\fig\inittri','fig');
if (plotdemo)
    disp('initial domain decomposition...;')
    pause
else
    close(demogcf);
end
fid = fopen(logmfname,'a');
fprintf(fid,'%%\n%%%% initial domain decomposition...;\n%%\n');
fprintf(fid,'open(%s);\n','''log\fig\inittri.fig''');
fclose(fid);

tri_edge_list = [tri(:,[1,2]);tri(:,[2,3]);tri(:,[3,1])];
[edge_list, tmp1, tmp2] = unique(tri_edge_list,'rows');
edge_list_unique = unique(sort(edge_list,2),'rows');

edgesplitfigcount = 0;
while ~idone  % hope for a non-infinite loop...
    numgeo = length(geometry); % atp-5/14 (did not encounter before since edges to be split were part of "old" geometries?)
    for igeo = 1:numgeo 
        negeo = size(geometry{igeo},2);
        for ie = 1:negeo
            edgetst = edge(geometry{igeo}(ie),:);
            ipass = max(ismember(edgetst,[tri(:,[1,2]);tri(:,[2,1]);tri(:,[2,3]);tri(:,[3,2]);tri(:,[1,3]);tri(:,[3,1])],'rows'));
            
            % check collision between curved and all possible edges
            % collision; atp-5/7 (temporary)
    
            if( ipass == 0 )
                edgesplit;
                % atp-5/7 moved below back into main script (here) so we could use
                % edgesplit for curvypreprocess
                tri = delaunay(preal(:,1),preal(:,2),{'Qt','Qbb','Qc','Qz'});
                
                figure(demogcf);
                boundarydraw
                set(findobj(gca,'Type','line','Color',[1 0 0]),'Color',[0,0,0.8],'LineWidth',4);
                hold on; triplotcurvy; hold off;
                set(demogcf,'Color','white');
                saveas(demogcf,strcat('log\fig\edgesplitgen',num2str(edgesplitfigcount)),'fig');
                if (plotdemo)
                    disp('edge-refined domain decomposition to respect boundaries...;')
                 pause
                else
                    close(demogcf);
                end
                fid = fopen(logmfname,'a');
                if (edgesplitfigcount == 0)
                    fprintf(fid,'%%\n%%%% edge-refined domain decomposition to respect boundaries...;\n%%\n');
                end
                fprintf(fid,'open(%s);\n',strcat('''log\fig\edgesplitgen',num2str(edgesplitfigcount),'.fig'''));
                fclose(fid);
                edgesplitfigcount = edgesplitfigcount + 1;
                
                % generate all edges of delaunay mesh
                tri_edge_list = [tri(:,[1,2]);tri(:,[2,3]);tri(:,[3,1])];
                [edge_list, tmp1, tmp2] = unique(tri_edge_list,'rows');
                edge_list_unique = unique(sort(edge_list,2),'rows');
                % nt = size(tri,1);
                % atp-5/7 above (see also edgesplit)
                break;
            end;
            idone = (ipass == 1 & ie == negeo & igeo == numgeo); 
        end;
        if (ipass == 0)
            break;
        end
    end
    if (~idone && iflip) % trigger a "final" check
        idone = 0;
        iflip = 0;
    end
end

if(plotdemo)
    disp('completed respectful domain decomposition before hole removal...;')
    figure(demogcf);
    triplotcurvy
    pause
end;

% get all domain's/hole's point lists
numdom = 0;
numhole = 0;
for i = 1:length(geometry)
    % find a list of nodes that travel around the domain
    clear etmp;
    tmp = geometry{i}(2:end);
    etmp(1) = edge(geometry{i}(1),1);
    for j = 2:length(geometry{i})
        itmp = find(etmp(j-1) == edge(tmp,1));
        if itmp>0
            etmp(j) = edge(tmp(itmp),2);
            tmp(itmp) = [];
        else
            itmp = find(etmp(j-1) == edge(tmp,2));
            etmp(j) = edge(tmp(itmp),1);
            tmp(itmp) = [];
        end
    end
    % get the points list
    if gflag(i)
        numdom = numdom + 1;
        iddomain(numdom) = i;
        boundarypts{numdom} = preal(etmp,:);
    else
        numhole = numhole + 1;
        idhole(numhole) = i;
        holepts{numhole} = preal(etmp,:);
    end
end

% winding all subdomains to be counter clockwise
for i = 1:size(tri,1)
    tmp = cross([preal(tri(i,2),:)-preal(tri(i,1),:),0],[preal(tri(i,3),:)-preal(tri(i,1),:),0]);
    if tmp(3) < 0
        tri(i,:) = tri(i,[1,3,2]);
    end
end

numdomsor = size(tri,1); % number of subdomains
numnodes = size(preal,1); % number of global nodes
nodemapor = tri;

% check/eliminate subdomains
inflag = ones(numdomsor,1);
for i = 1:numdomsor;
    vc = sum(preal(nodemapor(i,:),:))/3;
    inside = zeros(numdom,1);
    for j = 1:numdom
        inside(j) = inpolygon(vc(1),vc(2),boundarypts{j}(:,1),boundarypts{j}(:,2));
    end
    insidehole = zeros(numhole,1);    
    for j = 1:numhole
        insidehole(j) = inpolygon(vc(1),vc(2),holepts{j}(:,1),holepts{j}(:,2));
    end
    if( max(inside) == 0 | max(insidehole) == 1)
        inflag(i) = 0;
    end
    tinside(:,i) = inside;
    tinsidehole(:,i) = insidehole;
    tvc(i,:) = vc;
end
nodemap = nodemapor(find(inflag==1),:);
numdoms = size(nodemap,1);

figure(demogcf+1);
tri = nodemap;
triplotcurvy
hold on;
plot(preal(:,1),preal(:,2),'ko');
for i = 1:numdoms
    tmp = sum(preal(nodemap(i,:),:))/3;
    text(tmp(1),tmp(2),num2str(i));
end
x1min = min(preal(:,1)); x2min = min(preal(:,2)); x1max = max(preal(:,1)); x2max = max(preal(:,2)); x1len = x1max - x1min; x2len = x2max - x2min; 
x1minb = x1min - .1*x1len; x1maxb = x1max + .1*x1len; x2minb = x2min - .1*x2len; x2maxb = x2max + .1*x2len;
plot([x1minb,x1maxb,x1maxb,x1minb,x1minb],[x2minb,x2minb,x2maxb,x2maxb,x2minb],'k-','Linewidth',3);
axis equal; axis tight;
hold off;
set(demogcf+1,'Color','white');
saveas(demogcf+1,'log\fig\finalgeo','fig');
if (plotdemo)
    disp('')
    fprintf('final respectful domain decomposition after hole removal --- %d subdomains...;\n',numdoms)
    pause
    close(demogcf);
else
    close(demogcf+1);
end
fid = fopen(logmfname,'a');
fprintf(fid,'%%\n%%%% final respectful domain decomposition after hole removal --- %d subdomains...;\n%%\n',numdoms);
fprintf(fid,'open(%s);\n','''log\fig\finalgeo.fig''');
fclose(fid);

% atp-5/1 (non-hole holes) below
geocount = zeros(numdom,1);
for i = 1:numdoms
    vc = sum(preal(nodemap(i,:),:))/3;
    for j = 1:numdom
        geocount(j) = geocount(j) + inpolygon(vc(1),vc(2),boundarypts{j}(:,1),boundarypts{j}(:,2));
    end;
end;

numnload = length(nload.edge);
numfareaload = size(fareaload,1);

domgeo = ones(numdoms,1);
for i = 1:numdoms
    vc = sum(preal(nodemap(i,:),:))/3;
    inside = zeros(numdom,1);
    for j = 1:numdom
        % atp-5/7 below 
        if(iddomain(j) > numgeo0) % want to set f/oareaload and kappa from the initial input geometries
            break;
        end;
        % atp-5/7 above
        inside(j) = inpolygon(vc(1),vc(2),boundarypts{j}(:,1),boundarypts{j}(:,2));
    end
    ftmp = find(inside == 1);
    [mintmp,itmp] = min(geocount(ftmp));
    domgeo(i) = ftmp(itmp); 
end
% atp-5/1 (non-hole holes) above
primal_symgen;
for i = 1:Qa;
    sizeLaffprint(i) = size(Laffsunipos{i},2);
    [sizeLaffprintsort,sizeLaffprintsortind] = sort(sizeLaffprint);
end;
clear tmp1;
for j = 1:min(3,length(Laffsunipos))
    tmp1{j} = gencompfunc(probtype,sizeLaffprintsortind(j),numdoms,numnload,numnloadgroup,Lsepcoeff,Boolecoeff,3);
end
if(plotdemo == 1)
    fprintf('primal affine decomposition identified: %d affine terms in a and %d affine terms in f, for example\n',Qa,Qf);
    for j = 1:min(3,length(Laffsunipos))
        fprintf('\n')
        disp( strcat('   \Theta_a^',num2str(sizeLaffprintsortind(j)),'(mu) =',Laffsunipos{sizeLaffprintsortind(j)},',   a^',num2str(sizeLaffprintsortind(j)),'(w,v) = ', tmp1{j}) )
        fprintf('\n')
    end;
    disp('for the three shortest expressions for a (see Get_Theta_q for complete list)...;');
    pause
end;

fid = fopen(logmfname,'a');
fprintf(fid,'%%\n%%%% Some coefficients...;\n%%\n');
fprintf(fid,'%% primal affine decomposition identified: %d affine terms in a and %d affine terms in f, for example\n',Qa,Qf);
fprintf(fid,'%% the three shortest expressions for a are (see Get_Theta_q for complete list):\n');
for j = 1:min(3,length(Laffsunipos))
    tmp = latex(sym(Laffsunipos{sizeLaffprintsortind(j)}));
    for p = 1:P
        tmp = regexprep(tmp, strcat('{\\it mu',num2str(p),'}'), strcat('\\mu_',num2str(p)));
    end
    tmp = regexprep(tmp,'\\left(','(');
    tmp = regexprep(tmp,'\\right',')');
    fprintf(fid,'%%\n%% $$ \\Theta_{%d}^a(\\mu) = %s$$ \n',sizeLaffprintsortind(j),tmp);
    fprintf(fid,'%%\n%% $$ a^{%d}(w,v) = %s$$ \n',sizeLaffprintsortind(j), tmp1{j});    
end
fclose(fid);

primal_pdeprep;

% Meshing
primal_meshing;

primal_pdesolution;

for j = 1:min(3,length(Laffsunipos))
    figure(demogcf+2);
    spy(Kq{sizeLaffprintsortind(j)});
    tmp = gencompfunc(probtype,sizeLaffprintsortind(j),numdoms,numnload,numnloadgroup,Lsepcoeff,Boolecoeff,5);
    title(strcat('$','a^{',num2str(sizeLaffprintsortind(j)),'}(w,v) = ',tmp,'$'),'Interpreter','latex','FontSize',12,'Fontname','Times New Roman'); % atp-5/22
    set(demogcf+2,'Color','white');
    saveas(demogcf+2,strcat('log\fig\compspy',num2str(j)),'fig');
    close(demogcf+2);
end
fid = fopen(logmfname,'a');
fprintf(fid,'%%\n%%%% Some components...;\n%%\n');
fprintf(fid,'%% primal affine FE components computed: %d matrices for a and %d vectors for f, for example\n',Qa,Qf);
fprintf(fid,'%% (see PROBDEF structure for the complete set).\n');
for j = 1:min(3,length(Laffsunipos))
    fprintf(fid,'open(%s);\n',strcat('''log\fig\compspy',num2str(j),'.fig'''));
end
fclose(fid);

if (plotdemo == 1)
    fprintf('primal affine FE components computed: %d matrices for a and %d vectors for f, for example\n',Qa,Qf)
    for j = 1:min(3,length(Laffsunipos))
        fprintf('\n')
        fprintf(strcat('      a^',num2str(sizeLaffprintsortind(j)),'(phiFE_i,phiFE_j)=\n'))
        fprintf('\n')
        figure(demogcf+2);
        tmp = gencompfunc(probtype,sizeLaffprintsortind(j),numdoms,numnload,numnloadgroup,Lsepcoeff,Boolecoeff,5);
        spy(Kq{sizeLaffprintsortind(j)});
        title(strcat('$','a^{',num2str(sizeLaffprintsortind(j)),'}(w,v) = ',tmp,'$'),'Interpreter','latex','FontSize',12,'Fontname','Times New Roman'); % atp-5/22
        pause
    end;
    fprintf('(see PROBDEF structure for the complete set).\n');
end;

% end symbolic pre-processor

%%%%%create VIS structure for Visualization%%%%%%%%%%%%%%%%%%%%% Gianluigi & atp-5/21
VIS.p=mesh.p;
VIS.t=mesh.t;
VIS.e=mesh.e;
VIS.UD=uDIR;
VIS.B=Btmp;

assignin('base',strcat(probname,'_','VIS'),VIS);
save(strcat(probname,'_','VIS'),strcat(probname,'_','VIS'));

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%create SYMB structure for webserver%%%%%%%%%%%%%%%%%%%%%%%%%%phuong-6/27
for i = 1:size(Gaffs,1)
    for j = 1:size(Gaffs,2)
        SYMB.Gaffschar{i,j} = char(Gaffs(i,j));
    end
end
for i = 1:size(Caffs,1)
    for j = 1:size(Caffs,2)
        SYMB.Caffschar{i,j} = char(Caffs(i,j));
    end
end
for i = 1:size(psym,1)
    for j = 1:size(psym,2)
        SYMB.psymchar{i,j} = char(psym(i,j));
    end
end
SYMB.P = P; SYMB.p = mesh.p; SYMB.e = mesh.e; SYMB.t = mesh.t; SYMB.nodemap = nodemap; SYMB.uDIR = uDIR; SYMB.B = Btmp;

assignin('base',strcat(probname,'_','SYMB'),SYMB);

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

clear K1 K2 K3 K4 M Masstmp Rtmp Qtmp Q1 Ktmpq Ktmp Htmp Gtmp F1 Ftmpq;
copyfile(strcat(probname,'_','pdedom.m'),strcat(probname,'_','pdedom_save.m'))
delete(strcat(probname,'_','pdedom.m'));

save(strcat(probname,'_','SYMB')) % save all to *PROBNAME_SYMB for use with subsequent (multiple) outputs

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% store quantities from the symbolic pre-processor (no user input required)
PROBDEF.type ='coer_noncompliant'; % problem type

PROBDEF.plotdemo=plotdemo; % atp-5/21

if exist('dt') & exist('nt')
    PROBDEF.type ='parabolic'; % problem type
    if exist('oareaload')
        PROBDEF.oareaload=1;
    else
        PROBDEF.oareaload=0;
    end
    OFFLINE.FEM.timestep.dt=dt;
    OFFLINE.FEM.timestep.nt=nt;
    x=mesh.p*Btmp;
    x1=x(1,:)';
    x2=x(2,:)';
    nnodes=length(x1);
    if exist('initsol')
        listsol=sym(initsol);
        if exist('theta_u') 
            listu=sym(theta_u);
        elseif exist('Theta_u') 
            listu=sym(Theta_u);
        else
            listu='1';
        end
        if size(listsol,1)~=size(listu,1)
            error('Warning: initsol and theta_u must be the same size');
        end
        PROBDEF.Q_affine.u = size(listsol,1)+1;
        for i=1:size(listsol,1)
            OFFLINE.FEM.matrix.Uq{i}=eval(listsol(i,:)).*ones(nnodes,1);            
            PROBDEF.Uaffsunipos{i}=char(listu(i,:));
        end        
        OFFLINE.FEM.matrix.Uq{end+1}=-VIS.B'*VIS.UD;            
        PROBDEF.Uaffsunipos{end+1}='1';
    else
        OFFLINE.FEM.matrix.Uq{1}=0-VIS.B'*VIS.UD;
        PROBDEF.Q_affine.u = 1; 
        PROBDEF.Uaffsunipos{1}='1';
    end
    OFFLINE.FEM.matrix.UD=VIS.B'*VIS.UD;
    OFFLINE.GREEDY.Offline='offline_parabolic_primal';
    OFFLINE.GREEDY.Online='online_parabolic_primal';
end

PROBDEF.P = P; % scalar $P$, the number of parameters
PROBDEF.probtype = probtype;
PROBDEF.femOPT = femOPT;
PROBDEF.mu_min = mu_min;
PROBDEF.mu_max = mu_max;
PROBDEF.mu_bar = mu_bar;
PROBDEF.mu_ref = muref;

PROBDEF.Q_affine.a = Qa ; % scalar $Q_a$
PROBDEF.Q_affine.m = Qm ; % scalar $Q_m$
PROBDEF.Q_affine.f = Qf ; % scalar $Q_f$
for q=1:Qa;
    eval(strcat('PROBDEF.Laffsunipos{',num2str(q),'}=Laffsunipos{q};'));
end;
for q=1:Qm;
    eval(strcat('PROBDEF.Maffsunipos{',num2str(q),'}=Maffsunipos{q};'));
end;
for q = 1:Qf;
    eval(strcat('PROBDEF.Raffsunipos{',num2str(q),'}= Raffsunipos{q};'));
end

PROBDEF.SYMB = SYMB;

assignin('base',strcat(probname,'_','pr_PROBDEF'),PROBDEF);
save(strcat(probname,'_','pr_PROBDEF'),strcat(probname,'_','pr_PROBDEF')); % save *PROBNAME_PROBDEF structure to file *PROBNAME_pr_PROBDEF.mat
% Fill the "INs" part of the PROBNAME_OFFLINE structure.
% First enter the FEM matrices.
for q=1:Qa;
    eval(strcat('OFFLINE.FEM.matrix.Aq{',num2str(q),'}=Kq{q};'));
end;
for q=1:Qm;
    eval(strcat('OFFLINE.FEM.matrix.Mq{',num2str(q),'}=Mq{q};'));
end;
for q = 1:Qf;
    eval(strcat('OFFLINE.FEM.matrix.Fq{',num2str(q),'}=Fq{q};'));
end;
OFFLINE.FEM.matrix.M_ref = 0.5*(M_ref+M_ref'); % mass matrix 
OFFLINE.coerlb.failedpoints=[]; %added GR to manage failedpoints
assignin('base',strcat(probname,'_','pr_OFFLINE'),OFFLINE);
save(strcat(probname,'_','pr_OFFLINE'),strcat(probname,'_','pr_OFFLINE')) % save *PROBNAME_OFFLINE structure (so far) to file *PROBNAME_OFFLINE.mat

% generate the file "Get_Theta_q.m"
fid = fopen(strcat(probname,'_','Get_Theta_q.m'),'wt');
fprintf(fid,'%% -----rbMIT_System Software Copyright MIT 2006-07-----\n');
fprintf(fid,'%%\n'); 
fprintf(fid,'%%\n');
fprintf(fid,'%% The user agrees to rbMIT_System MIT usage, distribution, and citation terms and conditions \n');
fprintf(fid,'%% described in the License at http://augustine.mit.edu/rbMIT_SystemLicense.htm.\n');
fprintf(fid,'%% rbMIT_System Software PartI_V2\n');
fprintf(fid,'%%\n');
fprintf(fid,'\n');
fprintf(fid,'function [Thetavectorvalue] = Get_Theta_q(DEF, muvectorvalue);\n');
fprintf(fid,'P = %d ; %% $P$, the number of parameters\n',PROBDEF.P);
fprintf(fid,'Qa = %d;\n',PROBDEF.Q_affine.a);
fprintf(fid,'Qf = %d;\n',PROBDEF.Q_affine.f);
fprintf(fid,'nummupts=size(muvectorvalue,1); %% nummupts=M\n');
fprintf(fid,'for m=1:nummupts\n');
for pp=1:PROBDEF.P
fprintf(fid,'    %s = muvectorvalue(m,%d);\n',strcat('mu',num2str(pp)),pp);
end
fprintf(fid,'    %% First compute the Theta_a^q, 1 \\le q \\le Q_a.\n');
for q=1:PROBDEF.Q_affine.a
fprintf(fid,'    Theta_a(1,%d) = %s;\n',q,PROBDEF.Laffsunipos{q});
end
fprintf(fid,'    %% Now compute the Theta_f^q, 1 \\le q \\le Q_f.\n');
for q=1:PROBDEF.Q_affine.f
fprintf(fid,'    Theta_f(1,%d) = %s;\n',q,PROBDEF.Raffsunipos{q});
end
% cuong-6/23
if strcmp(PROBDEF.type,'parabolic')
    fprintf(fid,'    %% Compute the Theta_m^q, 1 \\le q \\le Q_m.\n');
    for q=1:PROBDEF.Q_affine.m
    fprintf(fid,'    Theta_m(1,%d) = %s;\n',q,PROBDEF.Maffsunipos{q});
    end
    for q=1:PROBDEF.Q_affine.u
    fprintf(fid,'    Theta_u(1,%d) = %s;\n',q,PROBDEF.Uaffsunipos{q});
    end
    fprintf(fid,'    Thetavectorvalue(m,:) = [Theta_a, Theta_f, Theta_m, Theta_u];\n');
else
    fprintf(fid,'    Thetavectorvalue(m,:) = [Theta_a, Theta_f];\n');
end
% cuong-6/23
fprintf(fid,'end\n');
fclose(fid);

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

save symb_temp probname;
clear;
load symb_temp;
delete symb_temp.mat;