function [out_affsunipos, out_Boolecoeff] = symcompress(P, in_affsunipos, in_Boolecoeff, pflag)
% -----rbMIT Software Copyright MIT 2006-07----
%  DBP  Huynh,NC Nguyen, AT Patera, G Rozza
% Henceforth, Software shall refer to the rbMIT_System software package: 
% the contents of the rbMIT_Library and rbMIT_Aux folders.
% 
% This License governs use of all accompanying Software, and your download and/or use of the Software constitutes acceptance 
% of this License.
% 
% You may use this Software for any non-commercial purpose, subject to the restrictions in this license. 
% Some purposes which can be non-commercial are teaching and academic research.
% 
% You may not use or distribute this Software or any derivative works in any form for commercial purposes. 
% Examples of commercial purposes would be licensing, leasing, or selling the Software, or distributing the 
% Software for use with commercial products.
% 
% You may modify this Software and distribute the modified Software for non-commercial purposes,
%  however, you may not grant rights to the Software or derivative works that are broader than those 
% provided by this License. For example, you may not distribute modifications of the Software under terms 
% that would permit commercial use.
% 
% In return, we require that you agree:
% 
% not to remove any copyright or other notices from the Software;
% 
% that if you distribute the Software in source or object form, you will include a verbatim copy of this license;
% 
% that if you distribute derivative works of the Software in source code form you do so only under a license
% that includes all of the provisions of this License, and if you distribute derivative works of the Software solely 
% in object form you do so only under a license that complies with this License;
% 
% that if you have modified the Software or created derivative works, and distribute such modifications or derivative
% works, you will cause the modified files to carry prominent notices so that recipients know that they are not receiving the original Software;
% 
% THAT THE SOFTWARE COMES "AS IS", WITH NO WARRANTIES: THIS MEANS NO EXPRESS, IMPLIED OR STATUTORY WARRANTY, 
% INCLUDING WITHOUT LIMITATION WARRANTIES OF MERCHANTABILITY OR FITNESS FOR A PARTICULAR PURPOSE OR ANY WARRANTY 
% OF TITLE OR NON-INFRINGEMENT; YOU MUST PASS THIS DISCLAIMER ON WHENEVER YOU DISTRIBUTE THE SOFTWARE OR DERIVATIVE WORKS;
% 
% THAT NEITHER MIT NOR THE AUTHORS WILL BE LIABLE FOR ANY DAMAGES RELATED TO THE SOFTWARE OR THIS LICENSE, 
% INCLUDING DIRECT, INDIRECT, SPECIAL, CONSEQUENTIAL OR INCIDENTAL DAMAGES; YOU MUST PASS THIS LIMITATION OF LIABILITY 
% ON WHENEVER YOU DISTRIBUTE THE SOFTWARE OR DERIVATIVE WORKS;
% 
% that your rights under the License end automatically if you breach the License in any way;
% 
% that MIT reserves all rights not expressly granted to you in this License.
% 
% (Note: The wording of this license agreement is derived from a Microsoft Shared Source license agreement.)
% 
% License at http://augustine.mit.edu/rbMIT_SystemLicense.htm.
%
% rbMIT Software Part_II_and_IV
%
% ---------- 
in_Boolecoeff = double(in_Boolecoeff);

% if exist('pflag')
    % save original input
    old_in_affsunipos = in_affsunipos;
    old_in_Boolecoeff = in_Boolecoeff;
    % find all polynomial terms
    tmpindex = [];
    for i = 1:length(in_affsunipos)
        tmpaffunipos(i) = expand(sym(in_affsunipos{i}));
        [tmp1,tmp2] = numden(tmpaffunipos(i));
        % only polynomials are supported
        % phuong 2/2/09
        tmp3 = length(regexp(in_affsunipos{i},'\w*mu\w*\^\w*','match')) + length(strfind(in_affsunipos{i},'abs')) + length(strfind(in_affsunipos{i},'sin')) + length(strfind(in_affsunipos{i},'cos')) + length(strfind(in_affsunipos{i},'tan')) + length(strfind(in_affsunipos{i},'log')) + length(strfind(in_affsunipos{i},'exp'));
        if (strcmp(findsym(tmp2),'')) && (tmp3 == 0)
            tmpindex = [tmpindex i];
        end
    end
    
    % collapse all polynomial terms
    count = 0;
    Ltot = [];
    for i = 1:length(tmpindex)
        if not(exist('mupad')) % phuong 2/2/09
            if strcmp(char(maple('whattype',tmpaffunipos(tmpindex(i)))),'`+`')
                Ltmp = maple('op',tmpaffunipos(tmpindex(i)));
            else
                Ltmp = tmpaffunipos(tmpindex(i));
            end
        else % mupad fix phuong 2/2/09
%             tmpchar = char(tmpaffunipos(tmpindex(i)));
%             pluscount = findstr(tmpchar,'+');
%             pluscount = sort([pluscount, findstr(tmpchar,'-')]);
%             if isempty(pluscount)
%                 Ltmp = tmpaffunipos(tmpindex(i));
%             else
%                 Ltmp = sym(tmpchar(1:pluscount(1)-1));
%                 for j = 1:length(pluscount)-1
%                     Ltmp = [Ltmp, sym(tmpchar(pluscount(j)+1:pluscount(j+1)-1))];
%                 end
%                 Ltmp = [Ltmp, sym(tmpchar(pluscount(end)+1:length(tmpchar)))];
%             end            
            [tmp1,tmp2] = numden(tmpaffunipos(tmpindex(i)));
            tmpchar = char(expand(tmp1));
            tmpchar = regexprep(tmpchar,'-','+(-1)*');
            pluscount = setdiff(findstr(tmpchar,'+'),1);
            if isempty(pluscount)
                Ltmp = tmpaffunipos(tmpindex(i));
            else
                Ltmp = sym(tmpchar(1:pluscount(1)-1))/tmp2;
                for j = 1:length(pluscount)-1
                    Ltmp = [Ltmp, sym(tmpchar(pluscount(j)+1:pluscount(j+1)-1))/tmp2];
                end
                Ltmp = [Ltmp, sym(tmpchar(pluscount(end)+1:length(tmpchar)))/tmp2];
            end 
        end
        Ltot = [Ltot Ltmp];
        for j = 1:length(Ltmp)
            count = count + 1;
            paffsunipos{count} = char(Ltmp(j));
            pBoolecoeff(:,count) = in_Boolecoeff(:,tmpindex(i));
        end
    end
    if length(Ltot)>1
        for i = 1:length(Ltot)
            Ltot(3,i) = sym(1);
            tmp = sym(Ltot(1,i));
            for p = 1:P
                [tmp1,tmp2] = symcoeffs(tmp,['mu',num2str(p)]); % phuong 2/2/09
                Ltot(3,i) = Ltot(3,i)*tmp2;
                tmp = tmp1;
            end
            Ltot(2,i) = tmp;
            mutmp{i} = char(Ltot(3,i));
        end
        [ptmp, index1, index2] = unique(mutmp);
        paffsunipos = ptmp';
        tmpBoolecoeff = pBoolecoeff;
        pBoolecoeff = 0*pBoolecoeff;
        for i = 1:length(index2)
            pBoolecoeff(:,index2(i)) = pBoolecoeff(:,index2(i)) + double(Ltot(2,i))*tmpBoolecoeff(:,i);
        end
        % compress all polynomial terms
        [paffsunipos,pBoolecoeff] = inner_symcompress(paffsunipos,pBoolecoeff);
        % inject back all the new terms
        tmpaffsunipos = in_affsunipos;
        tmpBoolecoeff = in_Boolecoeff;
        clear in_affsunipos in_Boolecoeff;
        tmpindex2 = setdiff(1:1:length(tmpaffsunipos),tmpindex);
        for i = 1:length(tmpindex2)
            in_affsunipos{i} = tmpaffsunipos{tmpindex2(i)};
            in_Boolecoeff(:,i) = tmpBoolecoeff(:,tmpindex2(i));
        end
        for i = 1:length(paffsunipos)
            in_affsunipos{i+length(tmpindex2)} = paffsunipos{i};
            in_Boolecoeff(:,i+length(tmpindex2)) = pBoolecoeff(:,i);
        end
%         [length(old_in_affsunipos) length(in_affsunipos)]
    end
    % recover original input if there is no improvement
    if length(old_in_affsunipos) < length(in_affsunipos)
        in_affsunipos = old_in_affsunipos;
        in_Boolecoeff = old_in_Boolecoeff;
    end
% end

[out_affsunipos, out_Boolecoeff] = inner_symcompress(in_affsunipos, in_Boolecoeff);

function [out_affsunipos, out_Boolecoeff] = inner_symcompress(in_affsunipos, in_Boolecoeff) 
% further "compress" affs by eliminate affs that are equal to within a
% multiplicative constant
in_Q = length(in_affsunipos);
indextmp = 1:1:in_Q;
factor = ones(in_Q,1);
for i = 1:length(in_affsunipos) % phuong 2/2/09 (speed-up)
    sym_in_affsunipos(i) = sym(in_affsunipos{i});
end
for i = 1:in_Q
    for j = in_Q:-1:i+1
%         symfactor = simplify(sym(in_affsunipos{j})/sym(in_affsunipos{i}));
%         symfactor = vpa(simplify(sym(in_affsunipos{j}))/simplify(sym(in_affsunipos{i})),10);
%         symfactor = vpa(simplify(sym(in_affsunipos{j})/sym(in_affsunipos{i})),10);
        symfactor = vpa(simplify(sym_in_affsunipos(j)/sym_in_affsunipos(i)),10); % phuong 2/2/09
        if isempty(findsym(symfactor))
            if indextmp(j) == j
                indextmp(j) = i;
                factor(j) = double(symfactor);
            end
        end
    end
end
Boolecoeff = double(in_Boolecoeff);
temp = in_affsunipos(unique(indextmp));
Btemp = 0*Boolecoeff;
for i = 1:in_Q
    Btemp(:,indextmp(i)) = Btemp(:,indextmp(i)) + Boolecoeff(:,i)*factor(i);
end
% atpfixed below (maybe) (4/12)
% Boolecoeff = 0*Btemp;
uniuni = unique(indextmp);
Boolecoeff = zeros(size(Boolecoeff,1),length(uniuni));
for i = 1:length(uniuni)
    Boolecoeff(:,i) = Btemp(:,min( find( indextmp == uniuni(i) ) ) );
end
out_affsunipos = temp;
out_Boolecoeff = Boolecoeff;
