% figure
% -----rbMIT Software Copyright MIT 2006-07----
%  DBP  Huynh,NC Nguyen, AT Patera, G Rozza
% Henceforth, Software shall refer to the rbMIT_System software package: 
% the contents of the rbMIT_Library and rbMIT_Aux folders.
% 
% This License governs use of all accompanying Software, and your download and/or use of the Software constitutes acceptance 
% of this License.
% 
% You may use this Software for any non-commercial purpose, subject to the restrictions in this license. 
% Some purposes which can be non-commercial are teaching and academic research.
% 
% You may not use or distribute this Software or any derivative works in any form for commercial purposes. 
% Examples of commercial purposes would be licensing, leasing, or selling the Software, or distributing the 
% Software for use with commercial products.
% 
% You may modify this Software and distribute the modified Software for non-commercial purposes,
%  however, you may not grant rights to the Software or derivative works that are broader than those 
% provided by this License. For example, you may not distribute modifications of the Software under terms 
% that would permit commercial use.
% 
% In return, we require that you agree:
% 
% not to remove any copyright or other notices from the Software;
% 
% that if you distribute the Software in source or object form, you will include a verbatim copy of this license;
% 
% that if you distribute derivative works of the Software in source code form you do so only under a license
% that includes all of the provisions of this License, and if you distribute derivative works of the Software solely 
% in object form you do so only under a license that complies with this License;
% 
% that if you have modified the Software or created derivative works, and distribute such modifications or derivative
% works, you will cause the modified files to carry prominent notices so that recipients know that they are not receiving the original Software;
% 
% THAT THE SOFTWARE COMES "AS IS", WITH NO WARRANTIES: THIS MEANS NO EXPRESS, IMPLIED OR STATUTORY WARRANTY, 
% INCLUDING WITHOUT LIMITATION WARRANTIES OF MERCHANTABILITY OR FITNESS FOR A PARTICULAR PURPOSE OR ANY WARRANTY 
% OF TITLE OR NON-INFRINGEMENT; YOU MUST PASS THIS DISCLAIMER ON WHENEVER YOU DISTRIBUTE THE SOFTWARE OR DERIVATIVE WORKS;
% 
% THAT NEITHER MIT NOR THE AUTHORS WILL BE LIABLE FOR ANY DAMAGES RELATED TO THE SOFTWARE OR THIS LICENSE, 
% INCLUDING DIRECT, INDIRECT, SPECIAL, CONSEQUENTIAL OR INCIDENTAL DAMAGES; YOU MUST PASS THIS LIMITATION OF LIABILITY 
% ON WHENEVER YOU DISTRIBUTE THE SOFTWARE OR DERIVATIVE WORKS;
% 
% that your rights under the License end automatically if you breach the License in any way;
% 
% that MIT reserves all rights not expressly granted to you in this License.
% 
% (Note: The wording of this license agreement is derived from a Microsoft Shared Source license agreement.)
% 
% License at http://augustine.mit.edu/rbMIT_SystemLicense.htm.
%
% rbMIT Software Part_II_and_IV
%
% ---------- 

curvyres = 10;
numtridr = size(tri,1);

for itri = 1:numtridr
    for jloc = 1:3;
        if(jloc < 3)
            jlocp1 = jloc + 1;
        else
            jlocp1 = 1;
        end;
        labdraw = 0;
        tmp1 = ismember(edge,[tri(itri,jloc),tri(itri,jlocp1)],'rows');
        tmp2 = ismember(edge,[tri(itri,jlocp1),tri(itri,jloc)],'rows');
        if(max(tmp1) == 1)
            iedge = find(tmp1 == 1);
            labdraw = double(tedgeval(iedge,1));
        end;
        if(max(tmp2) == 1)
            iedge = find(tmp2 == 1);
            labdraw = double(tedgeval(iedge,1));
        end;
        
        if(labdraw == 0)
            x1pt = [preal( tri(itri,jloc),1 ),preal( tri(itri,jlocp1),1)];
            x2pt = [preal( tri(itri,jloc),2 ),preal( tri(itri,jlocp1),2)];
            hold on;
            plot(x1pt,x2pt,'r-','Linewidth',2);
        else;
            dtdraw = double((tedgeval(iedge,3) - tedgeval(iedge,2)))/curvyres;
            for itdraw = 1:curvyres;
                tvalr1 = double(tedgeval(iedge,2)) + (itdraw-1)*dtdraw;
                tvalr2 = tvalr1 + dtdraw;
                xfirstptsym = simplify(subs(curvedatsym{labdraw}.gfun,'t',tvalr1));
                xsecondptsym = simplify(subs(curvedatsym{labdraw}.gfun,'t',tvalr2));
                x1ptsym = [xfirstptsym(1),xsecondptsym(1)];
                x2ptsym = [xfirstptsym(2),xsecondptsym(2)];
                tmp1 = x1ptsym;
                tmp2 = x2ptsym;
                for i = 1:P
                    tmp1 = subs(tmp1,strcat('mu',num2str(i)),muref(i),0); %phuong 2/2/09
                    tmp2 = subs(tmp2,strcat('mu',num2str(i)),muref(i),0); %phuong 2/2/09
                end;
                hold on;
                plot(tmp1,tmp2,'r-','Linewidth',2);
            end;
        end;
    end;
end;
