
clear all;
% License material
%
% -----rbMIT  Software Copyright MIT 2006-07-----
% -----------DBP Huynh, NC Nguyen, AT Patera, G Rozza-------
% 
% The user agrees to rbMIT  MIT usage, distribution, and citation terms and conditions 
% described in the License at http://augustine.mit.edu/rbMIT_SystemLicense.htm.
% rbMIT Software Part_II_and_IV
%
probname = 'LEiso'
%This problem describes an Elastic Block made up by 3x3 cells with 
%variable isotropic Young's modulus in each subdomain (geometry is fixed).

probtype = 'LE1';
points = '[0,0;0.5,0;1.0,0;1.5,0;0,0.5;0.5,0.5;1.0,0.5;1.5,0.5;0,1.0;0.5,1.0;1.0,1.0;1.5,1.0;0,1.5;0.5,1.5;1.0,1.5;1.5,1.5]';
edge = [1,2;2,3;3,4;5,6;6,7;7,8;9,10;10,11;11,12;13,14;14,15;15,16;1,5;2,6;3,7;4,8;5,9;6,10;7,11;8,12;9,13;10,14;11,15;12,16];
geometry{1} = [1,14,4,13];
geometry{2} = [2,15,5,14];
geometry{3} = [3,16,6,15];
geometry{4} = [4,18,7,17];
geometry{5} = [5,19,8,18];
geometry{6} = [6,20,9,19];
geometry{7} = [7,22,10,21];
geometry{8} = [8,23,11,22];
geometry{9} = [9,24,12,23];
gflag = [1,1,1,1,1,1,1,1,1];
%parameter is Young modulus, Poisson Coefficient is fixed
matprop{1} = '[mu1, 3/10]';
matprop{2} = '[mu2, 3/10]';
matprop{3} = '[mu3, 3/10]';
matprop{4} = '[mu4, 3/10]';
matprop{5} = '[mu5, 3/10]';
matprop{6} = '[mu6, 3/10]';
matprop{7} = '[mu7, 3/10]';
matprop{8} = '[mu8, 3/10]';
matprop{9} = '[mu9, 3/10]';
% on the upper side we have zero Dirichlet condition
dirichlet = '[10,x,0;11,x,0;12,x,0;10,y,0;11,y,0;12,y,0]';
% on other sides we have Neumann conditions
nload = '[1,-1,0;2,-1,0;3,-1,0]';
muref = [0.1,0.1,0.1,0.1,0.1,0.1,0.1,0.1,0.1];
mu_min = [0.1,0.1,0.1,0.1,0.1,0.1,0.1,0.1,0.1];
mu_max = [10,10,10,10,10,10,10,10,10];
mu_bar = [1,1,1,1,1,1,1,1,1];

% block below for each output (1 output only for dummies)

%output is the displacement on the loaded side (compliant)
outputname = 'average'
oload = '[1,-1,0;2,-1,0;3,-1,0]';

 
%%%%%%%%%%%% no user input required beyond this point
if ~exist('plotdemo')
    plotdemo = 0;
end

save rbU ;
addpath('../rbMIT_Aux')
copyfile('../rbMIT_Aux/Step1_coer_noncompliant.m',...
    strcat(probname,'_','Step1_coer_noncompliant.m'))
eval(strcat(probname,'_','Step1_coer_noncompliant'))
