
clear;
% License material
%
% -----rbMIT  Software Copyright MIT 2006-07-----
% -----------DBP Huynh, NC Nguyen, AT Patera, G Rozza-------
% 
% The user agrees to rbMIT  MIT usage, distribution, and citation terms and conditions 
% described in the License at http://augustine.mit.edu/rbMIT_SystemLicense.htm.
% rbMIT Software Part_II_and_IV
%
probname = 'TBiso'

%This problem describes a Thermal Block made up by 3x3 cells with  9
%(mu1-mu9) variable isotropic conductivity coefficients (geometry is fixed)

femOPT.refine = 'subdivision';
femOPT.maxsize = 1000;

points = '[0,0;0.5,0;1.0,0;1.5,0;0,0.5;0.5,0.5;1.0,0.5;1.5,0.5;0,1.0;0.5,1.0;1.0,1.0;1.5,1.0;0,1.5;0.5,1.5;1.0,1.5;1.5,1.5]';
edge = [1,2;2,3;3,4;5,6;6,7;7,8;9,10;10,11;11,12;13,14;14,15;15,16;1,5;2,6;3,7;4,8;5,9;6,10;7,11;8,12;9,13;10,14;11,15;12,16];
geometry{1} = [1,14,4,13];
geometry{2} = [2,15,5,14];
geometry{3} = [3,16,6,15];
geometry{4} = [4,18,7,17];
geometry{5} = [5,19,8,18];
geometry{6} = [6,20,9,19];
geometry{7} = [7,22,10,21];
geometry{8} = [8,23,11,22];
geometry{9} = [9,24,12,23];
gflag = [1,1,1,1,1,1,1,1,1];

% Laplacian (steady heat conduction)
kappa{1} = '[mu1, 0,0; 0, mu1, 0; 0, 0, 0]';
kappa{2} = '[mu2, 0,0; 0, mu2, 0; 0, 0, 0]';
kappa{3} = '[mu3, 0,0; 0, mu3, 0; 0, 0, 0]';
kappa{4} = '[mu4, 0,0; 0, mu4, 0; 0, 0, 0]';
kappa{5} = '[mu5, 0,0; 0, mu5, 0; 0, 0, 0]';
kappa{6} = '[mu6, 0,0; 0, mu6, 0; 0, 0, 0]';
kappa{7} = '[mu7, 0,0; 0, mu7, 0; 0, 0, 0]';
kappa{8} = '[mu8, 0,0; 0, mu8, 0; 0, 0, 0]';
kappa{9} = '[mu9, 0,0; 0, mu9, 0; 0, 0, 0]';
%top side has Dirichet BC
dirichlet = '[10,0;11,0;12,0]';
%botton side has Neumann non-homogeneous BC, other sides are Neumann
%homogeneous
nload = '[1, 0, 0, 1; 2, 0, 0, 1;3,0,0,1]';
muref = [0.1,0.1,0.1,0.1,0.1,0.1,0.1,0.1,0.1];
mu_min = [0.1,0.1,0.1,0.1,0.1,0.1,0.1,0.1,0.1];
mu_max = [10,10,10,10,10,10,10,10,10];
mu_bar = [0.1,0.1,0.1,0.1,0.1,0.1,0.1,0.1,0.1];

% block below for each output (1 output only for dummies)
% The output is the averag etemperature on the bottom side.

outputname = 'average'
oload = '[1,1;2,1;3,1]';

 
%%%%%%%%%%%% no user input required beyond this point
if ~exist('plotdemo')
    plotdemo = 0;
end

save rbU ;
addpath('../rbMIT_Aux')
copyfile('../rbMIT_Aux/Step1_coer_noncompliant.m',...
    strcat(probname,'_','Step1_coer_noncompliant.m'))
eval(strcat(probname,'_','Step1_coer_noncompliant'))
