
clear all;
% License material
%
% -----rbMIT  Software Copyright MIT 2006-07-----
% -----------DBP Huynh, NC Nguyen, AT Patera, G Rozza-------
% 
% The user agrees to rbMIT  MIT usage, distribution, and citation terms and conditions 
% described in the License at http://augustine.mit.edu/rbMIT_SystemLicense.htm.
% rbMIT Software Part_II_and_IV
%
probname = 'cantilever1'
% Problem: This problem corresponds to a cantilever beam clamped at both side 
% under a uniform load on the upper side.
% mu1: length of the beam
probtype = 'LE2';
points = '[0,-1/2;mu1/4,-1/2;mu1/2,-1/2;3*mu1/4,-1/2;mu1,-1/2;mu1,1/2;3*mu1/4,1/2;mu1/2,1/2;mu1/4,1/2;0,1/2]';
edge = [1,2;2,3;3,4;4,5;5,6;6,7;7,8;8,9;9,10;10,1];
geometry{1} = [1,2,3,4,5,6,7,8,9,10];
gflag = [1];
% material properties, Young modulus and Poisson ratio
matprop{1} = '[1, 3/10]';
muref = [10];
mu_min = [2];
mu_max = [18];
mu_bar = [10];
% nload: edge fn ft
% ft is tangential force (aligned with the en, direction is from p1 to p2)
% fn is normal force (cross(en,et)>0))
nload = '[6,-1,0;7,-1,0;8,-1,0;9,-1,0]';
% dirichlet: edge lab val
% lab can be "x" and "y"
dirichlet = '[5,x,0;5,y,0;10,x,0;10,y,0]';

% Output: The output is the integral of the vertical displacement along the upper side. 
% This output  will approach the classical solution given by the beam theory 
% when mu1 increases.
outputname = 'cantilever1'
oload = '[6,-1,0;7,-1,0;8,-1,0;9,-1,0]';

 
%%%%%%%%%%%% no user input required beyond this point
if ~exist('plotdemo')
    plotdemo = 0;
end

save rbU ;
addpath('../rbMIT_Aux')
copyfile('../rbMIT_Aux/Step1_coer_noncompliant.m',...
    strcat(probname,'_','Step1_coer_noncompliant.m'))
eval(strcat(probname,'_','Step1_coer_noncompliant'))