
clear;
% License material
%
% -----rbMIT  Software Copyright MIT 2006-07-----
% -----------DBP Huynh, NC Nguyen, AT Patera, G Rozza-------
% 
% The user agrees to rbMIT  MIT usage, distribution, and citation terms and conditions 
% described in the License at http://augustine.mit.edu/rbMIT_SystemLicense.htm.
% rbMIT Software Part_II_and_IV

probname = 'elas4'

% This problem corresponds to a plate contains an ellipse hole under tension at two 
% opposite side, assuming isotropic plane stress. The model modelled as a quarter 
% of the original domain and symmetric boundary conditions are considered.
% mu1: major semiaxis
% mu2: minor semiaxis

probtype = 'LE2';
points = '[mu1,0;1,0;1,1;0,1;0,mu2]';
edge = [1,5;5,4;4,3;3,2;2,1];
geometry{1} = [1,2,3,4,5];
gflag = [1];
% material properties, Young modulus and Poisson ratio
matprop{1} = '[1, 3/10]';
muref = [0.3,0.3];
mu_min = [0.05,0.05];
mu_max = [0.55,0.55];
mu_bar = [0.3,0.3];
% nload: edge fn ft
% ft is tangential force (aligned with the en, direction is from p1 to p2)
% fn is normal force (cross(en,et)>0))
nload = '[4,1,0]';
% dirichlet: edge lab val
% lab can be "x" and "y"
dirichlet = '[2,x,0;5,y,0]';
curvedat = '[0,0,mu1,mu2,0,cos(t),sin(t)]';
tarclist = '[1,1,0,pi/2]';

% Output: The output is the integral of the horizontal displacement along the edge 
% of which tension is applied. This output will approach the analytical solution 
% for the infinite case when the size of the elliptic hole decreases.
% Analytical solution for the infinite plate with a circular hole is
% available in Roark's Formulas for Stress and Strain.
outputname = 'elas4'
oload = '[4,1,0]';
 
%%%%%%%%%%%% no user input required beyond this point
if ~exist('plotdemo')
    plotdemo = 0;
end

save rbU ;
addpath('../rbMIT_Aux')
copyfile('../rbMIT_Aux/Step1_coer_noncompliant.m',...
    strcat(probname,'_','Step1_coer_noncompliant.m'))
eval(strcat(probname,'_','Step1_coer_noncompliant'))