
clear;
% License material
%
% -----rbMIT  Software Copyright MIT 2006-07-----
% -----------DBP Huynh, NC Nguyen, AT Patera, G Rozza-------
% 
% The user agrees to rbMIT ? MIT usage, distribution, and citation terms and conditions 
% described in the License at http://augustine.mit.edu/rbMIT_SystemLicense.htm.
% rbMIT Software Part_II_and_IV
%
probname = 'elashole'
% LE problem  in two regions (a rectangular area containing a parametrized 
% ellipse: mu1 and mu2 are the semi-axis)
% the external region has also a parametrized Young Modulus mu3
probtype = 'LE1';
points = '[mu1,0;0,mu2;-mu1,0;0,-mu2;2,2;-2,2;-2,-2;2,-2]';
edge = [1,2;2,3;3,4;4,1;5,6;6,7;7,8;8,5];
geometry{1} = [1,2,3,4];
geometry{2} = [5,6,7,8];
matprop{1} = '[mu3, 3/10]';
matprop{2} = '[1, 3/10]';
gflag = [1,1];
muref = [1,1,1];
mu_min = [0.8,0.8,1];
mu_max = [1.2,1.2,5];
mu_bar = [1.0,1.0,1];
curvedat = '[0,0,mu1,mu2,0,cos(t),sin(t)]';
tarclist = '[1,1,0,pi/2;2,1,pi/2,pi;3,1,pi,3*pi/2;4,1,3*pi/2,2*pi]';
% nload: edge fn ft
% ft is tangential force (aligned with the en, direction is from p1 to p2)
% fn is normal force (cross(en,et)>0))
nload = '[8,1,0]';
% dirichlet: edge lab val
% lab can be "x" and "y"
dirichlet = '[6,x,0;6,y,0]';

outputname = 'elas8'
%displacement on side 3
oload = '[8,0,1]';
 
%%%%%%%%%%%% no user input required beyond this point
if ~exist('plotdemo')
    plotdemo = 0;
end

save rbU ;
addpath('../rbMIT_Aux')
copyfile('../rbMIT_Aux/Step1_coer_noncompliant.m',...
    strcat(probname,'_','Step1_coer_noncompliant.m'))
eval(strcat(probname,'_','Step1_coer_noncompliant'))