clear all;
% License material
%
% -----rbMIT  Software Copyright MIT 2006-07-----
% -----------DBP Huynh, NC Nguyen, AT Patera, G Rozza-------
% 
% The user agrees to rbMIT  MIT usage, distribution, and citation terms and conditions 
% described in the License at http://augustine.mit.edu/rbMIT_SystemLicense.htm.
% rbMIT Software Part_II_and_IV
%
plotdemo = 0;
femOPT.refine = 'subdivision';
femOPT.maxsize = 500;
probtype = 'LE5'; % axis-symmetric flag


%
% Computation of the force (drag) around an ellipsoid with axis equal to 1
% and mu2 (axisymmetric). We use Stokes by penalty (Poisson ratio \nu is next to 0.5).
% Output should be multiplied by 2*pi to get the complete drag around
% ellipsoid. Reference viscosity is given by 1/2(1+\nu).

probname = 'ellipsedrag'
points = '[1,0;0,-mu2;0,-8;8,-8;8,8;0,8;0,mu2]';
edge = [2,1;2,3;3,4;4,5;5,6;6,7;1,7];
geometry{1} = [1,2,3,4,5,6,7];
gflag = [1];
% material properties, Young modulus and Poisson ratio
matprop{1} = '[1, mu1]';
muref = [0.4,1];
mu_min = [0.4,0.9];
mu_max = [0.475,1.2];
mu_bar = [0.4,1];
curvedat = '[0,0,1,mu2,0,cos(t),sin(t)]';


tarclist = '[7,1,0,pi/2;1,1,-pi/2,0]';
dirichlet = '[7,y,0;7,x,0;1,x,0;1,y,0;3,x,0;3,y,1;5,x,0;5,y,1;4,x,0;4,y,1]';
outputname = 'drag'
dLIFT = '[1,0,1;7,0,1]';


% %%%%%%%%%%%% no user input required beyond this point
if ~exist('plotdemo')
    plotdemo = 0;
end

save rbU ;
addpath('../rbMIT_Aux')
copyfile('../rbMIT_Aux/Step1_coer_noncompliant.m',...
    strcat(probname,'_','Step1_coer_noncompliant.m'))
eval(strcat(probname,'_','Step1_coer_noncompliant'))
