
clear;
% License material
%
% -----rbMIT  Software Copyright MIT 2006-07-----
% -----------DBP Huynh, NC Nguyen, AT Patera, G Rozza-------
% 
% The user agrees to rbMIT ? MIT usage, distribution, and citation terms and conditions 
% described in the License at http://augustine.mit.edu/rbMIT_SystemLicense.htm.
% rbMIT Software Part_II_and_IV
%
probname = 'fin'
femOPT.codes = 'HB';
femOPT.maxsize = 1500;
% A thermal fin problem: illustrates inhomogeneous Dirichlet conditions,
% Robin conditions, and a flux output.
% plotdemo = 1;
points = '[1/2,0; 1/2, mu2/2; 1/2, mu2; -1/2, mu2; -1/2, mu2/2; -1/2, 0]';
% mu2 is the length of the fin
edge = [1,2;2,3;3,4;4,5;5,6;6,1];
geometry{1} = [1,2,3,4,5,6];
gflag = [1];
kappa{1} = '[1 0 0; 0 1 0; 0 0 0]';
muref = [.1,4];
mu_min = [0.02,2];
mu_max = [0.5,8];
mu_bar = [0.1,4];
nload = '[1,mu1,0,0;2,mu1,0,0;4,mu1,0,0;5,mu1,0,0]';
% imposes kappa du/dn + c1*(u - c2) = c3; here c1 = mu1 is the Biot number
dirichlet = '[6,1]';
% unity temperature at the fin base

outputname = 'flux'
dLIFT = '[6,1]';
% requests the integrated flux (with prefactor '1') over edge 6 --- the fin base
% Note: in limit of mu1 (Biot) tends to zero, output should be
% sqrt(2*mu1)*tanh( mu2* sqrt(2*mu1) );
% for all mu1, this analytical expression should be an upper bound
% for the actual output.


%%%%%%%%%%%% no user input required beyond this point
if ~exist('plotdemo')
    plotdemo = 0;
end

save rbU ;
addpath('../rbMIT_Aux')
copyfile('../rbMIT_Aux/Step1_coer_noncompliant.m',...
    strcat(probname,'_','Step1_coer_noncompliant.m'))
eval(strcat(probname,'_','Step1_coer_noncompliant'))