
clear;
% License material
%
% -----rbMIT  Software Copyright MIT 2006-07-----
% -----------DBP Huynh, NC Nguyen, AT Patera, G Rozza-------
% 
% The user agrees to rbMIT ? MIT usage, distribution, and citation terms and conditions 
% described in the License at http://augustine.mit.edu/rbMIT_SystemLicense.htm.
% rbMIT Software Part_II_and_IV
%
probname = 'graetz'
probtype = 'TH';
plotdemo = 0;
% Advection-diffusion problem with two parameters (lentgh of the channel
% and Peclet number), advection field is polynomial (parabolic in x direction and
% zero in y direction). Mixed Dirichlet and Neumann BC. It simulates a
% simple scalar Graezt flow (see Arpaci, "Conduction heat transfer").
%mu1 L
%mu2 Peclet
% a rectangular channel
points = '[0,0;1,0;1+mu1,0;1+mu1,1.0;1,1.0;0,1.0]';
edge = [1,2;2,3;3,4;4,5;5,6;6,1];
geometry{1} = [1,2,3,4,5,6];
gflag = [1];
% operator is 1/mu2*du/dx*du/dx+ 1/mu2*du/dy*du/dy + Udu/dxv + Vdu/dyv
kappa{1} = '[1/mu2, 0, 0; 0, 1/mu2, 0; 10*y*(1.0-y), 0, 0]';
muref = [1,1];
mu_min = [1,0.1];
mu_max = [10,100];
mu_bar = [1,1];
%zero Dirichlet BC on side 3 and 4
dirichlet = '[1,0;2,1;4,1;5,0;6,0]';
% Neumann on other side (non homogeneous on side 1 and zero on side 2)
nload = '[3, 0, 0, 0]';
%areaload='[1,1]';
%output is  compliant and it is the "concentration" at the bottom
%side where we have Neumann BC.

outputname = 'average'
oareaload = '[1,1]';
%oload = '[2,1]';

 
%%%%%%%%%%%% no user input required beyond this point
if ~exist('plotdemo')
    plotdemo = 0;
end

save rbU ;
addpath('../rbMIT_Aux')
copyfile('../rbMIT_Aux/Step1_coer_noncompliant.m',...
    strcat(probname,'_','Step1_coer_noncompliant.m'))
eval(strcat(probname,'_','Step1_coer_noncompliant'))
