clear;
% License material
%
% -----rbMIT  Software Copyright MIT 2006-07-----
% -----------DBP Huynh, NC Nguyen, AT Patera, G Rozza-------
% 
% The user agrees to rbMIT  MIT usage, distribution, and citation terms and conditions 
% described in the License at http://augustine.mit.edu/rbMIT_SystemLicense.htm.
% rbMIT Software Part_II_and_IV
%
% plotdemo = 1;
% femOPT.codes = 'HB';
% femOPT.maxsize = 2000;
probname = 'tailpiano'
% This problem illustrates a Curvy Edge domain with Curvy Triangles. It
% also illustrates anisotropic conductivity.

points = '[0,mu1;1/2,0;1,-mu1;1,-1;0,-1;0,0]';
% mu1 is the amplitude of the cosinusoidal variation of the top boundary
edge = [1,2;2,3;3,4;4,5;5,6;6,1];
geometry{1} = [1,2,3,4,5,6];
gflag = [1];
kappa{1} = '[1 0 0; 0, mu2, 0; 0 0 0]';
% mu2 is the conductivity in the x_2 direction (relative to the
% conductivity in the x_1 direction)
muref = [1/3,5];
mu_min = [1/6,1];
mu_max = [1/2,25];
mu_bar = [1/3,5];
nload = '[5,0,0,1;6,0,0,1]';
% flux conditions on the left boundary
dirichlet = '[3,0]';
% zero Dirichlet conditions on the right boundary
curvedat = '[0,0,1,mu1,0,t,cos(pi*t);1,0,1,mu1,0,t-1,cos(pi*t)]';
% There are two families of curvy edges: the first is [0,0]' + [1 0; 0
% mu1]*[t, cos(pi*t)]'; the second is [1,0]' + [1 0; 0 mu1]*[t-1,
% cos(pi*t)]'.
tarclist = '[1,1,0,1/2;2,2,1/2,1]';
% Edge 1 is in family 1 with t varying between 0 and 1/2; Edge 2 is in
% family 2 with t varying between 1/2 and 1.

outputname = 'int'

oareaload = '[1,1]';
% The output is the integral of the field over the domain.
% Note in the limit that mu2 tends to infinity, the field approaches
% u(x) = \int_x1 \frac{1 + mu1}{1 + mu1 cos(\pi z)} dz and the output is then
% given by \int_01 u(x) dx.

%%%%%%%%%%%% no user input required beyond this point
if ~exist('plotdemo')
    plotdemo = 0;
end

save rbU ;
addpath('../rbMIT_Aux')
copyfile('../rbMIT_Aux/Step1_coer_noncompliant.m',...
    strcat(probname,'_','Step1_coer_noncompliant.m'))
eval(strcat(probname,'_','Step1_coer_noncompliant'))