clear all;

% License material
%
% -----rbMIT  Software Copyright MIT 2006-07-----
% -----------DBP Huynh, NC Nguyen, AT Patera, G Rozza-------
% 
% The user agrees to rbMIT ? MIT usage, distribution, and citation terms and conditions 
% described in the License at http://augustine.mit.edu/rbMIT_SystemLicense.htm.
% rbMIT Software Part_II_and_IV
%

probname = 'tdepheatingduct'
plotdemo = 0;
femOPT.refine = 'subdivision';
femOPT.maxsize = 500;

points = '[0,0;2,0;4,0;6,0;8,0;10,0;10,1/2;8,1/2;6,1/2;4,1/2;2,1/2;0,1/2;10,1/2+mu1;8,1/2+mu1;6,1/2+mu1;4,1/2+mu1;2,1/2+mu1;0,1/2+mu1]';
edge = [1,2;2,3;3,4;4,5;5,6;6,7;7,8;8,9;9,10;10,11;11,12;12,1;12,18;18,17;17,16;16,15;15,14;14,13;13,7;5,8];
geometry{1} = [1,2,3,4,20,8,9,10,11,12];
geometry{2} = [20,5,6,7];
geometry{3} = [7,8,9,10,11,13,14,15,16,17,18,19];
gflag = [1,1,1];
% for kappa{1} and kappa{2} we include mu3 in (3,1) entry (uniform velocity in
% x_1) with .5 \le mu3 \le 5 --- 
kappa{1} = '[1 0 0; 0, 1, 0; mu3 0 0]';
kappa{2} = '[1 0 0; 0, 1, 0; mu3 0 0]';
kappa{3} = '[1 0 0; 0, 1, 0; 0 0 0]';
rhoc= '[1,1,mu2]'; % wish to treat unsteady case with 1 \le mu2 \le 5 --
muref = [0.5,2.5,5.0];
mu_min = [0.4,1.0,1.0];
mu_max = [0.6,5.0,10.0];
mu_bar = [0.5,2.5,5.0];
%dirichlet = '[12,1;14,0;15,0;16,0;17,0;18,0]';
dirichlet = '[12,1]';

outputname = 'exittemp'
oareaload = '[2,1]';

% uncomment for unsteady case
initsol = '[0]'; % Zero initial data
theta_u = '[1]';
nt = 20;         % Number of timesteps  
dt = 0.1;         % Timestep size


%%%%%%%%%%%% no user input required beyond this point
if ~exist('plotdemo')
    plotdemo = 0;
end

save rbU ;
addpath('../rbMIT_Aux')
copyfile('../rbMIT_Aux/Step1_coer_noncompliant.m',...
    strcat(probname,'_','Step1_coer_noncompliant.m'))
eval(strcat(probname,'_','Step1_coer_noncompliant'))
%%%%%%%%%% End of the offline execution. 

% Now the user can perform the online stage to rapidly simulate the problem 
% for different parameter values. See the software documentation for details. 

 