clear all;

% License material
%
% -----rbMIT  Software Copyright MIT 2006-07-----
% -----------DBP Huynh, NC Nguyen, AT Patera, G Rozza-------
% 
% The user agrees to rbMIT  MIT usage, distribution, and citation terms and conditions 
% described in the License at http://augustine.mit.edu/rbMIT_SystemLicense.htm.
% rbMIT Software Part_II_and_IV
%

% This example illustrates heat conduction through a heat shield (a complex 
% parameter-dependent domain).

probname = 'tdepheatshield'
plotdemo=0;
femOPT.maxsize = 500;
femOPT.refine = 'subdivision';

points = '[0,0;mu1,0;mu1,4;0,4+mu2;0,4;mu3,4;mu3,3;0,3;0,2;mu3,2;mu3,1;0,1]';
edge = [1,2;2,3;3,4;4,5;5,6;6,7;7,8;8,9;9,10;10,11;11,12;12,1;6,3];
geometry{1} = [3,4,5,13]; 
% The top area
geometry{2} = [1,2,13,6,7,8,9,10,11,12]; 
% Heat shield
gflag = [1,1]; 
kappa{1} = '[1 0 0; 0 1 0; 0 0 0]';
kappa{2} = '[1 0 0; 0 1 0; 0 0 0]';
muref = [2,1.5,1];
mu_min = [1.75,1.25,0.75];
mu_max = [2.25,1.75,1.25];
mu_bar = [2,1.5,1];
dirichlet = '[1,0]'; 
% Dirichlet at the bottom
nload = '[3, 0, 0, 1]';
% Heat flux is added in at the top surface 
curvedat = '[0, 4, mu1, mu2, 0, cos(t), sin(t)]';
tarclist = '[3,1,0,pi/2]';

outputname = 'heatarea'
oareaload = '[1, 1]';
% Output is the integral of the temperature over the top area

initsol='[0]';
theta_u='[1]';
% The temperature is 0 degrees at the time we start applying heat.

nt=60;   % number of timesteps
dt=0.05; % timestep size
% Finally, to complete the problem formulation, we specify that the starting time is 0 
% and that we want to study the heat distribution during the first 3 seconds.

%%%%%%%%%%%% no user input required beyond this point
if ~exist('plotdemo')
    plotdemo = 0;
end

save rbU ;
addpath('../rbMIT_Aux')
copyfile('../rbMIT_Aux/Step1_coer_noncompliant.m',strcat(probname,'_','Step1_coer_noncompliant.m'))
eval(strcat(probname,'_','Step1_coer_noncompliant'))
%%%%%%%%%% End of the offline execution. 

% Now the user can perform the online stage to rapidly simulate the problem 
% for different parameter values. See the software documentation for details. 



