clear all;

% License material
%
% -----rbMIT  Software Copyright MIT 2006-07-----
% -----------DBP Huynh, NC Nguyen, AT Patera, G Rozza-------
% 
% The user agrees to rbMIT  MIT usage, distribution, and citation terms and conditions 
% described in the License at http://augustine.mit.edu/rbMIT_SystemLicense.htm.
% rbMIT Software Part_II_and_IV
%

% This example illustrates axis-symmetric case which reduces a 3D problem in a sphere to 
% a 2D problem in a plane. There is a steady-state solution in some limit.

probname = 'tdepmultiplates'
plotdemo = 0;
femOPT.refine = 'subdivision';
femOPT.maxsize = 500;

points = '[0,0;1,0;1,0.1;0,0.1;0,0.2;1,0.2;1,0.3;0,0.3]';
edge = [1,2;2,3;3,4;4,1;3,6;6,5;5,4;6,7;7,8;8,5];
geometry{1} = [1,2,3,4];
geometry{2} = [3,5,6,7];
geometry{3} = [6,8,9,10];
gflag = [1,1,1];
kappa{1} = '[1 0 0; 0, 1, 0; 0 0 0]';
kappa{2} = '[1 0 0; 0, 1, 0; 0 0 0]';
kappa{3} = '[1 0 0; 0, 1, 0; 0 0 0]';
rhoc='[mu1,mu2,mu3]'; 
% rhoc = mu1 on geometry{1}, 
% rhoc = mu2 on geometry{2},
% rhoc = mu3 on geometry{3},
muref = [1,1,1];
mu_min = [0.1,0.1,0.1];
mu_max = [10,10,10];
mu_bar = [1,1,1];
dirichlet = '[2,0;5,0;8,0]';
nload = '[4,0,0,1;7,0,0,1;10,0,0,1]';

outputname = 'integ'
oareaload = '[1,1;2,1;3,1]';

initsol = '[0]'; % Zero initial data
theta_u = '[1]';
nt = 50;         % Number of timesteps  
dt = .1;         % Timestep size


%%%%%%%%%%%% no user input required beyond this point
if ~exist('plotdemo')
    plotdemo = 0;
end

save rbU ;
addpath('../rbMIT_Aux')
copyfile('../rbMIT_Aux/Step1_coer_noncompliant.m',...
    strcat(probname,'_','Step1_coer_noncompliant.m'))
eval(strcat(probname,'_','Step1_coer_noncompliant'))
%%%%%%%%%% End of the offline execution. 

% Now the user can perform the online stage to rapidly simulate the problem 
% for different parameter values. See the software documentation for details. 

 