clear all;
% License material
%
% -----rbMIT  Software Copyright MIT 2006-07-----
% -----------DBP Huynh, NC Nguyen, AT Patera, G Rozza-------
% 
% The user agrees to rbMIT  MIT usage, distribution, and citation terms and conditions 
% described in the License at http://augustine.mit.edu/rbMIT_SystemLicense.htm.
% rbMIT Software Part_II_and_IV
%


% "Reactor" problem illustrates Robin conditions and parameter-dependent initial data.

probname = 'tdepreactor'
plotdemo = 0;
% femOPT.refine = 'subdivision';
% femOPT.codes = 'HB';
% femOPT.maxsize = 800;
% femOPT.lref = [4,5,6,7;4,4,4,4]'; % refine along the "core" to level "4"

points = '[0,0;1.5,0;0,1.5;0.5+0.2,0.5;0.5,0.5+0.2;0.5-0.2,0.5;0.5,0.5-0.2]';
edge = [1,2;2,3;3,1;4,5;5,6;6,7;7,4];
geometry{1} = [1,2,3];
geometry{2} = [4,5,6,7];
gflag = [1,0];
kappa{1} = '[1 0 0; 0 1 0; 0 0 0]';
kappa{2} = '[1 0 0; 0 1 0; 0 0 0]';
muref=[1,1];
mu_min=[0.1,0.5];
mu_max=[10,2];
mu_bar=[1,1];
nload = '[2,mu1,0,0;4,0,0,1; 5,0,0,1; 6,0,0,1; 7,0,0,1]';
% mu1 is the Bi number
curvedat = '[0,0,1.5,1.5,0,cos(t),sin(t);0.5,0.5,0.2,0.2,0,cos(t),sin(t)]';
tarclist = '[2,1,0,pi/2;4,2,0,pi/2;5,2,pi/2,pi;6,2,pi,3*pi/2;7,2,3*pi/2,2*pi]';

outputname = 'area';
oareaload = '[1,1]';

% Parameter-dependent initial data
initsol='[1.5-x1.^2-x2.^2]';
theta_u='[mu2]';

nt=50;   % number of timesteps
dt=0.02; % timestep size

%%%%%%%%%%%% no user input required beyond this point
if ~exist('plotdemo')
    plotdemo = 0;
end

save rbU ;
addpath('../rbMIT_Aux')
copyfile('../rbMIT_Aux/Step1_coer_noncompliant.m',...
    strcat(probname,'_','Step1_coer_noncompliant.m'))
eval(strcat(probname,'_','Step1_coer_noncompliant'))
return;
%%%%%%%%%% End of the offline execution. 

% Now the user can perform the online stage to rapidly simulate the problem 
% for different parameter values. See the software documentation for details. 
