clear all;
% License material
%
% -----rbMIT  Software Copyright MIT 2006-07-----
% -----------DBP Huynh, NC Nguyen, AT Patera, G Rozza-------
% 
% The user agrees to rbMIT  MIT usage, distribution, and citation terms and conditions 
% described in the License at http://augustine.mit.edu/rbMIT_SystemLicense.htm.
% rbMIT Software Part_II_and_IV
%


% This example illustrates axis-symmetric case which reduces a 3D problem in a sphere to 
% a 2D problem in a plane. There is a steady-state solution in some limit.

probname = 'tdepsphere'
plotdemo = 0;
probtype = 'TH2'; % axis-symmetric flag
femOPT.codes = 'HB';
femOPT.maxsize = 1000;

points = '[1,0;3,0;3,3;0,3;0,1;mu2,0;mu2,mu2;0,mu2]';
% mu2 is the size of the truncated domain
edge = [1,2;2,3;3,4;4,5;1,5;2,6;6,7;7,8;8,4];
geometry{1} = [1,6,7,8,9,4,5];
geometry{2} = [1,2,3,4,5];
gflag = [1,1];
kappa{1} = '[1 0 0; 0, 1, 0; 0 0 mu1]';
kappa{2} = '[1 0 0; 0, 1, 0; 0 0 mu1]';
muref = [1,6];
mu_min = [1/2,4];
mu_max = [4,8];
mu_bar = [1,6];
dirichlet = '[5,1;7,0;8,0]';
curvedat = '[0,0,1,1,0,cos(pi*t),sin(pi*t)]';
tarclist = '[5,1,0,1/2]';

outputname = 'integ'
oareaload = '[1,1;2,1]';

%analytical expression for steady-state output is (1/mu1 + 1/sqrt(mu1))
%note the above only true in limit mu2 tends to infinity, however for mu1
%larger even small mu2 are effectively infinite

initsol = '[0]'; % Zero initial data
theta_u = '[1]';
nt = 50;         % Number of timesteps  
dt = .1;         % Timestep size


%%%%%%%%%%%% no user input required beyond this point
if ~exist('plotdemo')
    plotdemo = 0;
end

save rbU ;
addpath('../rbMIT_Aux')
copyfile('../rbMIT_Aux/Step1_coer_noncompliant.m',...
    strcat(probname,'_','Step1_coer_noncompliant.m'))
eval(strcat(probname,'_','Step1_coer_noncompliant'))
%%%%%%%%%% End of the offline execution. 

% Now the user can perform the online stage to rapidly simulate the problem 
% for different parameter values. See the software documentation for details. 

 