clear all;

% License material
%
% -----rbMIT  Software Copyright MIT 2006-07-----
% -----------DBP Huynh, NC Nguyen, AT Patera, G Rozza-------
% 
% The user agrees to rbMIT ? MIT usage, distribution, and citation terms and conditions 
% described in the License at http://augustine.mit.edu/rbMIT_SystemLicense.htm.
% rbMIT Software Part_II_and_IV
%

% This is a time-dependent convection-diffusion problem which has the velocity
% depending on the spatial coordinates

probname = 'tdepstagnation'
plotdemo = 0;
femOPT.refine = 'subdivision';
femOPT.maxsize = 500;

points = '[0,0;1,0;1,1;0,1]';
edge = [1,2;2,3;3,4;4,1];
geometry{1} = [1,2,3,4];
gflag = [1];
kappa{1} = '[mu1, 0, 0; 0, mu1, 0; x, -y, 0]';
% mu1 is the conductivity
muref = [1];
mu_min = [0.1];
mu_max = [10.0];
mu_bar = [1];
dirichlet = '[1,0;3,1]';

outputname = 'intsol'
oareaload = '[1,1]';
% The output is the integral of the field over the domain.
% Note in the limit that mu1 tends to zero, the field approaches
% u(x_1,x_2,mu1) = erf(x_2/(2 sqrt(mu1)) as t tends to infinity, and hence
% s(mu1) tends to \int_0^1 erf(x_2/(2 sqrt(mu1)) dx_2 in the same limits.

initsol = '[x2]'; % Initial data
theta_u = '[1]';  % 
nt = 50;          % Number of timesteps
dt = .1;          % Timestep size


%%%%%%%%%%%% no user input required beyond this point
if ~exist('plotdemo')
    plotdemo = 0;
end

save rbU ;
addpath('../rbMIT_Aux')
copyfile('../rbMIT_Aux/Step1_coer_noncompliant.m',...
    strcat(probname,'_','Step1_coer_noncompliant.m'))
eval(strcat(probname,'_','Step1_coer_noncompliant'))
%%%%%%%%%% End of the offline execution. 

% Now the user can perform the online stage to rapidly simulate the problem 
% for different parameter values. See the software documentation for details. 

